2024-11-10  Darshit Shah  <darnir@gnu.org>

	version 1.25.0
	* NEWS: Record release date.

2024-11-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	* NEWS: Update for release 1.25.0

2024-11-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix CVE-2024-10524 (drop support for shorthand URLs)
	* doc/wget.texi: Add documentation for removed support for shorthand URLs.
	* src/html-url.c (src/html-url.c): Call maybe_prepend_scheme.
	* src/main.c (main): Likewise.
	* src/retr.c (getproxy): Likewise.
	* src/url.c: Rename definition of rewrite_shorthand_url to maybe_prepend_scheme,
	  add new function is_valid_port.
	* src/url.h: Rename declaration of rewrite_shorthand_url to maybe_prepend_scheme.

	Reported-by: Goni Golan <gonig@jfrog.com>

2024-11-10  Darshit Shah  <darnir@gnu.org>

	* contrib/make-release: Fix missing variables

	* doc/wget.texi: Document the new non-blocking read feature

	Revert "* configure.ac: Remove searching for makeinfo (breaks doc/ build)"
	This reverts commit 04053a7c1e31ec848d503282d510c99545b6ae16.

2024-11-10  Darshit Shah  <darnir@gnu.org>

	Fix a static analysis false positive
	Clang's static analyzer believes that it is possible for a realloc
	request to return NULL. However, the `xrealloc` implementation used
	in Wget will trigger a program crash if enough memory couldn't be
	found. I'm not sure why the analyzer isn't able to see that. But let's
	pacify it by asserting here that xrealloc will always return a non-null

	 * src/wget.h (DO_REALLOC): Assert that xrealloc will always return
	   non-null

2024-11-10  Darshit Shah  <darnir@gnu.org>

	Fix returning uninitialized variable
	* src/retr.c (retrieve_from_file): Remove a dead store to status
	  (retrieve_from_url_list): Initialize status to a default of RETROK

2024-11-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	* fuzz/wget_options_fuzzer.c: Work around issue "multiple definition of getaddrinfo"

2024-11-10  Darshit Shah  <darnir@gnu.org>

	Fix build error on MingW
	Gnulib does not currently implement the `F_GETFL` and `F_SETFL` flags on
	mingw. As a result building Wget failed on Windows. We don't currently
	have a good solution to this problem and Windows users of Wget will not
	get the new functionality of non-blocking file I/O reads. The current
	solution is simply to provide a Windows specific no-op stub

	 * src/mswindows.c (set_fd_nonblocking): Provide an empty stub function
	   for Windows systems
	 * src/mswindows.h (set_fd_nonblocking): Export the function so it is
	   available in util.c where it is needed
	 * src/util.c (set_fd_nonblocking): New function to set a fd as
	   O_NONBLOCK on non-Windows, non-MSDOS systems
	   (wget_read_from_file): Split the O_NONBLOCK code into
	   set_fd_nonblocking and make all file I/O non-blocking, not just stdin

2024-11-10  Sam James  <sam@gentoo.org>  (tiny change)

	init: fix -Warray-bounds in setval_internal_tilde
	>= GCC 12 reports an instance of -Warray-bounds in setval_internal_tilde
	with the default -DNDEBUG:
	```
	In function ‘setval_internal_tilde’,
	    inlined from ‘run_wgetrc’ at init.c:710:16:
	init.c:940:17: error: array subscript [0, 167] is outside array bounds of ‘const struct <anonymous>[168]’ [-Werror=array-bounds=]
	  940 |   if (((commands[comind].action == cmd_file) ||
	      |         ~~~~~~~~^~~~~~~~
	init.c: In function ‘run_wgetrc’:
	init.c:135:3: note: while referencing ‘commands’
	  135 | } commands[] = {
	      |   ^~~~~~~~
	```

	setval_internal_tilde calls setval_internal and stores the result in ret;
	setval_internal *does* check for if comind is out-of-bounds, but we only
	check that *after* dereferencing commands[comind]. Swap the order in the
	if() to fix that so we only dereference if we know it's safe.

	ChangeLog:

		* src/init.c (setval_internal_tilde): Check 'ret' earlier.

2024-11-10  Darshit Shah  <darnir@gnu.org>

	src/utils.h: Include wget.h before stdlib.h
	* src/utils.h: wget.h includes config.h which should be included before
	    any other header files. So swap the order of includes

2024-11-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	* README: Replace FSF address with URL

	* configure.ac: Remove searching for makeinfo (breaks doc/ build)

	* bootstrap: Update from gnulib

	* gnulib: Update

	* src/http.c (http_loop): Remove unused code

	* configure.ac: Drop -Wc99-c11-compat and -Wuseless-cast for manywarnings

2024-11-01  Tim Rühsen  <tim.ruehsen@gmx.de>

	* Makefile.am: Fix check-coverage from tarball

	* Makefile.am: Fix creating coverage reports

	* .gitlab-ci.yml: Remove tags to fix CI

2024-10-31  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/utils.c (compile_posix_regex): Remove redundant casts

2024-10-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/utils.h (strlcpy): Use restrict keywords

	* src/hash.c: Include config.h in STANDALONE mode

2024-06-09  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http.c (http_loop): Fix memory leak

	* src/retr.c (retrieve_from_url_list): Fix memory leak

2024-06-02  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/retr.c (retrieve_from_file): Fix memleak

	* src/warc.c (warc_close): Fix memleak

	* src/warc.c (warc_start_new_file): Simplify code

	* src/httpc.c (http_loop): Fix memleak

	* src/init.c (cleanup): Do not close stdout on exit

	* src/iri.c (do_conversion): Initialize memory from realloc()

	* src/warc.c (warc_write_end_record): Check warc_write_ok (fix use-after-free)"

	* src/wget.h (DO_REALLOC): Initialize realloc'ed memory to help valgrind

	* src/utils.c (run_with_timeout): Set SIGALRM handler before setjmp() (reported by valgrind)

	* fuzz/wget_options_fuzzer.c: Fix indentation

2024-06-02  Tim Rühsen  <tim.ruehsen@gmx.de>

	Properly re-implement userinfo parsing (rfc2396)
	* src/url.c (url_skip_credentials): Properly re-implement userinfo parsing (rfc2396)

	The reason why the implementation is based on RFC 2396, an outdated standard,
	is that the whole file is based on that RFC, and mixing standard here might be
	dangerous.

2024-05-24  Tim Rühsen  <tim.ruehsen@gmx.de>

	* fuzz/Makefile.am (oss-fuzz): Add -lgmp

2024-05-12  Darshit Shah  <darnir@gnu.org>

	Support continious reading from stdin pipes
	Rather than reading from stdin only once, leave the pipe open until the
	other end closes it and keep reading from the file after each set of
	URLs is read

	* src/html-url.h(get_urls_file): Update prototype to add additional
	  param
	* src/html-url.c(get_urls_file): Pass through read_again to
	  wget_read_from_file.
	* src/retr.c(retrieve_from_file): Split the function into two. Introduce
	  `retrieve_from_url_list` that actually performs the retrieval.
	  Also, if `url_list` returns that the fd has been left open, then
	  continue reading from it until the fd is closed.
	  (retrieve_from_url_list): New function that does the retrieval from
	  a list of URLs that was read from a file.
	* src/utils.c(wget_read_from_file): Rename old function `wget_read_file`
	  to this.
	  Accept an additional output parameter that states whether the fd was
	  left open and if we should continue reading from it after the current
	  set of URLs have been processed
	  (wget_read_file): Write it as a new wrapper function around
	  `wget_read_from_file` to maintain API comptability across other users

2024-04-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	* gnulib: Update

2024-04-20  Tim Rühsen  <tim.ruehsen@gmx.de>

	Update gnulib link libraries
	* fuzz/Makefile.am: Update gnulib link libraries.
	* src/Makefile.am: Likewise.
	* tests/Makefile.am: Likewise.

2024-04-16  Sam James  <sam@gentoo.org>  (tiny change)

	Fix libproxy build with --disable-debug
	The definition of debug_logprintf in src/log.c is guarded by ENABLE_DEBUG
	(although its prototype is unconditionally available in src/log.h).

	The uses of debug_logprintf in src/retr.c aren't guarded by ENABLE_DEBUG.

	Use the DEBUGP macro which is designed for this purpose.

	* src/retr.c (getproxy): Use DEBUGP macro.

	Fixes: https://gitlab.com/gnuwget/wget/-/issues/19

2024-03-16  Darshit Shah  <darnir@gnu.org>

	Add a new testcase for pathconf truncation
	* testenv/Test-recursive-pathmax.py: Add a new testcase. This test tries
	  to check that Wget allows downloading long filenames as far as allowed
	  by the OS and filesystem.

2024-03-11  Darshit Shah  <darnir@gnu.org>

	* contrib/make-release: Automatically build and update online documentation

2024-03-10  Darshit Shah  <darnir@gnu.org>

	* contrib/make-release: More minor fixes

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 1.24.5
	* NEWS: Record release date.

	* contrib/make-release: Some more release management

	* NEWS: Update the noteworthy NEWS

	* bootstrap.conf: Organize alphabetically

	* gnulib: Update to the latest version

2024-03-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	Remove obsolete Travis CI files
	* .travis.yml: Remove.
	* contrib/travis-ci: Remove.

2024-02-24  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix HSTS matching
	* src/hsts.c (hsts_find_entry): Check for includeSubdomains,
	  (test_hsts_new_entry): Fix test,
	  (test_hsts_url_rewrite_superdomain): Improve test.

	Reported-by: Hanno Böck <hanno@hboeck.de

2024-02-19  Darshit Shah  <darnir@gnu.org>

	Delete some redundant tests
	* tests/Makefile.am: Remove some tests that are redundant with the
	  Python testenv
	* tests/Test-auth-basic.px: Delete file
	* tests/Test-auth-no-challenge.px: Same
	* tests/Test-auth-no-challenge-url.px: Same
	* tests/Test-auth-retcode.px: Same
	* tests/Test-auth-with-content-disposition.px: Same
	* tests/Test-k.px: Same

	* Makefile.am: Ignore some lcov errors, allowing the tests to run through

	* README: Add a link to the COPYING file to meet the GNU Coding Standards

	* bootstrap: Update script from gnulib

	* gnulib: Update gnulib

	* Update copyright year to 2024

2024-02-19  Darshit Shah  <git@darnir.net>

	Add tests for --convert-links option
	* testenv/Makefile.am: Add two new tests, Test-k.py and Test-https-k.py
	* testenv/Test-k.py: New file. Add a test based on tests/Test-k.px
	* testenv/Test-https-k.py: New file. Add a new test to ensure that the
	  protocol of the original host URL is retained when creatign absolute
	  links.

	This test is added as a result of an issue reported on StackExchange:
	https://superuser.com/questions/1348940/making-wgets-convert-links-respect-http-vs-https

2024-02-19  Darshit Shah  <git@darnir.net>

	* testenv/conf/expected_files.py: Aesthetic changes only. Format file with black

	* testenv/conf/expected_files.py: Nicer diff printing on error

2024-02-18  Darshit Shah  <darnir@gnu.org>

	* SECURITY.md: Add a file stating how to report security issues

2024-01-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	Parse 'srcset' HTML attr for 'source' HTML tag.
	* src/html-url.c (struct known_tag): Use tag_handle_img() for 'source' tag.
	* testenv/Test-recursive-include.py: Extend test.

2023-11-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/netrc.c (parse_netrc_fp): Add fetchmail compatibility (user and passwd)
	Reported-by: Gerald Pfeifer <gerald@pfeifer.com>

2023-10-22  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix confusing 'Cannot write to ... (Success)' message
	* src/http.c (gethttp): Store/restore errno value.

	Reported-by: Christian Rosentreter, Andries E. Brouwer

2023-10-20  Jan-Michael Brummer  <jan-michael.brummer1@volkswagen.de>  (tiny change)

	Add libproxy support
	Add support for libproxy, which is capable to extract desktop
	environment proxy configurations from dozens of systems and platforms.
	This also enables wget to handle pac/wpad proxy server.

	* configure.ac: Add check for libbproxy.
	* src/retr.c (getproxy): Retrieve proxy via libproxy.

2023-08-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/retr.c: Fix sc_prohibit_empty_lines_at_EOF

2023-08-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix crash when printing download rate
	If the download rate is TB/s, a read buffer overflow happended
	that either caused a crash or printed whatever string was pointed to.

	* src/retr.c (retr_rate): Add missing array entrie for TB/s and Tb/s,
	  (test_retr_rate): New test function.
	* tests/unit-tests.c (all_tests): Run test 'test_retr_rate'.
	* tests/unit-tests.h: Add prototype for test_retr_rate.

	Reported-by: Wiebe Cazemier <wiebe@halfgaar.net>

2023-08-03  Christian Weisgerber  <naddy@mips.inka.de>  (tiny change)

	* tests/Makefile.am: Remove './' from  for portability (OpenBSD)

2023-07-16  Yaakov Selkowitz  <yselkowi@redhat.com>  (tiny change)

	testenv: fix for Python 3.12
	* testenv/server/http/http_server.py (HTTPSServer): Update for
	  ssl.SSLContext APIs instead of deprecated ssl.wrap_socket().

	ssl.wrap_socket() was deprecated in 3.7 and removed in 3.12.
	This should be compatible back to 3.6 (RHEL 8 and newer).

2023-07-01  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/url.c (test_uri_merge): Fix check

	Add new unit test test_uri_merge()
	* src/url.c: New test function test_uri_merge().
	* tests/unit-tests.c (tests/unit-tests.c): Call test_uri_merge().
	* tests/unit-tests.h (tests/unit-tests.h): Declare test_uri_merge().

2023-05-16  Darshit Shah  <darnir@gnu.org>

	Ensure that spaces are quoted when converting links
	* src/convert.c(convert_links): Print the actual quoted newname when printing DEBUG output
	  (local_quote_string): Also quote the ' ' charcter as %20. While it is okay
	  to leave the characted as-is, quoting it covers more edge cases.
	  And it should resolve a >10 year old bug with CSS url() parameters not being quoted

	Bug-Id: 64082
	Reported-By: Ethan Gibbs <ethan@snowsign.net>
	Discussed-At: https://stackoverflow.com/q/13300017

2023-05-16  Darshit Shah  <darnir@gnu.org>

	Add new test to ensure CSS url() encoding
	url() parameters in CSS cannot have spaces in them. Ensure that Wget does not do that
	when using --convert-links

	* testenv/test_css_url.py: New file
	* testenv/Makefile: Add test_css_url.py to tests

	Bug-Id: 64082

2023-05-14  Darshit Shah  <darnir@gnu.org>

	Automatically verify if commit author has assigned copyrights in the past
	* contrib/commit-check: Add new script
	* .gitlab-ci.yml: Add new test in the CI pipeline

2023-05-14  Jan Palus  <jpalus@fastmail.com>  (tiny change)

	* testenv/conf/expected_files.py: Ignore common.conf

2023-05-14  Darshit Shah  <darnir@gnu.org>

	* AUTHORS: Rework file to prepare for autmated testing

2023-05-11  Darshit Shah  <darnir@gnu.org>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	contrib/make-release: Update regexes to match the NEWS file

2023-05-11  Darshit Shah  <git@darnir.net>

	cfg.mk: Replace uses of filesystem with file system

	Update NEWS

2023-05-10  Darshit Shah  <git@darnir.net>

	bootstrap.sh: Update script from gnulib

	gnulib: Pull forward

2023-04-09  jinfuchiang  <jinfuchiang@outlook.com>  (tiny change)

	Update deprecated option '--html-extension' to '--adjust-extension'
	* doc/wget.texi: Update option '--html-extension' to '--adjust-extension'.
	  Renamed in Wget 1.12 to better reflect its behavior.

2023-03-19  Tim Rühsen  <tim.ruehsen@gmx.de>

	Don't write core dump if --secure-option value isn't suppported.

2023-02-18  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/retr.c (fd_read_body): Increase bufsize from 8k to 64k

	* src/retr.c (fd_read_body): Simplify gzip initialization

	* src/retr.c (fd_read_body): Use MAX instead of max

	Simplify url_error function.
	* src/url.c (url_error): simplify, remove url arg, return const char *.
	* src/url.h (url_error): remove url arg, return const char *.
	* src/html-url.c (get_urls_file): Simplify call to url_error(),
	  remove call to free().
	* src/http.c (metalink_from_http): Likewise.
	* src/main.c (main): Likewise.
	* src/metalink.c (retrieve_from_metalink, fetch_metalink_file): Likewise.
	* src/recur.c (retrieve_tree): Likewise.
	* src/res.c (res_retrieve_file): Likewise.
	* src/retr.c (retrieve_url, retrieve_from_file): Likewise.

	* src/url.c: Refactored url_error()

	* tests/valgrind-suppressions: Add rule for 'strcmp-sse2.S in libdl.so'

2023-02-17  Tim Rühsen  <tim.ruehsen@gmx.de>

	* configure.ac: Remove CC flags -Wc90-c99-compat and -Wlong-long

	* fuzz/*: Use grep >/dev/null instead of grep -q

	* src/retr.c: Don't include hash.h

	Update copyright years

	* gnulib: Update

2022-12-11  Tim Rühsen  <tim.ruehsen@gmx.de>

	* configure.ac: Disable nettle if NTLM is explicitly disabled

2022-12-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	* configure.ac: Allow disabling NTLM if nettle present (Savannah #63431)

2022-09-24  Tim Rühsen  <tim.ruehsen@gmx.de>

	* fuzz/Makefile.am: Add -lz to fuzzer libs

2022-03-20  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/main.c (print_help): Add --retry-on-host-error to help text

	Fix HSTS portability by using int64_t instead of time_t.
	* src/hsts.c: Use int64_t instead of time_t.
	* src/http.c: Use int64_t for parsing Strict-Transport-Security.

	src/http.c (time_to_rfc1123): Fix -Wformat-nonliteral

	* src/warc.c (warc_process_cdx_line): Fix variable type to idx_t

	* src/main.c (secs_to_human_time): Use snprintf instead of sprintf

	* src/main.c (main): Remove unused variable

	* src/netrc.c (test_parse_netrc): Check if HAVE_FMEMOPEN is defined

2022-02-26  Darshit Shah  <darnir@gnu.org>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	* NEWS: Update NEWS items for release

	* .gitignore: Remove empty line at EOF

	* .gitignore: Update file

	* src.hsts.c(hsts_read_database): Use SCNd64 for portable format flags

	* configure.ac: Add some warning flags to ignore

	* cfg.mk: Remove passing syntax-checks from skip list

	Fix issues from syntax-check
	* doc/wget.texi: s/time stamp/timestamp/
	* src/ftp-ls.c(clean_line): Same
	  (ftp_parse_vms_ls): Don't cast return value of x*alloc
	* src/ftp.c: Don't cast return value of alloca
	* src/css-url.c: wget.h should be the first include
	* testenv/Makefile.am: Use $(PATH_SEPARATOR) instead of : when declaring
	  a path
	* testenv/Test-no_proxy-env.py: s/can not/cannot/

	* Update Copyright years

	* bootstrap: Update script

	* gnulib: Pull forward

	Cleanup some incorrect uses of AM Conditionals
	    * configure.ac: Replace IRI_IS_ENABLED with WITH_IRI and
	      METALINK_IS_ENABLED with WITH_METALINK
	    * src/Makefile.am: Add the .c and .h files for IRI, Metalink and
	      Xattr support to wget_SOURCES directly when needed instead of
	      adding them as object files.
	    * testenv/Makefile.am: Rename METALINK_IS_ENABLED to WITH_METALINK

2022-02-26  Darshit Shah  <darnir@gnu.org>

	Replace incorrect usage of AC_LIBOBJ in configure.ac
	AC_LIBOBJ is to be used for providing replacement functions for
	compatibility reasons. Not for conditional compilation of entire source
	files. Autotools provides other methods for achieving that. However, our
	build system has (ab-)used the AC_LIBOBJ macros for doing this for over
	15 years. That stops today.

	    * configure.ac: Replace uses of AC_LIBOBJ with automake conditionals
	      that can be used in Makefiles
	    * src/Makefile.am: Use the defined conditionals to select which
	      files get built.

2022-02-25  Darshit Shah  <darnir@gnu.org>

	Fix case where installed gettext is newer than minimum version
	* configure.ac: Use AM_GNU_GETTEXT_REQUIRE_VERSION to specify a minimum
	  version of gettext needed. This should allow newer versions of gettext
	  to be copied for autipoint to use when available.

	This commit hopefully fixes the annoying issue when building from
	source on a system that has a newer version of gettext.

2022-02-13  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/netrc.c (test_parse_netrc): Free netrc structure

	* .gitlab-ci.yml: Fix path to llvm-symbolizer

	* src/netrc.c (test_parse_netrc): New unit test function

2022-01-31  Aarni Koskela  <akx@iki.fi>  (tiny change)

	* src/http.c (parse_strict_transport_security): Fix typo in string

2022-01-23  Tim Rühsen  <tim.ruehsen@gmx.de>

	* .gitlab-ci.yml (Scan-Build): Allow failure due to two false positives

	* configure.ac: Use pkg-config for gpgme, libidn2 and nettle

2022-01-22  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/ftp.c: Small cleanups

2022-01-16  Nik Soggia  <wget@niksoggia.it>  (tiny change)

	Print newline after dot progress bar in non-verbose mode
	* src/progress.c (dot_finish): Print new in all progress bar contexts
	  instead of just verbose

2022-01-12  Tim Rühsen  <tim.ruehsen@gmx.de>

	* .gitlab-ci.yml: Fix artifact path for the Scan-Build runner

2022-01-09  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/main.c (main): Unlink output document when --unlink is given

2021-12-22  Tim Rühsen  <tim.ruehsen@gmx.de>

	fuzz/*.in: Update fuzzer corpora

	* .gitlab-ci.yml (CoverageReports): Fix artifacts paths

	* tests/valgrind-suppressions: Fix libidn rule

	* .gitlab-ci.yml: Fix artifacts paths

	* tests/valgrind-suppressions: Extend libidn rule

	* src/log.c (logprintf): Check earlier for verbosity

	* src/http.c (http_loop): Fix memleak

2021-12-21  Tim Rühsen  <tim.ruehsen@gmx.de>

	Switch fuzzing build from C++ to C
	* Makefile.am (oss-fuzz): Build with $CC instead of $CXX.
	* README.md: Remove CXX and CXXFLAGS exports.

2021-12-01  Darshit Shah  <darnir@gnu.org>

	* src/http.c (http_loop): Hide password when printing status with -nv
	Reported-By: Per Lundberg <perlun@gmail.com>
	Closes: #61492

	* gnulib: Pull forward

	* src/hsts.c (hsts_read_database): Read time_t values as long long

2021-12-01  Thomas Niederberger  <thomas@niederb.ch>

	* src/main.c (print_help): Add command line option for TLS 1.3

2021-10-11  Darshit Shah  <darnir@gnu.org>

	* retr.c (rotate_backups): Non existent files are not errors in this function

2021-10-08  Darshit Shah  <darnir@gnu.org>

	* ftp.c (ftp_loop_internal): Fix computation of total_downloaded_bytes
	When continuing a FTP download, or not starting one because the file is
	already fully retrieved, don't include the size of the file in the
	total_downloaded_bytes. Only the actual amount of data retrieved over
	the network should be considered there.

	Fixes: #61277
	Reported-By: Michal Ruprich <formaiko>

2021-09-08  Darshit Shah  <darnir@gnu.org>

	Remove suprious print statements
	* src/gnutls.c: Remove fprintf statements. We should never print to
	  console directly. Always honor the log levels.
	  Fixes: #61125

2021-09-07  Darshit Shah  <darnir@gnu.org>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	* NEWS: Update NEWS items for release

	* cfg.mk: Disable the indent check

	* gnulib: Pull forward

2021-08-21  WB  <3572564-wadersgeek@users.noreply.gitlab.com>

	Fix #60956 (improve --page-requisites)
	* src/html_url.c (tag_handle_link): Check for "alternate stylesheet",
	  "icon" and "manifest".

2021-08-07  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/html-url.c (tag_handle_meta): Fix integer overflow

2021-07-05  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/recur.c (download_child): Remove temporary robots.txt.tmp

2021-06-14  Josef Moellers  <jmoellers@suse.de>

	Long pathnames patch

2021-06-07  Tim Rühsen  <tim.ruehsen@gmx.de>

	* .gitlab-ci.yml: Remove scan-build deps from pages stage

	* .gitlab-ci.yml: Move scan-build/ to public/ only if it exists

2021-06-06  Tim Rühsen  <tim.ruehsen@gmx.de>

	* .gitlab-ci.yml: Move scan-build results to parent directory

	* .gitlab-ci.yml: Move coverage results to parent directory

	* .gitlab-ci.yml: Don't allow failure of scan-build

	* .gitlab-ci.yml: Pages needs Build-Tarball

	* src/url.c (append_uri_pathel): Add cheap extra check to help static analyzers

	* src/http.c (gethttp): Add cheap extra check to help static analyzers

	* .gitlab-ci.yml: Exclude src/css_.o from scan-build

	* src/main.c (main): Removed unused variable

2021-06-06  Tim Rühsen  <tim.ruehsen@gmx.de>

	Revert "Long pathnames patch"
	This reverts commit affad27664afccdedafd94711d350f368e859be4.

	Manual tests with very long path names did not work with this patch.
	We have to wait for a patch including automated tests.

2021-06-06  Tim Rühsen  <tim.ruehsen@gmx.de>

	* .lgtm.yml: Add autoconf-archive

	* .gitlab-ci.yml: Re-arrange stages

	Remove .git/, .gitmodules and gnulib/ from bootstrap artefacts

2021-06-06  Darshit Shah  <darnir@gnu.org>

	Updated Gitlab CI Pipeline
	* .gitlab-ci.yml: COmpletely overhauled CI pipeline with dependencies
	  for a faster and more robust CI.

2021-05-29  jmoellers  <josef.moellers@suse.com>

	Long pathnames patch

2021-05-22  Tim Rühsen  <tim.ruehsen@gmx.de>

	* fuzz/wget_read_hunk_fuzzer.c: Add explicit cast for C++ compilation

	* fuzz/wget_ntlm_fuzzer.c: Add explicit cast for C++ compilation

2021-05-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http.c (initialize_request): Send Host HTTP header first
	This solves an issue where the server expects the Host: header
	as first one. This seems plausible (ahem) as the Host: header is the
	only one that is required.

2021-05-02  Tim Rühsen  <tim.ruehsen@gmx.de>

	Improve wget_options_fuzzer
	* fuzz/fuzzer.h: Ignore -Wunused-parameter.
	* fuzz/wget_options_fuzzer.c: Let getaddrinfo() fail in while fuzzing.
	* fuzz/wget_options_fuzzer.in/*: Update corpora from OSS-Fuzz.

2021-05-02  Nekun  <nekokun@firemail.cc>  (tiny change)

	Fix typo in VMS support code
	* src/utils.c: Remove unpaired brace

2021-04-15  Nils  <nils@nilsand.re>  (tiny change)

	Use "nofollow" instead of "no-follow" in messages
	* src/html-url.c (get_urls_html_fm): Remove misleading debug message.
	* src/recur.c (retrieve_tree): Fix no-follow -> follow in DEBUGP.

	The attribute in html is "nofollow" so it is more consistent to call it
	so than to hyphenate it.

2021-04-15  Nils  <nils@nilsand.re>  (tiny change)

	Print message for no-follow attribute only if norobots respected
	* src/html-url.c (get_urls_html_fm): Remove misleading log message.
	* src/recur.c (retrieve_tree): Add log message into correct if block.

	Commit e39be3283836b8cb7b9ee320456eefb2a2fda173 added a message that
	said links will not be followed whenever the nofollow attribute is found
	in a page. It didn't take into account that with -e robots=off (and
	equivalents) links will still be followed.

	This bug has been noticed multiple times:
	* https://www.reddit.com/r/DataHoarder/comments/mprq89/wget_respects_nofollow_attribute_despite_e/
	* https://gist.github.com/simonw/27e810771137408fd7834ad153750c41#gistcomment-3648191
	* https://superuser.com/questions/1494761/wget-wont-ignore-no-follow-attributes

	This commits makes it so that this message is only printed when a
	nofollow link is found and the norobots convention is respected.

2021-04-15  Tim Rühsen  <tim.ruehsen@gmx.de>

	* configure.ac: Add AM_GNU_GETTEXT_VERSION

2021-04-11  Tim Rühsen  <tim.ruehsen@gmx.de>

	* testenv/test/base_test.py: Rename valgrind-suppression-ssl -> valgrind-suppressions-ssl

	* testenv/test/base_test.py: Add --show-leak-kinds=all valgrind argument

	* tests/WgetTests.pm: Add --show-leak-kinds=all valgrind argument

	Fix testenv valgrind suppression
	* testenv/Makefile.am: Remove valgrind-suppressions from EXTRA_DIST.
	* testenv/valgrind-suppression-ssl: Rename to testenv/valgrind-suppressions-ssl.

2021-04-11  Tim Rühsen  <tim.ruehsen@gmx.de>

	* bootstrap.conf: Add 'rename' to gnulib modules
	The missing module could be a reason for
	https://savannah.gnu.org/bugs/?60346.

	Reported-by: jrharris42@gmail.com

2021-04-11  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/wget.h: Use strtoll() for str_to_wgint
	This fixes a regression reported at https://savannah.gnu.org/bugs/?60353.

	Reported-by: Michal Ruprich

2021-04-11  Shamil Gumirov  <shamil@gumirov.com>  (tiny change)

	Minor output fix to use quote_n() instead of quote()
	* src/ftp.c (ftp_retrieve_list): change quote to quote_n
	* src/iri.c (do_conversion): change quote to quote_n
	* src/url.c (convert_fname): change quote to quote_n

	The implementation quote() reuses the buffer it returns which
	leads to printing the same string for each quote() call in one
	output line. Instead, quote_n() should be used as highlighted in
	the doc:
	https://www.gnu.org/software/gnulib/manual/html_node/Quoting.html

2021-04-05  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/Makefile.am: Add metalink.c and xattr.c to EXTRA_wget_SOURCES

	* testenv/Makefile.am: Allow tarball build without python3

2021-04-04  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix spelling errors
	* NEWS: trough -> through.
	* README.checkout: Likewise.
	* contrib/spell-checker: Add exclusion 'parm'

	Remove gettext version requirements
	* bootstrap.conf: Remove gettext version requirements
	* configure.ac: Likewise.

2021-03-16  Darshit Shah  <darnir@gnu.org>

	Use a LOG_COMPILER for running fuzz tests
	This prevents needing a special case in the fuzz tests to detect
	valgrind usage and a new exec. Instead, we simply detect the environment
	in a shell script and start the test with valgrind in the first place.

	* fuzz/test-runner.sh: New script for running the fuzz tests
	* fuzz/main.c (main): Remove code for re-running under valgrind
	* fuzz/Makefile.am: Set the LOG_COMPILER to test-runner.sh and remember
	  to add it to the list of extra files for packaging

2021-03-07  Tim Rühsen  <tim.ruehsen@gmx.de>

	* configure.ac: Add AC_PROG_CC_C99

2021-03-07  Darshit Shah  <darnir@gnu.org>

	Bump gettext version to 0.20
	* bootstrap.conf: Increase minimum version of gettext needed to 0.20
	* configure.ac: Same

	* bootstrap: Update script

	* gnulib: Pull forward

2021-03-02  Darshit Shah  <darnir@gnu.org>

	Fix double free in FTP Code
	* src/ftp.c(getftp): Don't free `target`. If it is not pointing to
	  targetbuf, then it still pointing to its original location of u->dir.
	  This location will be free'd later. Doing so now causes a double free
	  and hence crashes Wget
	* tests/Test-ftp-dir.px: New test to show double free error
	* tests/Makefile.am: Add new test

2021-01-31  Tim Rühsen  <tim.ruehsen@gmx.de>

	* doc/wget.texi: Replace '' with  in example
	Needed to hide from texi2pod.pl replacement of '' -> ".

	Reported-by: Vincent Lefevre

2021-01-23  Tim Rühsen  <tim.ruehsen@gmx.de>

	Use gnulib's utime.h
	* bootstrap.conf: Remove utime-h (included by utime).
	* configure.ac: Remove header checks for utime.h and sys/utime.h.
	* src/utils.c: Simply #include <utime.h>.

	* configure.ac: Detect unresolved AX_ macros

2021-01-16  Tim Rühsen  <tim.ruehsen@gmx.de>

	* configure.ac: Use noyywrap for AC_PROG_LEX

	Fix --quota on systems with 32bit long type
	* src/init.c (cmd_bytes_sum): Use WGINT_MIN and WGINT_MAX in check.
	* src/options.h (struct options): Make 'quota' of type wgint.
	* src/retr.c: Make 'total_downloaded_bytes' of type wgint.
	* src/utils.h: Fix comment.
	* src/wget.h: Add WGINT_MIN, remove SUM_SIZE_INT.

	* configure.ac: Remove obsolete AC_HEADER_STDC

	* configure.ac: Replace ` with '

	* configure.ac: Use yywrap param for AC_PROG_LEX

2021-01-09  Darshit Shah  <darnir@gnu.org>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	* NEWS: Update NEWS items for release

	* gnulib: Pull forward

	* cfg.mk: Add manual_title for web docs

	* contrib/make-release: Update to use maintainer-makefile

	* bootstrap.conf: Add gendocs and gnu-web-doc-update modules

	* configure.ac(AM_INIT_AUTOMAKE): Create lzip archives when making a distribution

	Prepare for making releases
	The maintainer makefile provides targets for making a release. They need
	these things:
	* cfg.mk: Set the hash of the NEWS file as it was at the beginning of
	  this release
	* .prev-version: Create the .prev-version file

	Prepare NEWS file for new release
	* NEWS: Fix the copyright notice
	* NEWS: Add header for new release

2021-01-07  Darshit Shah  <darnir@gnu.org>

	Use PRId64 to correctly identify the format specifier
	* src/utils.c: Use PRId64 to correctly identify the format specifier for
	wgint values. This fixes a warning on 32-bit systems where wgint is a
	long long int instead of the long int that the format specifier
	indicated.

	Reported-by: Jeffrey Walton

2021-01-03  Darshit Shah  <darnir@gnu.org>

	* src/retr.c(rotate_backups): Simplify logic for handling filename rotation

2021-01-03  Matt Whitlock  <gentoo@mattwhitlock.name>

	* configure.ac: Don't use Bashisms

2021-01-01  Darshit Shah  <darnir@gnu.org>

	Run make update-copyright

	* gnulib: Pull forward

2020-12-31  Darshit Shah  <darnir@gnu.org>

	* NEWS: Finalize release

	* gnulib: Update for release

2020-12-30  Darshit Shah  <darnir@gnu.org>

	* src/main.c: Disable use-askpass on VMS

2020-12-30  Steven M. Schweda  <sms@antinode.info>
	    Darshit Shah  <darnir@gnu.org>

	Fixes for running on VMS
	time_t on VMS is typically unsigned.  (Lazy man's solution to 2038?)
	I added "(time_t)" type casts to negative values ("-1"), and changed
	tests to avoid complaints.

	* src/hsts.c (hsts_add_entry): Explicitly cast potentially negative time
	  values to time_t to handle VMS quirks.
	  (hsts_store_entry): Same
	  (get_hsts_store_filename): Use new ajoin_dir_file function to join
	  filenames
	  (test_hsts_read_database): Same
	* src/init.c (struct options): use-askpass is not implemented on VMS
	  (ajoin_dir_file): New Function to join filenames in a platform
	  agnostic manner
	  (wgetrc_user_file_name): Use ajoin_dir_file to join paths. Doing this
	  correctly, eliminates the need for a special case on VMS
	* src/init.h: Add prototype for ajoin_dir_file
	* src/log.c (check_redirect_output): Ignore on VMS
	* src/main.c(option_data): Disable use-askpass on VMS
	  (print_help): Same
	  (get_hsts_database): Use ajoin_dir_file to join paths
	  (print_version): Add VMS specific information to Version output
	* src/utils.c (fork_to_background): Fix signature on VMS

2020-12-29  Tim Rühsen  <tim.ruehsen@gmx.de>

	Remove SIZEOF_WGINT as wgint is always int64_t
	* src/http.c (test_parse_range_header): Remove use of SIZEOF_WGINT.
	* src/utils.c (human_readable): Remove superfluous HR_NUMTYPE,
	*   (number_to_string): Remove use of SIZEOF_WGINT.
	* src/utils.h: Remove use of SIZEOF_WGINT and HR_NUMTYPE.
	* src/wget.h: Remove #define SIZEOF_WGINT.

	src/wget.h: Cleanup code around wgint

2020-12-29  Darshit Shah  <darnir@gnu.org>

	Remove portability handling for str[n]casecmp
	* src/mswindows.c: Gnulib ensures we always have str{n}casecmp
	* configure.ac: Don't need to define HAVE_STR[N]CASECMP anymore

2020-12-29  Darshit Shah  <darnir@gnu.org>

	Remove portability handling code for wgint
	Gnulib's stdint.h module promises a C99 compliant stdint.h file on all
	platforms. Thus allowing us to directly use the fixed wodth integer
	type, int64_t wihout needing to resort to all the checks being
	performed.

	* src/wget.h: Assume that int64_t is always available and use it
	* src/mswindows.h: Remove portability code since gnulib handles it
	* configure.ac: Remove sizeof checks for integer types that are no
	  longer used

2020-12-29  Tim Rühsen  <tim.ruehsen@gmx.de>

	* .lgtm.yml: Call autoreconf to support Debian oldstable

2020-12-28  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix --accept-regex/i--reject-regex for FTP
	* src/ftp.c (ftp_retrieve_glob): Call accept_url() with the full URL

	Reported-by: Frans de Boer <frans@fransdb.nl>

2020-12-28  Darshit Shah  <darnir@gnu.org>

	* tests/valgrind-suppressions: Make suppression for libidn false positive more generic

	* Makefile.am: Clean up gnulib_po/stamp-po

	tests/valgrind-suppressions: Add suppressions for false positives

	testenv/Test--https.py: Fix missing import

	.gitlab-ci.yml: Everyone needs an autoreconf now

	.gitlab-ci.yml: Even Debian Stable requires running autoreconf

	Fix usage of Magic number of tests
	testenv/test/base_test.py: Add new variable SKIP_TEST
	testenv/Test--https-crl.py: Use SKIP_TEST instead of magic number
	testenv/Test--https.py: Same
	testenv/Test-hsts.py: Same
	testenv/Test-no_proxy-env.py: Same
	testenv/Test-pinnedpubkey-der-https.py: Same
	testenv/Test-pinnedpubkey-der-no-check-https.py: Same
	testenv/Test-pinnedpubkey-hash-https.py: Same
	testenv/Test-pinnedpubkey-hash-no-check-fail-https.py: Same
	testenv/Test-pinnedpubkey-pem-fail-https.py: Same
	testenv/Test-pinnedpubkey-pem-https.py: Same

	.gitlab-ci.yml: All modern builds need autoreconf

	.po/POTFILES.in: Remove files containing no translateable strings

	Fix issues reported by codespell

	.gitlab-ci.yml: Need --force option to autopoint

	* .gitlab-ci.yml: Don't need autoreconf everywhere. Only on Arch
	This (partially) reverts commit 0309d13794303d82529addecfc31f0e1a8c5b97b.

	configure.ac: Revert to requiring gettext 0.19

	.gitlab-ci.yml: Call autoreconf to refresh gettext files

	* NEWS: Update NEWS items

	configure.ac: Raise minimum gettext version to 0.20

	Run autoupdate on configure.ac
	* configure.ac, m4/{wget, wget_manywarnings}.m4: Run autoupdate

	.gitignore: Ignore gnulib_po directory

	configure.ac: Replace obsolete macro AC_AIX with AC_USE_SYSTEM_EXTENSIONS

2020-12-27  Darshit Shah  <darnir@gnu.org>

	bootstrap.conf: Remove unneeded text block

	m4/getpagesize.m4: Don't track autogenerated file

2020-12-27  Darshit Shah  <darnir@gnu.org>

	Remove unneeded files from gnulib
	m4/exitfail.m4: Remove unneeded file
	m4/wchar.m4: Same
	m4/wctype.m4: Same

	The latest versions of these files will be copied by gnulib-tool upon
	its invokation. No need to track them around here

2020-12-27  Darshit Shah  <darnir@gnu.org>

	Use a separate domain for translating gnulib
	Use the --po-domain option to gnulib-tool to create a new textdomain
	that can be used by gnulib files for translations. This way, we don't
	have to maintain the list of all files that require translations in
	gnulib.

	* bootstrap.conf: Use --po-domain and --po-base options to create a
	  separate base for gnulib translations
	* src/main.c(i18n_initialize): Call bindtextdomain on wget-gnulib to
	  include those translations as well
	* Makefile.am: Add new directory gnulib_po to SUBDIRS
	* configure.ac: Generate gnulib_po/Makefile.in
	* lib/Makefile.am: Set AM_CPPFLAGS to empty since gnulib.mk expects it
	  to be set

2020-12-27  Darshit Shah  <darnir@gnu.org>

	po/POTFILES.in: Update the list of files that need translation

	m4/getpagesize.m4: Update from gnulib

	configure.ac: Increase minimum required version to 2.64

	gnulib: Pull forward

2020-12-22  Darshit Shah  <git@darnir.net>

	main.c (main): Warn when trying to use password without username

2020-12-13  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http.c (http_cleanup): Reset wget_cookie_jar after freeing
	This silences the wget_options_fuzzer which triggered #28610 on
	OSS-Fuzz. This issue can not happen with the Wget utility.
	The fuzzer runs main(),...,cleanup() in a loop which the Wget utility
	never does.

2020-11-08  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/main.c: Add description to --help output of wait options

2020-07-11  Tomas Hozza  <thozza@redhat.com>

	testenv: Add test for handling of no_proxy environment variable
	* testenv/Test-no_proxy-env.py: Added new test for no_proxy env
	* testenv/Makefile.am: Added the new test to Makefile

	Added new test with 5 cases, which are testing various combinations
	of no_proxy environment variable definition and requested URLs.
	The test is skipped if the system does not support resolution of
	localhost subdomains to lcalhost address.

2020-07-11  Tomas Hozza  <thozza@redhat.com>

	testenv: Allow definition of environment variables for wget execuion
	* testenv/README: Added description for new EnvironmentVariable hook
	* testenv/conf/environment_variable.py: Added implementation of
	EnvironmentVariable hook
	* testenv/test/base_test.py: Modified exec_wget() to enable use of
	EnvironmentVariable hook

	Added new test hook called EnvironmentVariables, for defining environment
	variables when wget is executed in tests. This is handy for testing
	environment variables, which are accepted by wget.

2020-07-11  Tomas Hozza  <thozza@redhat.com>

	testenv: HTTPTest.begin() should return exit value
	* testenv/test/http_test.py: Ensure that HTTPTest.begin() always returns
	a value

	Previously the HTTPTest.begin() method always returned None. However this
	is not consistent with the begin() implementation of the parent class
	(BaseTest). This change ensures that HTTPTest.begin() returns a value.

2020-07-07  Darshit Shah  <git@darnir.net>

	Minor documentation clarification
	* src/wget.texi: Clarify behaviour of --quota
	  Thanks to TheWild on IRC for pointing it out

2020-06-29  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/ftp.c (ftp_loop_internal): Check for VERIFCERTERR to avoid SIGABRT
	There is a bug that causes wget to exit with SIGABRT when trying to
	receive files through FTP from a server with a certificate that failed
	the verification.

	The bug is filed in RedHat Bugzilla for Fedora:
	https://bugzilla.redhat.com/show_bug.cgi?id=1475861

	Reported-by: Artem Egorenkov <aegorenk@redhat.com>

2020-06-21  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/host.c (lookup_host): Fix uninitialized pointer access in c-ares code
	Reported-by: Swapnil More

2020-05-22  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/gnutls.c (ssl_init): Small cleanup fixing output of ncerts

2020-05-01  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/convert.c (downloaded_files_free): Only compile if DEBUG_MALLOC or TESTING is defined

	* src/netrc.c (free_netrc): Only compile if DEBUG_MALLOC or TESTING is defined

2020-05-01  Вячеслав Петрищев  <vyachemail@gmail.com>

	Fix SSL/TLS timeout issues.
	* connect.c (fd_read, fd_peek): Let implementation take care about timeout.
	* gnutls.c (_do_handshake, _do_reauth, wgnutls_read_timeout): Fix support for interactive timeout.
	* gnutls.c (wgnutls_peek): Let wgnutls_read_timeout() take care about timeout.
	* openssl.c (openssl_read_peek): Fix 0 (-1) timeout.
	* retr.c (fd_read_body): Avoid wrong 'interactive timeout'.

	Set interactive to true for bar progress.
	* src/progress.c (bar_set_params): Set interactive to true.
	* src/retr.c (fd_read_body): Avoid call fd_read with 0 timeout.

2020-05-01  Вячеслав Петрищев  <vyachemail@gmail.com>

	New implementation for openssl_read, openssl_peek ssl_connect_with_timeout (openssl)
	Add new implementation for openssl_read, openssl_peek
	ssl_connect_with_timeout (openssl). Thats allow continue
	read after ETIMEDOUT (if timeout < opt.read_timeout)
	without 'Retrying', and do not create thread (under MSWin)
	for every read. Old implementation, (with fix for 'timeout')
	avaible for build with: -DOPENSSL_RUN_WITHTIMEOUT

	Add timeout for transport_implementation {reader,peeker};

	* src/init.c (cmd_time): Add check for negative value.
	* src/connect.h (transport_implementation {reader,peeker}): Change function prototype.
	* src/connect.c (select_fd_nb): New function, aviod conversion to blocked under MSWin.
	* src/gnutls.c
	   (gnutls_read): Fix: using timeout, seting ETIMEDOUT, conversion to blocked.
	   (gnutls_peek): Likewise.
	   (wgnutls_errstr): Add errmsg for ETIMEDOUT.
	   (_do_handshake) (_do_reauth): Fix conversion to blocked.
	* src/openssl.c:
	   Add new implementation for openssl_read, openssl_peek, ssl_connect_with_timeout.
	   (init_prng): when option --random-file given warn user if RAND_load_file() fail.

2020-04-18  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add missing linefeed in output strings
	* src/ftp.c (getftp): Add linefeed to error message.
	* src/res.c (res_parse_from_file): Likewise.
	* src/utils.c (fopen_stat): Likewise.
	  (open_stat): Likewise.

2020-03-28  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/metalink.c: Include filename.h instead of dosname.h

	* gnulib: Update

2020-03-24  Tomas Hozza  <thozza@redhat.com>

	Don't print message about loading crl or ca-cert files with --no-verbose
	* src/gnutls.c (ssl_init): Use LOG_VERBOSE verbosity for informative
	  message related to loading CRL or CA certificate file.

	Before change [1], wget didn't produce any output related to loading CA
	certificates when --no-verbose option has been used. When --no-verbose
	option is used, only error messages and basic information should get
	printed. Information about loading CRL or CA certificate is probably not
	a basic information. Any error when loading the CRL or CA certificate
	will be still printed with --no-verbose.

	Some users rely on wget not printing such information and they consider
	it a regression.

	Reported as https://bugzilla.redhat.com/show_bug.cgi?id=1807267

	[1] http://git.savannah.gnu.org/cgit/wget.git/commit/?id=e4a8fe84e2b813b65d91aec29298eecabe4850a5

2020-03-06  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add NTLM fuzzer
	* configure.ac: Create WITH_NTLM conditional.
	* fuzz/Makefile.am: Add wget_ntlm_fuzzer.
	* fuzz/wget_ntlm_fuzzer.c: New file.
	* fuzz/wget_ntlm_fuzzer.in/*: Initial fuzz corpora.

	* src/http.c (check_auth): Fix memory leak

	* src/http-ntlm.c (mkhash): Fix read buffer overflow

2020-03-05  Tim Rühsen  <tim.ruehsen@gmx.de>

	* README.checkout: Fix gperf typo and tab indentation

	* .gitlab-ci.yml: Generate online docs and coverage reports for Gitlab

2020-03-05  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add code coverage reporting
	* configure.ac: Add AX_CODE_COVERAGE.
	* Makefile.am: Add rules 'check-coverage' and 'fuzz-coverage'.
	* fuzz/Makefile.am: Amend LDADD, AM_CFLAGS and AM_CPPFLAGS.
	* src/Makefile.am: Amend LDADD, AM_CFLAGS and AM_CPPFLAGS.

	This add a new configure option, --enable-code-coverage.

	With this option enabled, generate test code coverage with
	  make code-coverage
	and generate coverage for the fuzz test corpora with
	  make fuzz-coverage

2020-03-05  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http.c: Don't cast 3rd param to request_set_header.

	* README: Fix typo 'can retrieves' -> 'can retrieve'

2020-03-03  Darshit Shah  <darnir@gnu.org>

	* doc/wget.texi: Add maintainers and mention wget2

	doc/wget.texi: Clarify usage of --level

2020-03-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http.c (gethttp): Remove unneeded free of hstat.(message|error)

	* src/http.c (gethttp): Fix memleaks
	Reported-by: Вячеслав Петрищев

	* src/http.c (read_response_body): Fix memleak
	Reported-by: Вячеслав Петрищев

2020-02-29  Tim Rühsen  <tim.ruehsen@gmx.de>

	* contrib/spell-checker: Add lightening to exceptions

	Always build ssl_cleanup
	* src/gnutls.c (ssl_cleanup): Don't build conditionally.
	* src/openssl.c (ssl_cleanup): Likewise

2020-02-28  Tim Rühsen  <tim.ruehsen@gmx.de>

	* doc/wget.texi: Fix spelling error
	Reported-by: Jim Cathey

2020-02-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/convert.c (convert_cleanup): Free downloaded_css_set

	* src/openssl.c (ssl_cleanup): Only compile for DEBUG_MALLOC or TESTING

	* src/gnutls.c (ssl_cleanup): Only compile for DEBUG_MALLOC or TESTING

	* src/netrc.c (netrc_cleanup): Only compile for DEBUG_MALLOC or TESTING

	* src/log.c (log_cleanup): Only compile for DEBUG_MALLOC or TESTING

	* src/host.c (host_cleanup): Only compile for DEBUG_MALLOC or TESTING

	* src/spider.c (spider_cleanup): Only compile for DEBUG_MALLOC or TESTING

	* src/res.c (res_cleanup): Only compile for DEBUG_MALLOC or TESTING

	* src/convert.c (convert_cleanup): Only compile for DEBUG_MALLOC or TESTING

	* src/html-url.c (cleanup_html_url): Only compile for DEBUG_MALLOC or TESTING

	* src/http.c (http_cleanup): Free hashtable basic_authed_hosts

	* src/cookies.c (cookie_jar_delete): Set psl to NULL after calling psl_free

	* src/init.c (cleanup): Call ssl_cleanup and connect_cleanup

	Add ssl_cleanup to free memory
	* src/ssl.h: Add declaration for ssl_cleanup.
	* src/openssl.c: Add ssl_cleanup stub.
	* src/gnutls.c: Implement ssl_cleanup.

	* src/http.c (http_cleanup): Call invalidate_persistent to free resources

	* src/cookies.c: Free PSL in cookie_jar_delete

	* src/connect.c (connect_cleanup): Only needed with DEBUG_MALLOC or TESTING

	* src/http.c (http_loop): Avoid unneeded strdup

2020-02-27  Вячеслав Петрищев  <vyachemail@gmail.com>

	* src/http.c (gethttp): Fix memleak

2020-02-23  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http.c: Do not reveal OS type to server via User-Agent: header
	Following the "privacy by design" principle, which is now European law by
	virtue of the GDPR since 2018, the client should not transmit the operating
	system.

	Fixes #57884
	Reported-by: Bruno Haible

2020-02-22  Tim Rühsen  <tim.ruehsen@gmx.de>

	* tests/unit-tests.c: Fix 'multiple definition of...' with gcc 10

	Split unique_name into two functions with just one arg
	* src/http.c (check_file_output): Call unique_name_passthrough.
	* src/metalink.c (badhash_suffix): Call unique_name.
	* src/url.c (url_file_name): Call unique_name_passthrough.
	* src/utils.c: Split unique_name, amend description.
	* src/utils.h: Amend unique_name, add unique_name_passthrough.

	* .gitlab-ci.yml: Set tag 'linux' explicitly for each runner

2020-02-22  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http.c (print_response_line): Fixed comparison
	Introduced in 68868bbb3737d26c197f39edafc5d526334426b0 (13.2.2020).

	Reported-by: Gisle Vanem

2020-02-21  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add valgrind suppressions
	* testenv/valgrind-suppression-ssl: Add gnutls suppressions
	* tests/valgrind-suppressions: Likewise
	* tests/valgrind-suppressions-ssl: Likewise

	Add --gen-suppressions=all to valgrind options
	* testenv/test/base_test.py: Add --gen-suppressions=all to valgrind options
	* tests/Test-proxied-https-auth.px: Likewise
	* tests/WgetTests.pm: Likewise

	* cfg.mk: Exclude sc_prohibit_gnu_make_extensions

	* src/retr.c (fd_read_body): Check timer before accessing (Coverity #600494)

	* src/warc.c (warc_write_start_record): Check return values of fseek, fflush (Coverity #1419650)

	* src/ftp-ls.c (eat_carets): Fix caret decoding issue (Coverity #1419653)

	* src/warc.c (warc_write_block_from_file): Check for write error (Coverity #1419654)

	* src/warc.c (warc_write_end_record): Check return value of fseeko (Coverity #1419657)

	Add valgrind suppressions for HTTPS tests (GnuTLS false positive)
	* testenv/valgrind-suppression-ssl: Add new rule
	* tests/valgrind-suppressions: Likewise
	* tests/valgrind-suppressions-ssl: Likewise

2020-02-20  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/init.c (setoptval): Add missing comma (fix compilation)

	* .gitlab-ci.yml: Add spell-checking to VPATH/Debian

2020-02-20  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix typos found by codespell
	*/*: Fix typos

	Thanks to https://fossies.org/features.html#codespell

	Reported-by: Jens Schleusener

2020-02-20  Tim Rühsen  <tim.ruehsen@gmx.de>

	* contrib/spell-checker: Add new file

	* src/init.c (setoptval): Silence Coverity (Coverity #1419648)

	* src/main.c (init_switches): Remove unneeded code (Coverity #1419658)

	* src/ftp-ls.c (ftp_parse_vms_ls): Fix use of uninitialized stack mem (Coverity #609373)

2020-02-19  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/retr.c (retrieve_url): Fix memory leak (Coverity #1316408)

	* src/http.c (set_file_timestamp): Fix stack memory leak (Coverity #1419655)

	* src/main.c (main): Initialize variable (Coverity #1419660)

	* .gitlab-ci.yml: Fix linebreak

	* src/http.c (metalink_from_http): Fix memleak (Coverity #1419661, #1419656)

	* .gitlab-ci.yml: Add 'coverity' runner

	* contrib/mk_authors: Create list of authors and translators since last version

	* src/progress.c (eta_to_human_short): Silence -Wformat-overflow

2020-02-14  Tim Rühsen  <tim.ruehsen@gmx.de>

	* .gitlab-ci.yml: Don't copy gnulib manually

	* NEWS: Update

	Remove alloca includes and macros
	* bootstrap.conf: Remove gnulib module 'alloca'.
	* src/sysdep.h: Remove include of alloca.h.
	* src/wget.h: Likewise,
	  remove macros BOUNDED_TO_ALLOCA and STRDUP_ALLOCA.

	* src/utils.h: Remove alloca_array

	* src/convert.c (convert_links_in_hashtable): Remove use of alloca

	* src/convert.c (local_quote_string): Remove use of alloca

	* src/convert.c (replace_attr_refresh_hack): Remove use of alloca

	* gnulib: Update

	* bootstrap.conf: Use fnmatch-gnu instead of fnmatch

	* src/convert.c (write_backup_file): Remove use of alloca

	* src/utils.c (fnmatch_nocase): Remove FNM_CASEFOLD emulation, gnulib takes care of it

	* src/cookies.c (cookie_header): Remove use of alloca

	* src/cookies.c (cookie_header): Remove use of alloca

	* src/cookies.c (cookie_handle_set_cookie): Remove use of alloca

	* src/cookies.c (parse_set_cookie): Explicitly convert from double to time_t

	* src/cookies.c (parse_set_cookie): Remove use of alloca

	* src/warc.c (warc_uuid_str): Add second param to windows_uuid_str

	* src/cookies.c (parse_set_cookie): Remove use of alloca

	* src/main.c (main): Code clean, reduce allocations

	* src/main.c: Modify macro IF_SSL to work with latest struct changes

	* configure.ac: List 'no' for --with-ssl in help output

2020-02-13  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/ftp.c (ftp_retrieve_dirs): Remove use of alloca

	* src/ftp.c (ftp_retrieve_list): Remove use of alloca

	* src/ftp.c (ftp_loop_internal): Remove use of alloca

	* src/ftp.c (getftp): Remove use of alloca

	* src/http.c: Include xstrndup.h unconditionally

	* src/ftp-basic.c (ftp_request): Remove use of alloca

	* src/html-parse.c (name_allowed): Remove use of alloca

	* src/netrc.c (search_netrc): Remove use of alloca

	* src/init.c (parse_line): Remove use of alloca

	Remove use of alloca in setoptval
	* src/init.c (setoptval): Remove use of alloca
	* src/init.h: Add define MAX_LONGOPTION
	* src/main.c (struct cmdline_option): Make 'long_name' a char array

	* src/http.c (check_auth): Remove use of alloca

	* src/http.c (print_response_line): Remove use of alloca

	* src/http.c (request_set_user_header): Remove use of alloca

	* src/http.c (metalink_from_http): Remove use of alloca

	* src/http.c (basic_authentication_encode): Remove use of alloca

	* src/http.c (gethttp): Remove use of alloca

	* src/http.c (gethttp): Remove use of alloca

	* src/http.c (set_file_timestamp): Remove use of alloca

	* src/main.c (main): Remove use of alloca

	* src/url.c (append_uri_pathel): Replace alloca by fixed array / sprintf

	* src/url.c (append_uri_pathel): Replace alloca by fixed array / xmalloc

	* src/utils.c (make_directory): Replace alloca by fixed array / xmalloc

	* src/utils.c (unique_name_1): Replace alloca by xmalloc

	Add buffer size param to warc_uuid_str
	* src/http.c (gethttp): Add buffer size param to warc_uuid_str.
	* src/warc.c: Likewise
	* src/warc.h: Likewise

2020-02-12  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http-ntlm.c (ntlm_output): Remove alloca

	* src/http-ntlm.c (mkhash): Replace alloca by fixed length array

	* src/http-ntlm.c (ntlm_input): Replace alloca by fixed length array

	* src/gnutls.c (ssl_init): Replace alloca by fixed length arrays

	* src/retr.c (fd_read_body): Fix signedness warnings

	* src/retr.c (rotate_backups): Replace alloca by fixed length arrays

	* src/wget.h: Add inline to _unhex

	* src/metalink.h: Include dirname.h, remove declaration of last_component

	* configure.ac: Add -Wno-undef -Wno-float-equal to gcc's WARN_CFLAGS

	* src/convert.c (convert_links): Fix previous commit

	* src/convert.c (convert_links): Add \n (Fixes #57795)

2020-01-25  Ander Juaristi  <ajuaristi@gmx.es>

	Do not overwrite restval if len is smaller
	 * src/http.c (http_loop): overwrite 'restval' only if 'len' is
	   greater than it. Else substract 'len' to 'restval'.

	When retrying a request, only send a 'Range' header if the previous
	request returned data.

2020-01-24  Вячеслав Петрищев  <vyachemail@gmail.com>

	Fix and cleanup progress bar code
	*src/progress.c
	 (struct dot_progress) accumulated, rows: Type changed to wgint
	 (print_row_stats): Fix missing unit name 'T'
	 (dot_update): Add ability to reduce dot_draw runtime
	 (bar_update): Avoid integer overflow

	* src/progress.c: Fix MINIMUM_SCREEN_WIDTH

	* src/progress.c (prepare_filename): Replace zero-width mbc (\xe2\x80\x8b, ...)

	Reenabling filename scrolling code in progress bar
	* src/progress.c: Reenabling filename scrolling code
	  (bar_create):  Reenabling file name scrolling.
	  (bar_create):  Memory allocation, filename preparation.
	  (bar_finish):  Filename  memory deallocation.
	  (prepare_filename):  New function, replaces unprintable chars.

	Fix multibyte handling in progress bar
	* src/progress.c
	  (count_cols): Fix return value if invalid multibyte sequence was encountered
	  (bar_draw): Fix xrealoc size

2020-01-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/progress.c (print_row_stats): Fix two integer overflows

	* .gitlab-ci.yml: Fix path for llvm-symbolizer

	* fuzz/wget_progress_fuzzer.in/*: Add fuzzer corpora

	* src/retr.c (calc_rate): Remove unwanted assertions

	Fix buffer overflows in progress 'bar' code
	* src/progress.c (progress_interactive_p): Sanitize input.
	  (progress_update): Likewise.
	  (bar_create): Use larger BUF_LEN.
	  (bar_create): Remove superfluous memset.
	  (bar_create): Fix filename layout.
	  (bar_create): Remove filename scrolling code, it caused many buffer
	  overflows later in bar_create.
	  (bar_create): Support TB/s download speed.

	Add new fuzzer for the progress bar code
	* Makefile.am: Add wget_progress_fuzzer.
	* wget_progress_fuzzer.c: New file.

2020-01-10  Darshit Shah  <darnir@gnu.org>

	Update copyright year to 2020

	* cfg.mk: Set update-copyright to use intervals

2019-12-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix segfault in progress bar in certain locales
	* src/progress.c (create_image): Protect memset from negative count

	Reported-by: JunDong Xie

2019-12-27  Tim Rühsen  <tim.ruehsen@gmx.de>  (tiny change)

	* src/progress.c (count_cols): Fix return value if USE_NLS_PROGRESS_BAR is undefined
	Taking patch from #54126
	Reported-by: Vyacheslav

2019-12-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/progress.c: Allow const names for set_progress_implementation.

	* src/progress.c (dot_draw): Avoid integer overflow

	* fuzz/README.md: Add --enable-assert to fuzzing build

	* src/progress.c (print_row_stats): Fix UB if eta < 0

	* src/progress.c (dot_update, dot_finish): Sanitize input

	* src/retr.c (calc_rate): Fix division by 0

	* src/retr.c (calc_rate): Add TB/s

	* src/progress.c (create_image): Sanitize input param 'dl_total_time'

	* fuzz/README.md: Update clang instructions

2019-12-26  Lauri Nurmi  <lanurmi@iki.fi>  (tiny change)

	Mark note to translators properly and elaborate its contents.
	* src/progress.c (create_image): Likewise

	The note was not even picked by xgettext to be included in the .pot,
	so barely any translators even saw the note.
	Also, this is one of the most cryptic messages to translate in wget,
	unless the translator happens to guess where the string is used,
	or looks at the source.

2019-12-26  Lauri Nurmi  <lanurmi@iki.fi>  (tiny change)

	* src/main.c (print_help): Don't cut translatable string mid-sentence.
	Complicates translating.

2019-11-24  Tim Rühsen  <tim.ruehsen@gmx.de>

	* fuzz/wget_read_hunk_fuzzer.c: Use cast to fix C++ error

2019-11-21  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/Makefile.am: Add build_info.c to EXTRA_DIST

	* .gitlab-ci.yml: Skip tests on tarball build due to missing perl

	* tests/WgetTests.pm: Support  to set the wget executable for testing

	* .gitlab-ci.yml: Add --with-ssl=no

	* .gitlab-ci.yml: Allow failure for Valgrind and Scan-Build CI runner

	* src/ftp.c (delelement): Make sure free'd pointer is set to NULL

	* configure.ac: Remove -fno-sanitize-recover=integer
	With this option on, several overflows from gnulib code (all
	harmless and on purpose) would break our tests.

2019-11-21  Tim Rühsen  <tim.ruehsen@gmx.de>

	Replace XDIGIT_TO_NUM by _unhex() with proper unsigned handling
	* src/wget.h: Replace XDIGIT_TO_NUM by _unhex()
	* src/html-parse.c (decode_entity): Use _unhex()
	* src/host.c (is_valid_ipv6_address): Use _unhex()
	* src/url.c (url_unescape_1): Use unsigned char to avoid UB
	* src/res.c (free_specs): Likewise

	Code taken from Wget2. XDIGIT_TO_NUM had a signed issue, detected by
	scan-build static anylyzer.

2019-11-21  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/connect.c (select_fd): Check for negative fd

	* .gitlab-ci.yml: Enable Windows executables for MinGW runner

	* .gitlab-ci.yml: Add CI runners from Wget2

2019-11-21  Tomas Hozza  <thozza@redhat.com>

	testenv: enable running tests on different wget binary
	* testenv/README: Document $WGET_PATH
	* testenv/test/base_test.py: Use $WGET_PATH instead ../src/wget if set

	Previously tests in testenv/ directory were run only on wget binary
	which was built from sources in src/ directory. However as a
	wget maintainer in a Linux distribution, I would like to be able to run
	upstream tests on the wget binary distributed with the distribution.

	This change enables one to define WGET_PATH environment variable
	to a path to wget binary which should be used by tests.

2019-11-21  Tim Rühsen  <tim.ruehsen@gmx.de>

	* AUTHORS: Add Darshit Shah and Tim Rühsen as maintainers

2019-11-19  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/cookie.c: Fix cookie file header to be recognized by 'file'

	* .mailmap: Allow mapping contributors for statistics

2019-10-03  Darshit Shah  <darnir@gnu.org>

	* configure.ac: Ignore -Wchkp which is deprecated

	Update gnulib
	* gnulib: Pull submodule
	* bootstrap: Update file from gnulib

2019-05-30  Tim Rühsen  <tim.ruehsen@gmx.de>

	Revert "Add . to perl path for all perl tests"
	This reverts commit 79be99aff4717a75ec7531d8b3a4ec96341754ca.

	/usr/bin/env 8.28 and below doesn't know -S.

2019-05-30  Darshit Shah  <darnir@gnu.org>

	Revert "	Hi, Thank you again Darshit for your response. The RejectHeaderField rule rejects ANY header"
	I accidentally commited this patch.

	This reverts commit 4ce2f93600827f47f7fea5e7eeb224232cef3c3d.

2019-05-30  Darshit Shah  <darnir@gnu.org>

	* .gitignore: Update gitignore file

2019-05-30  sulfastor  <torresmoisesa@gmail.com>

		Hi, Thank you again Darshit for your response. The RejectHeaderField rule rejects ANY header 	of the header field while RejectHeader rejects ONLY the specified full header. 	Since we wanted to be sure a header field is not sent to the server we wrote this rule.
		* doc/wget.texi: Added --disable-header documentation.
	        * fuzz/wget_options_fuzzer.dict: Update with --disable-header inputs.
	        * src/http.c (disabled_header): Checks for disabled headers
		(request_set_header): Doesn't let header to be set if disabled
		(gethttp): frees disabled header to let overriding
	        * src/init.c (cmd_dis_header), (check_user_disabled_header) added new option disabled_headers.
	        * src/main.c: added new option --disable-header, added help description
	        * src/options.h: added new option --disable-header
		* src/utils.h (vec_remove_header)
		* src/utils.c (vec_remove_header) removes all header instances from vector
	        * testenv/Makefile.am: Added new test files
	        * testenv/server/http/http_server.py: Added new rule RejectHeaderField
	        * testenv/conf/reject_header_field.py: Added new rule RejectHeaderField
	        * testenv/README: Added help description for new rule
	        * testenv/Test-disable-default-headers.py: Test without using --header
	        * testenv/Test-disable-headers-after.py: Test using --header before --disable-header
	        * testenv/Test-disable-headers-before.py: Test using --header after --disable-header

2019-05-28  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/log.c (log_vprintf_internal): Don't log twice

2019-05-25  AviSoomirtee  <avi@cyberstorm.mu>  (tiny change)

	* src/openssl.c (ssl_init): post handshake auth for OpenSSL

2019-05-24  Tim Rühsen  <tim.ruehsen@gmx.de>

	* bootstrap.conf: Explicitly set source_base and test_base

2019-05-07  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/convert.c (convert_basename): Do not pass NULL to strrchr()

	* src/url.c (append_uri_pathel): Check for possible NULL dereference

	* fuzz/main.c: Fix paths for WIN32

	* bootstrap.conf: Work around VPATH issue

	* configure.ac: Update gettext version to 0.19.3

	* bootstrap.conf: Remove rsync as prerequisite
	'./bootstrap --skip-po' won't need wget nor rsync

	* bootstrap.conf: Replace prerequisite xz by gzip

2019-05-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add sanitizer flags for ./configure
	* bootstrap.conf: Add 'warning' gnulib module
	* configure.ac: Add --enable-fsanitize-* flags
	* tests/Makefile.am: Add compiler flags for unit testing

2019-05-02  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add --enable-manywarnings from wget2
	* .gitignore: Exclude /lib/Makefile.am
	* bootstrap.conf: Use --makefile-name=gnulib.mk with gnulib-tool
	* configure.ac: Use wget_MANYWARNINGS()
	* lib/Makefile.am: Define empty noinst_LIBRARIES and MAINTAINERCLEANFILES
	* m4/wget_manywarnings.m4: New file from GNU Wget2
	* src/Makefile.am: Use WARN_CFLAGS for AM_CFLAGS

2019-04-28  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add CONTRIBUTING.md
	* CONTRIBUTING.md: New file for contributors
	* README: Mention CONTRIBUTING.md

2019-04-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	* fuzz/*.in/*: Update corpora from OSS-fuzz

	* fuzz/get_ossfuzz_corpora: Remove -f from unzip, mkdir *.in/

	* .gitlab-ci.yml: Update Gitlab CI WORKDIR to /usr/local

2019-04-26  Eneas U de Queiroz  <cote2004-github@yahoo.com>  (tiny change)

	* src/openssl.c: fix ssl_init for openssl 1.1.1
	ssl_init fails with openssl 1.1.1 when openssl.cnf is not found.
	Redundant calls to intialization functions were removed as
	OPENSSL_config takes care of them for openssl versions < 1.1.0.
	For versions > 1.1.0, OPENSSL_init_ssl is preferred.

2019-04-11  Leif Ryge  <leif@synthesize.us>  (tiny change)

	* doc/wget.texi: Fix typo in man page

2019-04-11  raminfp  <ramin.blackhat@gmail.com>

	[log] miss check If logging is inhibited

2019-04-05  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/iri.c (do_conversion): Remove unneeded debug lines

2019-04-05  Darshit Shah  <darnir@gnu.org>

	* NEWS: Update NEWS for new release

2019-04-05  Tim Ruehsen  <tim.ruehsen@gmx.de>

	Fix a buffer overflow vulnerability
	* src/iri.c(do_conversion): Reallocate the output buffer to a larger
	  size if it is already full

2019-04-05  Darshit Shah  <darnir@gnu.org>

	* NEWS: Update NEWS for new release

2019-04-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/openssl.c (ssl_init): Check for X509_V_FLAG_PARTIAL_CHAIN

2019-04-01  Darshit Shah  <darnir@gnu.org>

	* gnulib: Pull forward

2019-03-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	* fuzz/main.c (test_all_from): Fix indentation

2019-03-25  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix corner case in processing server response
	* src/http.c (response_head_terminator): Don't access uninitialized data
	* fuzz/wget_read_hunk_fuzzer.c: Sync response_head_terminator()

	Add new fuzzer wget_read_hunk_fuzzer.c
	* fuzz/Makefile.am: Add wget_read_hunk_fuzzer
	* fuzz/wget_read_hunk_fuzzer.c: New file
	* fuzz/wget_read_hunk_fuzzer.in/*: Fuzz corpora
	* src/connect.c: Add connect_cleanup()
	* src/connect.h: Add prototype for connect_cleanup()

2019-03-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	* fuzz/wget_netrc_fuzzer.c: Fix fuzzer

	* fuzz/wget_ftpls_fuzzer.c: Fix fuzzer

2019-02-22  Jeffrey Walton  <noloader@gmail.com>

	* src/openssl.c (ssl_init): Trust partial cert chain

2019-02-20  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/ftp-ls.c (ftp_parse_vms_ls): Use snprintf instead of strcpy/strcat

2019-02-19  Darshit Shah  <darnir@gnu.org>

	* src/html-url.c(get_urls_html_fm): Add message in verbose mode with no-follow attribute

2019-02-19  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix fuzz/ tests for OpenBSD
	* fuzz/wget_*_fuzzer.c: Take care when calling exit()

	* fuzz/Makefile.am: Remove hard-coded gcc flags

	Fix STDERR closing/restoring in fuzzers
	* fuzz/fuzzer.h: Add CLOSE_STDERR and RESTORE_STDERR
	* fuzz/wget_*_fuzzer.c: Use CLOSE_STDERR and RESTORE_STDERR

	* configure.ac: Rearrange AM_ICONV before gl_INIT

2019-02-19  Tim Rühsen  <tim.ruehsen@gmx.de>

	Do not hard-code -ldl in fuzz/Makefile.am
	* configure.ac: Search for dlopen and add library to $FUZZ_LIBS
	* fuzz/Makefile.am: Link with $FUZZ_LIBS instead of -ldl

	This fixes linking on BSD systems.

	Reported-by: Nam Nguyen

2019-02-14  Tim Rühsen  <tim.ruehsen@gmx.de>

	* doc/wget.texi: Correct --logfile -> --output-file

2019-02-10  Darshit Shah  <darnir@gnu.org>

	Update gnulib

	Update copyright statements

2019-01-23  Leon Klingele  <git@leonklingele.de>  (tiny change)

	docs: --no-cache also sets the 'Cache-Control: no-cache' header
	* doc/wget.texi: Add Cache-Control to docs
	* src/wget.h: Add Cache-Control to comment of SEND_NOCACHE

2019-01-20  Tim Rühsen  <tim.ruehsen@gmx.de>

	* .gitlab-ci.yml: Add minimal build

	* src/init.c (cleanup): Check HAVE_HSTS
	Reported-by: Simon Dales

2018-12-31  André Wolski  <andre@dena-design.de>

	NTLM restart authentication (trivial change)
	* src/http-ntlm.c (ntlm_input): Continue on NTLMSTATE_LAST,
	  error on NTLMSTATE_TYPE3

	The code comes from the cURL project. Thanks to Daniel Stenberg
	for donating the code.

	https://lists.gnu.org/archive/html/bug-wget/2018-12/msg00030.html

2018-12-28  Tim Rühsen  <tim.ruehsen@gmx.de>

	* contrib/spell-checker: Remove trailing whitespace

	Fix typos detected by codespell (via contrib/spell-checker)

	* contrib/spell-checker: Add script for spell checking

2018-12-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	* fuzz/Makefile.am: Fix order of libraries for linking

	* src/wget.h: #undef _Noreturn when building with C++

	* src/gnutls.c (ssl_connect_wget): Fix call to gnutls_set_default_priority()

2018-12-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	* NEWS: Add release changes for 1.20.1

2018-12-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	Don't save user/pw with --xattr
	Also the Referer info is reduced to scheme+host+port.

	* src/ftp.c (getftp): Change params of set_file_metadata()
	* src/http.c (gethttp): Change params of set_file_metadata()
	* src/xattr.c (set_file_metadata): Remove user/password from origin URL,
	  reduce Referer value to scheme/host/port.
	* src/xattr.h: Change prototype of set_file_metadata()

2018-12-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	Don't use extended attributes (--xattr) by default
	* src/init.c (defaults): Set enable_xattr to false by default
	* src/main.c (print_help): Reverse option logic of --xattr
	* doc/wget.texi: Add description for --xattr

	Users may not be aware that the origin URL and Referer are saved
	including credentials, and possibly access tokens within
	the urls.

2018-12-13  Tim Rühsen  <tim.ruehsen@gmx.de>

	* .travis.yml: Email to wget-dev instead bug-wget mailing list

2018-11-30  Darshit Shah  <darnir@gnu.org>

	* NEWS: Prepare for new version

2018-11-13  Darshit Shah  <darnir@gnu.org>

	* contrib/make-release: Add a small checklist for pending tasks

	Prepare NEWS for new release

	* configure.ac: gnulib now expects autoconf >=2.63

	* gnulib: Update library

2018-11-13  Jay Satiro  <raysatiro@yahoo.com>

	* src/init.c: Stop freeing the pointer returned by ws_mypath()
	.. since ws_mypath() saves the address it returns in a static pointer
	for reuse, to also be returned in later calls.

2018-11-13  Darshit Shah  <darnir@gnu.org>

	* src/ftp.c(ftp_retrieve_glob): Honor {accept,reject}-regex switches as well

	* src/ftp.c (ftp_retrieve_glob): Refactor to prevent looping over listing multiple times

2018-11-11  Tim Rühsen  <tim.ruehsen@gmx.de>

	* .gitlab-ci.yml: Split into GnuTLS and OpenSSL build

	* Makefile.am: dist clean po/stamp-po

	Remove auto-generated files from po/

	Add VPATH build

2018-11-09  Tim Rühsen  <tim.ruehsen@gmx.de>

	Revert "Bail out on unexpected 416 server errors"
	This reverts commit 6f3b9959935ad7640bcf48a0a93848ed25ff8963.

	The code is obviously wrong, see https://savannah.gnu.org/bugs/?54963
	Also, the example from the original post doesn't work any more.
	With other words, the broken server behavior has been fixed meanwhile.

2018-11-09  Rosen Penev  <rosenp@gmail.com>  (tiny change)

	openssl: Do not use engines when OpenSSL does not support
	* src/openssl.c: Check for OPENSSL_NO_ENGINE before
	 including openssl/engine.h and before calling ENGINE_load_builtin_engines()

	Fixes compilation with no engines compiled.

2018-11-09  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix HTTPS Perl tests
	* tests/SSLTest.pm: Rename server cert and key file
	* tests/Test-https*.px: Fix and remove OpenSSL hard-coding
	* tests/certs/create-certs.sh: Script to generate test files
	* tests/certs/*-template.txt: GnuTLS template files for certs and crl
	* tests/certs/*.pem: Keys, certs, crls
	* tests/certs/README: Removed commands, link to create-certs.sh

2018-10-28  Kapus, Timotej  <timotej.kapus13@imperial.ac.uk>  (tiny change)

	Replace some loops with string.h functions
	* src/init.c: Replace loop with strspn
	* src/url.c: Replace loop with strrchr

2018-10-26  Luiz Angelo Daros de Luca  <luizluca@gmail.com>  (tiny change)

	* .gitmodules: Use https:// instead of git:// for gnulib
	git:// does not work over http proxy

	* src/host.c (sufmatch): Fix dot-prefixed domain matching
	Current sufmatch does not match when domain is dot-prefixed.
	The example of no_proxy in man (.mit.edu) does use a dot-prefixed
	domain.

2018-10-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/convert.c (convert_links): Fix fallthrough

2018-10-22  Darshit Shah  <darnir@gnu.org>

	* bootstrap: Update script from gnulib

	* gnulib: Update library

2018-10-19  Tim Rühsen  <tim.ruehsen@gmx.de>

	* .lgtm.yml: New file to add LGTM to Gitlab.com CI

2018-10-16  Tim Rühsen  <tim.ruehsen@gmx.de>

	* configure.ac: Fix build issue with libgpgme

2018-10-14  Tim Rühsen  <tim.ruehsen@gmx.de>

	* fuzz/*_fuzzer.in/*: Update fuzzer corpora

2018-10-08  Nikos Mavrogiannopoulos  <nmav@redhat.com>

	Enable post-handshake auth under gnutls on TLS1.3

2018-09-20  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http.c (resp_new): Fix code to avoid false positive by clang

	* src/convert.c (convert_links): Fix code to avoid false positive by clang

2018-09-19  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add support for PCRE2 pattern matching
	* configure.ac: Check for libpcre2-8
	* src/init.c (choices): Test for HAVE_LIBPCRE2
	* src/main.c (main): Set regex compile and match functions
	* src/options.h: Test for HAVE_LIBPCRE2
	* src/utils.c: Include pcre2.h, add functions
	  compile_pcre2_regex() and match_pcre2_regex()
	* src/utils.h: Declare compile_pcre2_regex() and match_pcre2_regex()

	Fixes #54677
	Reported-by: Noël Köthe

2018-09-07  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add . to perl path for all perl tests
	* tests/*.px: Add -I . to the shebang

	This allows perl test to be run from tests/ directory, e.g. via
	  ./Test--post-file.px

2018-09-07  Tomas Hozza  <thozza@redhat.com>

	Add TLS 1.3 support for GnuTLS
	* doc/wget.texi: Add "TLSv1_3" to --secure-protocol
	* src/gnutls.c (set_prio_default): Use GNUTLS_TLS1_3 where needed

	Wget currently allows specifying "TLSv1_3" as the parameter for
	--secure-protocol option. However it is only implemented for OpenSSL
	and in case wget is compiled with GnuTLS, it causes wget to abort with:
	GnuTLS: unimplemented 'secure-protocol' option value 6

	GnuTLS contains TLS 1.3 implementation since version 3.6.3 [1]. However
	currently it must be enabled explicitly in the application of it to be
	used. This will change after the draft is finalized. [2] However for
	the time being, I enabled it explicitly in case "TLSv1_3" is used with
	--secure-protocol.

	I also fixed man page to contain "TLSv1_3" in all listings of available
	parameters for --secure-protocol

	[1] https://lists.gnupg.org/pipermail/gnutls-devel/2018-July/008584.html
	[2] https://nikmav.blogspot.com/2018/05/gnutls-and-tls-13.html

2018-08-29  Tomas Korbar  <tkorbar@redhat.com>

	Avoid creating empty wget-log when using -O and -q in background
	* src/log.c (check_redirect_output): Check for quiet mode

2018-08-27  Tomas Hozza  <thozza@redhat.com>

	* src/warc.c (warc_write_cdx_record): Fix RESOURCE LEAK found by Coverity
	Error: RESOURCE_LEAK (CWE-772): - REAL ERROR
	wget-1.19.5/src/warc.c:1376: alloc_fn: Storage is returned from allocation function "url_escape".
	wget-1.19.5/src/url.c:284:3: alloc_fn: Storage is returned from allocation function "url_escape_1".
	wget-1.19.5/src/url.c:255:3: alloc_fn: Storage is returned from allocation function "xmalloc".
	wget-1.19.5/lib/xmalloc.c:41:11: alloc_fn: Storage is returned from allocation function "malloc".
	wget-1.19.5/lib/xmalloc.c:41:11: var_assign: Assigning: "p" = "malloc(n)".
	wget-1.19.5/lib/xmalloc.c:44:3: return_alloc: Returning allocated memory "p".
	wget-1.19.5/src/url.c:255:3: var_assign: Assigning: "newstr" = "xmalloc(newlen + 1)".
	wget-1.19.5/src/url.c:258:3: var_assign: Assigning: "p2" = "newstr".
	wget-1.19.5/src/url.c:275:3: return_alloc: Returning allocated memory "newstr".
	wget-1.19.5/src/url.c:284:3: return_alloc_fn: Directly returning storage allocated by "url_escape_1".
	wget-1.19.5/src/warc.c:1376: var_assign: Assigning: "redirect_location" = storage returned from "url_escape(redirect_location)".
	wget-1.19.5/src/warc.c:1381: noescape: Resource "redirect_location" is not freed or pointed-to in "fprintf".
	wget-1.19.5/src/warc.c:1387: leaked_storage: Returning without freeing "redirect_location" leaks the storage that it points to.
	\# 1385|     fflush (warc_current_cdx_file);
	\# 1386|
	\# 1387|->   return true;
	\# 1388|   }
	\# 1389|

	url_escape() really returns a newly allocated memory and it leaks when the warc_write_cdx_record() returns. The memory returned from url_escape() is usually stored in a temporary variable in other parts of the project and then freed. I took the same approach.

2018-08-27  Tomas Hozza  <thozza@redhat.com>

	* src/warc.c (warc_write_start_record): Fix potential RESOURCE LEAK
	In warc_write_start_record() function, the reutrn value of dup() is
	directly used in gzdopen() call and not stored anywhere. However the
	zlib documentation says that "The duplicated descriptor should be saved
	to avoid a leak, since gzdopen does not close fd if it fails." [1].
	This change stores the FD in a variable and closes it in case gzopen()
	fails.

	[1] https://www.zlib.net/manual.html

	Error: RESOURCE_LEAK (CWE-772):
	wget-1.19.5/src/warc.c:217: open_fn: Returning handle opened by "dup".
	wget-1.19.5/src/warc.c:217: leaked_handle: Failing to save or close handle opened by "dup(fileno(warc_current_file))" leaks it.
	\#  215|
	\#  216|         /* Start a new GZIP stream. */
	\#  217|->       warc_current_gzfile = gzdopen (dup (fileno (warc_current_file)), "wb9");
	\#  218|         warc_current_gzfile_uncompressed_size = 0;
	\#  219|

2018-08-27  Tomas Hozza  <thozza@redhat.com>

	* src/utils.c (open_stat): Fix RESOURCE LEAK found by Coverity
	Error: RESOURCE_LEAK (CWE-772):
	wget-1.19.5/src/utils.c:914: open_fn: Returning handle opened by "open". [Note: The source code implementation of the function has been overridden by a user model.]
	wget-1.19.5/src/utils.c:914: var_assign: Assigning: "fd" = handle returned from "open(fname, flags, mode)".
	wget-1.19.5/src/utils.c:921: noescape: Resource "fd" is not freed or pointed-to in "fstat". [Note: The source code implementation of the function has been overridden by a builtin model.]
	wget-1.19.5/src/utils.c:924: leaked_handle: Handle variable "fd" going out of scope leaks the handle.
	\#  922|     {
	\#  923|       logprintf (LOG_NOTQUIET, _("Failed to stat file %s, error: %s\n"), fname, strerror(errno));
	\#  924|->     return -1;
	\#  925|     }
	\#  926|   #if !(defined(WINDOWS) || defined(__VMS))

	This seems to be a real issue, since the opened file descriptor in "fd"
	would leak. There is also additional check below the "fstat" call, which
	closes the opened "fd".

2018-08-27  Tomas Hozza  <thozza@redhat.com>

	* src/http.c (http_loop): Fix RESOURCE LEAK found by Coverity
	Error: RESOURCE_LEAK (CWE-772):
	wget-1.19.5/src/http.c:4486: alloc_fn: Storage is returned from allocation function "url_string".
	wget-1.19.5/src/url.c:2248:3: alloc_fn: Storage is returned from allocation function "xmalloc".
	wget-1.19.5/lib/xmalloc.c:41:11: alloc_fn: Storage is returned from allocation function "malloc".
	wget-1.19.5/lib/xmalloc.c:41:11: var_assign: Assigning: "p" = "malloc(n)".
	wget-1.19.5/lib/xmalloc.c:44:3: return_alloc: Returning allocated memory "p".
	wget-1.19.5/src/url.c:2248:3: var_assign: Assigning: "result" = "xmalloc(size)".
	wget-1.19.5/src/url.c:2248:3: var_assign: Assigning: "p" = "result".
	wget-1.19.5/src/url.c:2250:3: noescape: Resource "p" is not freed or pointed-to in function "memcpy". [Note: The source code implementation of the function has been overridden by a builtin model.]
	wget-1.19.5/src/url.c:2253:7: noescape: Resource "p" is not freed or pointed-to in function "memcpy". [Note: The source code implementation of the function has been overridden by a builtin model.]
	wget-1.19.5/src/url.c:2257:11: noescape: Resource "p" is not freed or pointed-to in function "memcpy". [Note: The source code implementation of the function has been overridden by a builtin model.]
	wget-1.19.5/src/url.c:2264:3: noescape: Resource "p" is not freed or pointed-to in function "memcpy". [Note: The source code implementation of the function has been overridden by a builtin model.]
	wget-1.19.5/src/url.c:2270:7: identity_transfer: Passing "p" as argument 1 to function "number_to_string", which returns an offset off that argument.
	wget-1.19.5/src/utils.c:1776:11: var_assign_parm: Assigning: "p" = "buffer".
	wget-1.19.5/src/utils.c:1847:3: return_var: Returning "p", which is a copy of a parameter.
	wget-1.19.5/src/url.c:2270:7: noescape: Resource "p" is not freed or pointed-to in function "number_to_string".
	wget-1.19.5/src/utils.c:1774:25: noescape: "number_to_string(char *, wgint)" does not free or save its parameter "buffer".
	wget-1.19.5/src/url.c:2270:7: var_assign: Assigning: "p" = "number_to_string(p, url->port)".
	wget-1.19.5/src/url.c:2273:3: noescape: Resource "p" is not freed or pointed-to in function "full_path_write".
	wget-1.19.5/src/url.c:1078:47: noescape: "full_path_write(struct url const *, char *)" does not free or save its parameter "where".
	wget-1.19.5/src/url.c:2287:3: return_alloc: Returning allocated memory "result".
	wget-1.19.5/src/http.c:4486: var_assign: Assigning: "hurl" = storage returned from "url_string(u, URL_AUTH_HIDE_PASSWD)".
	wget-1.19.5/src/http.c:4487: noescape: Resource "hurl" is not freed or pointed-to in "logprintf".
	wget-1.19.5/src/http.c:4513: leaked_storage: Variable "hurl" going out of scope leaks the storage it points to.
	\# 4511|               {
	\# 4512|                 printwhat (count, opt.ntry);
	\# 4513|->               continue;
	\# 4514|               }
	\# 4515|             else

	There are two conditional branches, which call continue, without freeing memory potentially allocated and pointed to by"hurl" pointer. In fase "!opt.verbose" is True and some of the appropriate conditions in the following if/else if construction, in which "continue" is called, are also true, then the memory allocated to "hurl" will leak.

2018-08-27  Tomas Hozza  <thozza@redhat.com>

	* src/http.c (check_auth): Fix RESOURCE LEAK found by Coverity
	Error: RESOURCE_LEAK (CWE-772):
	wget-1.19.5/src/http.c:2434: alloc_fn: Storage is returned from allocation function "xmalloc".
	wget-1.19.5/lib/xmalloc.c:41:11: alloc_fn: Storage is returned from allocation function "malloc".
	wget-1.19.5/lib/xmalloc.c:41:11: var_assign: Assigning: "p" = "malloc(n)".
	wget-1.19.5/lib/xmalloc.c:44:3: return_alloc: Returning allocated memory "p".
	wget-1.19.5/src/http.c:2434: var_assign: Assigning: "auth_stat" = storage returned from "xmalloc(4UL)".
	wget-1.19.5/src/http.c:2446: noescape: Resource "auth_stat" is not freed or pointed-to in "create_authorization_line".
	wget-1.19.5/src/http.c:5203:70: noescape: "create_authorization_line(char const *, char const *, char const *, char const *, char const *, _Bool *, uerr_t *)" does not free or save its parameter "auth_err".
	wget-1.19.5/src/http.c:2476: leaked_storage: Variable "auth_stat" going out of scope leaks the storage it points to.
	\# 2474|                 /* Creating the Authorization header went wrong */
	\# 2475|               }
	\# 2476|->         }
	\# 2477|         else
	\# 2478|           {

	Error: RESOURCE_LEAK (CWE-772):
	wget-1.19.5/src/http.c:2431: alloc_fn: Storage is returned from allocation function "url_full_path".
	wget-1.19.5/src/url.c:1105:19: alloc_fn: Storage is returned from allocation function "xmalloc".
	wget-1.19.5/lib/xmalloc.c:41:11: alloc_fn: Storage is returned from allocation function "malloc".
	wget-1.19.5/lib/xmalloc.c:41:11: var_assign: Assigning: "p" = "malloc(n)".
	wget-1.19.5/lib/xmalloc.c:44:3: return_alloc: Returning allocated memory "p".
	wget-1.19.5/src/url.c:1105:19: var_assign: Assigning: "full_path" = "xmalloc(length + 1)".
	wget-1.19.5/src/url.c:1107:3: noescape: Resource "full_path" is not freed or pointed-to in function "full_path_write".
	wget-1.19.5/src/url.c:1078:47: noescape: "full_path_write(struct url const *, char *)" does not free or save its parameter "where".
	wget-1.19.5/src/url.c:1110:3: return_alloc: Returning allocated memory "full_path".
	wget-1.19.5/src/http.c:2431: var_assign: Assigning: "pth" = storage returned from "url_full_path(u)".
	wget-1.19.5/src/http.c:2446: noescape: Resource "pth" is not freed or pointed-to in "create_authorization_line".
	wget-1.19.5/src/http.c:5203:40: noescape: "create_authorization_line(char const *, char const *, char const *, char const *, char const *, _Bool *, uerr_t *)" does not free or save its parameter "path".
	wget-1.19.5/src/http.c:2476: leaked_storage: Variable "pth" going out of scope leaks the storage it points to.
	\# 2474|                 /* Creating the Authorization header went wrong */
	\# 2475|               }
	\# 2476|->         }
	\# 2477|         else
	\# 2478|           {

	Both "pth" and "auth_stat" are allocated in "check_auth()" function. These are used for creating the HTTP Authorization Request header via "create_authorization_line()" function. In case the creation went OK (auth_err == RETROK), then the memory previously allocated to "pth" and "auth_stat" is freed. However if the creation failed, then the memory is never freed and it leaks.

2018-08-27  Tomas Hozza  <thozza@redhat.com>

	* src/ftp.c (getftp): Fix RESOURCE LEAK found by Coverity
	Error: RESOURCE_LEAK (CWE-772):
	wget-1.19.5/src/ftp.c:1493: alloc_fn: Storage is returned from allocation function "fopen".
	wget-1.19.5/src/ftp.c:1493: var_assign: Assigning: "fp" = storage returned from "fopen(con->target, "wb")".
	wget-1.19.5/src/ftp.c:1811: leaked_storage: Variable "fp" going out of scope leaks the storage it points to.
	\# 1809|     if (fp && !output_stream)
	\# 1810|       fclose (fp);
	\# 1811|->   return err;
	\# 1812|   }
	\# 1813|

	It can happen, that "if (!output_stream || con->cmd & DO_LIST)" on line #1398 can be true, even though "output_stream != NULL". In this case a new file is opened to "fp". Later it may happen in the FTPS branch, that some error will occure and code will jump to label "exit_error". In "exit_error", the "fp" is closed only if "output_stream == NULL". However this may not be true as described earlier and "fp" leaks.

	On line #1588, there is the following conditional free of "fp":

	  /* Close the local file.  */
	  if (!output_stream || con->cmd & DO_LIST)
	    fclose (fp);

	Therefore the conditional at the end of the function after "exit_error" label should be modified to:

	  if (fp && (!output_stream || con->cmd & DO_LIST))
	    fclose (fp);

	This will ensure that "fp" does not leak in any case it sould be opened.

2018-08-11  Tomas Hozza  <thozza@redhat.com>

	Don't limit the test suite HTTPS server to TLSv1
	In Fedora, we are implementing crypto policies, in order to enhance the
	security of user systems. This is done on the system level by global
	configuration. It may happen that due to the active policy, only
	TLSv1.2 or higher will be available in crypto libraries. While wget as
	a client will by default determine the minimal TLS version supported by
	both client and server, the HTTPS server implementation in testenv/
	hardcodes use of TLSv1. As a result all HTTPS related tests fail in
	case a more hardened crypto policy is set on the Fedora system.

	This change removes the explicit TLS version setting and leaves the
	determination of the minimal supported TLS version on the server and
	client.

	More information about Fedora change can be found here:
	https://fedoraproject.org/wiki/Changes/StrongCryptoSettings

2018-06-13  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/gnutls.c (ssl_check_certificate): Fix grammar of error msg
	Reported-by: Nicholas Sielicki

	* fuzz/Makefile.am: Remove libtool LTLIB... from LDADD

	* src/http.c (http_loop): Fix --retry-on-host-error

2018-06-13  ethus3h  <kolubat@gmail.com>  (tiny change)

	Add new option --retry-on-host-error
	* doc/wget.texi: Add docs for --retry-on-host-error
	* src/http.c (http_loop): Add code for HOSTERR
	* src/init.c: Add option --retry-on-host-error
	* src/main.c: Likewise
	* src/options.h: Add options.retry_on_host_error

2018-05-29  Tim Rühsen  <tim.ruehsen@gmx.de>

	Save original data to WARC file
	* src/retr.c (write_data): Cleanup,
	  (fd_read_body): Write to WARC before uncompressing

	Fixes: #53968

2018-05-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	* fuzz/get_ossfuzz_corpora: Speed up corpora download

2018-05-09  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/main.c (print_version): Silence UBSAN message

	* src/utils.ci (file_exists_p): Fix stat(NULL,...)

	* src/hsts.c (open_hsts_test_store): Fix unlink(NULL)

	* src/hash.c: Silence UBSAN for hash functions

	* fuzz/*_fuzzer.in: Update corpora from OSS-Fuzz

	* fuzz/get_ossfuzz_corpora: Fix path

2018-05-08  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/hsts.h: Fix header guard

	* src/version.h: Add header guard

	* src/host.c (wait_ares): Remove void assignment
	Reported-by: Josef Moellers

2018-05-06  Tim Rühsen  <tim.ruehsen@gmx.de>

	Update NEWS file for new release

2018-05-06  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix cookie injection (CVE-2018-0494)
	* src/http.c (resp_new): Replace \r\n by space in continuation lines

	Fixes #53763
	 "Malicious website can write arbitrary cookie entries to cookie jar"

	HTTP header parsing left the \r\n from continuation line intact.
	The Set-Cookie code didn't check and could be tricked to write
	\r\n into the cookie jar, allowing a server to generate cookies at will.

2018-05-06  Tim Rühsen  <tim.ruehsen@gmx.de>

	* tests/Test-https-weboftrust.px: Skip test, needs cert regen

	Fix make syntax-check
	* cfg.mk: Add fuzzer reproducers to exception list
	* po/POTFILES.in: Add src/spider.c

	Fix HTTPS tests
	* tests/Test-https-badcerts.px: Fix test return value
	* tests/Test-https-crl.px: Likewise
	* README: How to create certs with GnuTLS's certtool
	* tests/certs/revokedcrl.pem: Recreated revocation
	* tests/certs/server.crt: Recreated server cert with no expiry
	* tests/certs/test-ca-cert.pem: Recreated CA cert with no expiry

	* src/init.c: Bring new --ciphers into right order in options array

2018-05-05  Ander Juaristi  <a@juaristi.eus>

	* doc/wget.texi: Add description for --ciphers

2018-05-05  Ander Juarist  <a@juaristi.eus>

	OpenSSL: Better seeding of PRNG
	 * src/openssl.c (init_prng): keep gathering entropy even though we
	                              already have enough
	   (ssl_connect_with_timeout_callback): reseed PRNG again just before
	                                        the handshake

	Reported-by: Jeffrey Walton <noloader@gmail.com>

2018-05-05  Ander Juaristi  <a@juaristi.eus>

	Enhance SSL/TLS security
	This commit hardens SSL/TLS a bit more in the following ways:

	 * Explicitly exclude NULL authentication and the 'MEDIUM' cipher list
	   category. Ciphers in the 'HIGH' level are only considered - this
	   includes all symmetric ciphers with key lengths larger than 128 bits,
	   and some ('modern') 128-bit ciphers, such as AES in GCM mode.
	 * Allow RSA key exchange by default, but exclude it when
	   Perfect Forward Secrecy is desired (with --secure-protocol=PFS).
	 * Introduce new option --ciphers to set the cipher list that the SSL/TLS
	   engine will favor. This string is fed directly to the underlying TLS
	   library (GnuTLS or OpenSSL) without further processing, and hence its
	   format and syntax are directly dependent on the specific library.

	Reported-by: Jeffrey Walton <noloader@gmail.com>

2018-04-28  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/netrc.c (parse_netrc_fp): Fix two memleaks

	Add new fuzzer for the .netrc parser
	* fuzz/wget_netrc_fuzzer.c: New fuzzer
	* fuzz/wget_netrc_fuzzer.dict: Fuzzer dictionary
	* fuzz/wget_netrc_fuzzer.in: Initial corpora
	* src/ftp.c (getftp): Amend call to search_netrc()
	* src/http.c (initialize_request): Likewise
	* src/netrc.c: Cleanup, prepare code for fuzzing
	* src/netrc.h: Cleanup

2018-04-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/utils.c (match_tail): Fix unsigned integer overflow

	Add new fuzzer for the Set-Cookie parser
	* fuzz/Makefile.am: Add wget_cookie_fuzzer
	* fuzz/wget_cookie_fuzzer.c: New fuzzer
	* fuzz/wget_cookie_fuzzer.dict: Fuzzers dictionary
	* fuzz/wget_cookie_fuzzer.in: Initial corpora

2018-04-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix buffer overflow in CSS parser
	* src/css-url.c (get_uri_string): Check input length
	* fuzz/wget_css_fuzzer.repro/buffer-overflow-6600180399865856:
	  Add reproducer corpus

	Fixes OSS-Fuzz issue #8033.
	This is a long standing bug affecting all versions <= 1.19.4.

2018-04-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix buffer overflow in CSS parser
	* src/css-url.c (get_urls_css): Check input string length
	* fuzz/wget_css_fuzzer.repro/negative-size-param-5724866467594240:
	  Add reproducer corpus

	Fixes OSS-Fuzz issue #8032.
	This is a long standing bug affecting all versions <= 1.19.4.

2018-04-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	Exclude fuzz corpora from tarball
	* fuzz/Makefile.am: Do not include corpora in tarball
	* fuzz/main.c: SKIP if corpora directory isn't found (make check)

	The fuzz corpora are thousands of files, not needed for a standard build
	from a distribution tarball. The reproducers of former issues are being
	included for regression testing.

2018-04-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	* tests/Makefile.am: Add -I/src to AM_CPPFLAGS

2018-04-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add CSS slowness reproducer (fixed)
	* fuzz/wget_css_fuzzer.repro/slowness-6275836549267456: New file

	This file created an extreme CPU usage with the old CSS parser.

2018-04-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	Update CSS grammar from 1.x to 2.2
	* src/css-tokens.h: Add enums and fixate values
	* src/css.l: Include config.h,
	  ignore several compiler warnings,
	  update the grammar to CSS 2.2

	Fixes OSS-Fuzz issue #8010 (slowness issue).
	This is a long standing bug affecting all versions <= 1.19.4.

	Some crafted CSS input was extremely slow / CPU wasting, so it could
	be used as a DOS attack against website scanning.

	The code/grammar changes were backported from Wget2.x.

2018-04-25  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/res.c (add_path): Fix memleak (parsing robots.txt)
	Fixes OSS-Fuzz issue #8005.
	This is a long standing bug affecting all versions <= 1.19.4.

	* src/ftp-ls.c (ftp_parse_winnt_ls): Fix integer overflow
	Fixes OSS-Fuzz issue #7999.
	This is a long standing bug affecting all versions <= 1.19.4.

2018-04-24  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add new fuzzer for the URL parser
	* fuzz/Makefile.am: Add wget_url_fuzzer
	* fuzz/wget_url_fuzzer.c: New fuzzer
	* fuzz/wget_url_fuzzer.in: Initial corpora

	Add new fuzzer for robots.txt parsing
	* fuzz/Makefile.am: Add wget_robots_fuzzer
	* fuzz/wget_robots_fuzzer.c: New fuzzer
	* fuzz/wget_robots_fuzzer.in: Initial corpora

	* fuzz/README.md: Add CFLAGS for undefined sanitizer

	* src/ftp-ls.c (ftp_parse_winnt_ls): Fix integer overflow

	* src/ftp-ls.c (ftp_parse_vms_ls): Fix integer overflow by left shift

	* src/ftp-ls.c (ftp_parse_unix_ls): Fix integer overflow in date parsing

2018-04-22  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/ftp-ls.c (ftp_parse_winnt_ls): Fix heap-buffer-overflow
	Fixes OSS-Fuzz issue #7931.
	This is a long standing bug affecting all versions <= 1.19.4.

	* src/ftp-ls.c (ftp_parse_winnt_ls): Fix heap-buffer-overflow
	Fixes OSS-Fuzz issue #7930.
	This is a long standing bug affecting all versions <= 1.19.4.

	* fuzz/wget_ftpls_fuzzer.in: Update corpora

2018-04-21  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/ftp-ls.c (eat_carets): Fix heap-buffer-overflow

	* src/ftp-ls.c (ftp_parse_winnt_ls): Fix memleak

	* src/ftp-ls.c (ftp_parse_vms_ls): Fix heap-buffer-overflow

	* src/ftp-ls.c (ftp_parse_vms_ls): Fix heap-buffer-overflow

	* src/ftp-ls.c (ftp_parse_vms_ls): Fix memleak

	Add new fuzzer for the FTP listing parsers
	* fuzz/Makefile.am: Add wget_ftpls_fuzzer
	* fuzz/wget_ftpls_fuzzer.c: New fuzzer
	* fuzz/wget_ftpls_fuzzer.dict: Fuzzer dictionary
	* fuzz/wget_ftpls_fuzzer.in/starter: Starting corpus
	* src/ftp-ls.c: Parsing function take FILE * as argument,
	  new function ftp_parse_ls_fp()
	* src/ftp.c: Remove static from freefileinfo()
	* src/ftp.h: Add ftp_parse_ls_fp() and freefileinfo()

	* fuzz/run-clang.sh: Remove -detect_leaks=0 from fuzzer command line

	* src/main.c (main): Fix memleak for fuzzing/testing

	* src/init.c: Fix fuzzing in case ~/.wgetrc doesn't exist

2018-04-20  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix fuzzer build for C++
	* fuzz/wget_css_fuzzer.c: Include wget.h outside 'extern "C"',
	  undef fopen_wgetrc directly after wget.h
	* fuzz/wget_html_fuzzer.c: Likewise

	* fuzz/Makefile.am: Add -I/lib to oss-fuzz builds

	Add new HTML parser fuzzer
	* fuzz/Makefile.am: Add wget_html_fuzzer
	* fuzz/wget_html_fuzzer.c: New fuzzer
	* fuzz/wget_html_fuzzer.dict: HTML dictionary for fuzzing
	* fuzz/wget_html_fuzzer.in: Initial corpora
	* src/html-url.c: Add new function get_urls_html_fm()
	* src/html-url.h: Add ne function get_urls_html_fm()
	* src/wget.h: Fix define for fopen_wgetrc()

	* fuzz/wget_css_fuzzer.c: Fix build

	* fuzz/wget_css_fuzzer.in/*: Update fuzzer corpora

	* src/css-url.c (get_uri_string): Fix buffer overflow (read)

	* src/iri.h: Fix C++ compile error

2018-04-19  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http.c: Download and scan CSS files in spider mode

	* src/css-url.c (get_urls_css): Call yylex_destroy() to reset CSS scanner

	Add new fuzzer wget_css_fuzzer.c
	* fuzz/Makefile.am: Add wget_css_fuzzer.c
	* fuzz/wget_css_fuzzer.c: New fuzzer

2018-04-18  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/html-url.h: Include needed header files

	* wget_options_fuzzer.in/*: Update fuzzer corpora

	* fuzz/README.md: Add CXXFLAGS and more configure options

	Fix oss-fuzz issue with exit()
	* src/wget.h: Define exit() as exit_wget()
	* fuzz/wget_options_fuzzer.c: Implement exit_wget() and cleanup

2018-04-17  Tim Rühsen  <tim.ruehsen@gmx.de>

	* fuzz/wget_options_fuzzer.c: Declare fopen_* as C functions

	Fix fopen/stdin issues with fuzzing
	* fuzz/wget_options_fuzzer.c: Add fopen_wget() and fopen_wgetrc()
	* src/utils.c: Use fopen_wgetrc() for config files,
	  don't read from stdin when fuzzing
	* src/wget.h: Define fopen as fopen_wget when fuzzing,
	  define fopen_wgetrc as fopen when not fuzzing

	* configure.ac: AC_DEFINE FUZZING if --enable-fuzzing was given

	* fuzz/wget_options_fuzzer.c: Write fuzzer crash reports

	* src/log.c: Don't check_redirect_output() when fuzzing

	* src/main.c (promt_for_password): Avoid getpass() when fuzzing

	Fix double fclose() with -d while fuzzing
	* src/ftp.c (ftp_loop_internal): Set warc_tmp to NULL after ffclose()
	* src/init.c (cleanup): Set output_stream to NULL after fclose()
	* src/log.c (log_close): Set global stream vars to NULL after closing
	* src/recur.c (retrieve_tree): Set rejectedlog to NULL after closing
	* src/warc.c (warc_close): Set stream vars to NULL after closing

	* src/main.c (main): Don't background if TESTING

	* src/init.c (initialize): Return error, don't exit()

2018-04-16  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/init.c (cmd_use_askpass): Return false on error

	* src/utils.c (compile_posix_regex): Hard-code string to regcomp
	regcomp() may be too cpu + memory intensive for fuzzing.
	See https://sourceware.org/glibc/wiki/Security%20Exceptions

	Fix 2 more memleaks
	* src/init.c (initialize): Use global var for wgetrc filename
	* src/iri.c (find_locale): Return strdup'ed locale string
	* src/options.h (struct options): Add wgetrcfile

	* src/init.c (cleanup): Set output_stream to NULL after closing

	Fix homedir memory leaks
	* src/hsts.c: Use opt.homedir
	* src/init.c: Likewise
	* src/main.c: Likewise
	* src/netrc.c: Likewise
	* src/options.h (struct options): Add homedir

	* src/main.c (main): Free opt.encoding_remote properly

	* src/host.c (wait_ares): Free ptimer

	* src/init.c (cleanup): Free regex objects properly

	* src/init.c (cleanup): Never call cleanup() twice

	* src/init.c (cmd_bytes_sum): Fix integer over- and underflow

	* src/main.c (save_hsts): Free hsts_store after closing

	Use strtol() instead of selfmade function
	* src/init.c (cmd_number): Use strtol() instead of selfmade function
	* bootstrap.conf: Add strtol gnulib module

	* src/hsts.c (hsts_hash_func): Allow integer overflow

	* init.c (cmd_spec_mirror): Fix uninitialzed stack variable

	* src/init.c (cleanup): Free more variables

	* wget_options_fuzzer.in: Add corpora directory

	* fuzz/wget_options_fuzzer.c: Suppress error messages from wget

	* src/utils.c (fopen_stat): Early return to allow fuzzing/fmemopen

	* src/init.c (initialize): Free mem before exit()

	Add OSS-Fuzz infrastruture
	* Makefile.am: Add fuzz/ to SUBDIRS
	* cfg.mk: Fix 'make syntax-check'
	* configure.ac: Add --enable-fuzzing
	* fuzz/Makefile.am: New file
	* fuzz/README.md: New file
	* fuzz/fuzzer.h: New file
	* fuzz/get_all_corpora: New file
	* fuzz/get_ossfuzz_corpora: New file
	* fuzz/glob_crash.c: New file
	* fuzz/main.c: New file
	* fuzz/run-afl.sh: New file
	* fuzz/run-clang.sh: New file
	* fuzz/view-coverage.sh: New file
	* fuzz/wget_options_fuzzer.c: New file
	* fuzz/wget_options_fuzzer.dict: New file
	* src/init.c (cleanup): Free more resources
	* src/main.c (init_switches): Initialize only once,
	  (print_usage): Don't print if TESTING is defined
	* src/utils.h: Include wget.h

2018-04-05  Tim Rühsen  <tim.ruehsen@gmx.de>

	Move unit-test code to tests/
	* src/Makefile.am: Remove test.c and test.h
	* src/test.c: Rename to tests/unit-tests.c
	* src/test.h: Rename to tests/unit-tests.h
	* tests/Makefile.am: Add unit-tests.c and unit-tests.h
	* src/hsts.c: Amend #include
	* src/http.c: Likewise
	* src/init.c: Likewise
	* src/metalink.c: Likewise
	* src/res.c: Likewise
	* src/url.c: Likewise
	* src/utils.c: Likewise

	* src/main.c: Rename main() -> main_wget() for unit tests

2018-03-14  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix some issues found by 'infer'

2018-03-08  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/openssl.c: Fix build for OpenSSL 1.1.0 without TLS1_3_VERSION

	Add docs for --secure-protocol=TLSv1_3
	* doc/wget.texi: Likewise

2018-03-08  Loganaden Velvindron  <logan@hackers.mu>  (tiny change)

	Add TLS1.3 support for OpenSSL build
	* src/init.c: Add 'tlsv1_3 for --secure-protocol
	* src/openssl.c (ssl_init): Enable TLS1.3 if possible
	* src/options.h: Add secure_protocol_tlsv1_3
	* doc/wget.texi: Add description of TLSv1_3

2018-03-07  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/main.c: Add help text for --retry-on-http-error
	Reported-by: Giovanni Tirloni

2018-03-01  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/url.c (convert_fname): Fix invalid free on iconv_open() failure
	Reported-by: Volkmar Klatt

2018-02-21  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/mswindows.c: Fix prototype of fork_to_background()
	Reported-by: Gisle Vanem

2018-02-09  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix warning to not print binary IP address
	* tests/Test-https-badcerts.px: Likewise
	* tests/Test-https-clientcert.px: Likewise
	* tests/Test-https-crl.px: Likewise
	* tests/Test-https-pfs.px: Likewise
	* tests/Test-https-selfsigned.px: Likewise
	* tests/Test-https-tlsv1.px: Likewise
	* tests/Test-https-tlsv1x.px: Likewise
	* tests/Test-https-weboftrust.px: Likewise

	Use gnulib's utime()
	* bootstrap.conf: Add modules utime and utime-h
	* src/utils.c (touch): Remove own code for gnulib's utime()

2018-02-09  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix logging in background mode
	* ../src/main.c: Re-init logfile if changed for background mode
	* ../src/utils.c: fork_to_background() returns whether logfile changed
	* ../src/utils.h: Set return type bool for fork_to_background()

	Fixes: #53020
	Reported-by: Noël Köthe

2018-02-09  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http.c: Fix two typos in comments

2018-01-31  Tim Rühsen  <tim.ruehsen@gmx.de>

	* testenv/conf/expected_files.py: Ignore pubring.gpg
	Reported-by: Arkadiusz Miśkiewicz

	* bootstrap.conf: Replace gnulib module gettext by gettext-h

2018-01-22  Tim Rühsen  <tim.ruehsen@gmx.de>

	Mention list and bugtracker for --help and in man page
	* doc/wget.texi: Mention list and bugtracker in man page
	* src/main.c: Mention list and bugtracker for --help

2018-01-21  Darshit Shah  <darnir@gnu.org>

	* contrib/make-release: Add another release script

	Update NEWS file for new release

	Fix typo in documentation

2018-01-21  Darshit Shah  <darnir@gnu.org>

	Switch off compression by default
	Gzip compression has a number of bugs which need to be ironed out before
	we can support it by default. Some of these stem from a misunderstanding
	of the HTTP spec, but a lot of them are also due to many web servers not
	being compliant with RFC 7231.

	With this commit, I am marking GZip compression support as experimental
	in GNU Wget pending further investigation and the addition of tests.

	* src/init.c (defaults): Switch of compression support by default
	* docs/wget.texi: State that compression is experimental

2018-01-21  Darshit Shah  <darnir@gnu.org>

	Pull gnulib module forward

	Revert "* src/init.c (defaults): Set compression_none as the default compression"
	This reverts commit 8283ac08467016283277578b96533febb8ce1adb.

	* src/init.c (defaults): Set compression_none as the default compression

2018-01-20  Reiji  <gey3dr@gmail.com>

	* src/http.c (gethttp): Fix bug that prevented all files from being decompressed

2018-01-19  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/host.c (sufmatch): Fix to domain matching

2018-01-17  Gisle Vanem  <gvanem@yahoo.no>

	* src/netrc.c: Fix Standalone compilation of netrc file

2018-01-14  Darshit Shah  <darnir@gnu.org>

	* NEWS: Update NEWS file for new release

	* bootstrap: Use the faster gnulib-tool.py script if possible

	Sync the bootstrap script from gnulib

	Update Copyright years

	Replace HTTP urls with HTTPS where valid

	Update gnulib

	* src/netrc.c: Search for the correct netrc file on Windows

2018-01-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http.c: Exclude *.gz and *.tgz from decompression

2017-12-31  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/utils.c (wg_pin_peer_pubkey): Fix format warning

2017-12-31  Peter Wu  <peter@lekensteyn.nl>

	Avoid redirecting output to file when tcgetpgrp fails
	* src/log.c (check_redirect_output): tcgetpgrp can return -1 (ENOTTY),
	be sure to check whether a valid controlling terminal exists before
	redirecting.

	Fixes: #51181

2017-12-11  Darshit Shah  <darnir@gnu.org>

	Add new test for 416 responses
	* testenv/server/http/http_server.py: If there are multiple requests in
	which the requested range is unsatisfiable, then send a body in the in
	the 2nd response onwards
	* testenv/Test-416.py: New test to check how Wget handles 416 responses

2017-12-08  Darshit Shah  <darnir@gnu.org>

	Don't assume a 416 response has no body
	* http.c(gethttp): In case of a 416 response, try to drain the socket of
	any bytes before reusing the connection

	Reported-By: Iru Cai <mytbk920423@gmail.com>

2017-11-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	Support building with OpenSSL 1.1 w/o deprecated features
	* src/openssl.c (ssl_init): Fix code for the subject's issue

	Reported-by: Matthew Thode

2017-11-25  Tim Rühsen  <tim.ruehsen@gmx.de>

	Avoid link conversion after 304 Not Modified
	* src/http.c (gethttp): Handle 304 before setting document content type

	Fixes: #52404
	Reported-by: Ben Fuchs

2017-11-16  YX Hao  <lifenjoiner@163.com>

	Fix printing mutibyte chars as unprintable chars on Windows
	* src/log.c (get_warc_log_fp): Fix return value to stderr
	* src/main.c (main): Init logging as soon as possible,
	  fix locale/charset on Windows

2017-11-16  Tim Rühsen  <tim.ruehsen@gmx.de>

	* tests/Test-https-weboftrust.px: Fix/add sslport

2017-11-15  YX Hao  <lifenjoiner@163.com>

	Convert remote path to local encoding
	* src/url.c (url_file_name): Convert remote path to local encoding

2017-11-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	Do not use must-revalidate in Cache-Control header
	As the bug report states, 'must-revalidate' is a request directive.

	Fixes #52379

2017-11-06  Darshit Shah  <darnir@gnu.org>

	Fix Segfault due to derefencing null ptr
	* src/http.c(gethttp): When Encoding is gzip, ensure that the
	Content-Type Header was actually seen. Without this, the "type" variable
	is null causing a Segfault.

	Reported-By: Noël Köthe <noel@debian.org>

2017-11-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http.c: Fix H_REDIRECTED

	* src/http.c: Add support for HTTP status code 308

2017-10-30  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix uninitialized value messages in tests
	* tests/Test-https-*.px: Use correct variable in error message

	Reported-by: Jeffrey Walton

2017-10-30  Tim Rühsen  <tim.ruehsen@gmx.de>

	Ignore dirmngr.conf, gpg.conf in test directories
	* testenv/conf/expected_files.py: Ignore dirmngr.conf, gpg.conf

	Libgpgme creates certain files if $HOME doesn't contain the .gnupg directory.
	These files disturb some metalink tests if we don't ignore them.

	Reported-by: Arkadiusz Miśkiewicz <arekm@maven.pl>

2017-10-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	* contrib/release: Cleanup, use lzip instead of xz

2017-10-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix heap overflow in HTTP protocol handling (CVE-2017-13090)
	* src/retr.c (fd_read_body): Stop processing on negative chunk size

	Reported-by: Antti Levomäki, Christian Jalio, Joonas Pihlaja from Forcepoint
	Reported-by: Juhani Eronen from Finnish National Cyber Security Centre

2017-10-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix stack overflow in HTTP protocol handling (CVE-2017-13089)
	* src/http.c (skip_short_body): Return error on negative chunk size

	Reported-by: Antti Levomäki, Christian Jalio, Joonas Pihlaja from Forcepoint
	Reported-by: Juhani Eronen from Finnish National Cyber Security Centre

2017-10-26  Tim Rühsen  <tim.ruehsen@gmx.de>

	Update for release 1.19.2
	* NEWS: Add news for 1.19.2
	* doc/wget.texi: Fix 1.20 to 1.19.2

2017-10-25  YX Hao  <lifenjoiner@163.com>

	Avoid unnecessary UTF-8 encoded fallback (trivial change)
	* src/retr.c (retrieve_url): Check for changed URL on redirect

2017-09-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add GNU extensions to .netrc parsing
	src/netrc.c (parse_netrc): Add 'port' and 'force' extensions

	Reported-by: September 20Tim Landscheidt

2017-09-18  Josef Moellers  <jmoellers@suse.de>

	Bail out on unexpected 416 server errors
	* src/http.c (gethttp): Stop on 416 if file is incomplete

2017-08-04  Tim Schlueter  <schlueter.tim@linux.com>

	Add gzip Content-Encoding decompression
	* src/http.c (struct http_stat): Add remote_encoding field.
	(read_response_body): Enable gzip decompression.
	(initialize_request): Send gzip Accept-Encoding header.
	(gethttp): Decompress files with gzip Content-Encoding.
	* src/retr.c: include zlib.h.
	(zalloc): New function.
	(zfree): New function.
	(fd_read_body): Decompress gzip data.
	* src/retr.h (fd_read_body enum): Add rb_compressed_gzip flag.

	Add --compression option
	* doc/wget.texi: Add --compression documentation.
	* src/init.c (cmd_spec_compression): New function.
	(commands[]): Add opt.compression.
	(defaults): Set default opt.compression value.
	* src/main.c (option_data[]): Add struct for --compression.
	(print_help, help[]): Add description for --compression.
	(main): Add incompatibility checks for --compression.
	* src/options.h (struct options): Add compression enum and field.

	Adjust Extension based on Content-Encoding
	* doc/wget.texi (--adjust-extension, adjust_extension): Updated documentation.
	* src/http.c (encoding_t): New enum.
	(struct http_stat): Add local_encoding field.
	(gethttp): --adjust-extension based on Content-Encoding.

2017-07-31  Darshit Shah  <darnir@gnu.org>

	Document gperf as a requirement

2017-07-28  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/url.c (url_scheme): Use ASCII version of strncasecmp

2017-07-28  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix misuse of strncasecmp
	* src/http.c (set_content_type): Use c_strcasecmp instead of strncasecmp

	See issue bug #51576

2017-07-09  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix python test suite for GnuTLS 3.5.12+
	* testenv/Test-*.py: Replace 127.0.0.1 by localhost
	* testenv/certs/server-template.cfg: Likewise
	* testenv/certs/server-cert.pem: Regenerate
	* testenv/certs/server-crl.pem: Likewise
	* testenv/test/base_test.py: Hardcode 'localhost' as server domain

	Reported-by: Ludovic Courtès <ludo@gnu.org>

2017-06-13  Tim Rühsen  <tim.ruehsen@gmx.de>

	Check for 304 response before applying --adjust-extension
	* src/http.c (gethttp): Move 304 code before --adjust-extension code

	This fixes applying --adjust-extension in combination with 304
	HTTP responses. It could lead to .html extensions to arbitrary
	files.

	Reported-by: anfractuosity

2017-06-13  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix buffer overflow in Public Key Pinning
	* src/utils.c (wget_base64_decode): Add param for destination size,
	  (wg_pubkey_pem_to_der): Amend call to wget_base64_decode(),
	  (wg_pin_peer_pubkey): Likewise and fix code style.
	* src/utils.h: Add param to wget_base64_decode()
	* src/http-ntlm.c (ntlm_input): Amend call to wget_base64_decode()
	* src/http.c (skip_content_type): Likewise

	Fixes #51227

2017-06-02  Tim Rühsen  <tim.ruehsen@gmx.de>

	* doc/wget.texi: Mention --no-config

2017-05-16  Tim Rühsen  <tim.ruehsen@gmx.de>

	* testenv/Test-recursive-basic.py: Check crawled files

	Fix two Metalink tests if $HOME is changed
	* conf/expected_files.py (gen_local_fs_snapshot): Skip processing
	  of 'pubring.kbx'

2017-05-15  Tomas Hozza  <thozza@redhat.com>

	Add command line option to disable use of .netrc
	Although internally code uses option for (not) reading .netrc for
	credentials, it was not possible to turn this behavior off on command
	line. Note that it was possible to turn it off using wgetrc.

	Idea for this change came from Bruce Jerrick (bmj001@gmail.com).
	Reference: https://bugzilla.redhat.com/show_bug.cgi?id=1425097

2017-05-15  Tomas Hozza  <thozza@redhat.com>

	Fixed getting of credentials from .netrc
	There seemed to be a copy&paste error in http.c code, which decides
	whether to get credentials from .netrc. In ftp.c "user" and "pass"
	variables are char*, while in http.c, these are char**. For this reason
	they should be dereferenced when determining if password and user login
	is set to some value.

	Also since both variables are dereferenced on lines above the changed
	code, it does not really make sense to check if they are NULL.

	This patch is based on fix from Bruce Jerrick <bmj001@gmail.com>.
	Fedora bug: https://bugzilla.redhat.com/show_bug.cgi?id=1425097

2017-05-15  Tomas Hozza  <thozza@redhat.com>

	Added tests for HTTP authentication using credentials from .netrc
	Getting credentials from .netrc has been broken from time to time, thus
	adding a test coverage to prevent regressions.

	Also added setting of "HOME" environment variable when executing wget,
	to make sure LocalFiles like .netrc, which are created just for the
	test, are actually used.

2017-05-15  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix Test-https-badcerts.px
	* util/createcerts.sh: Set date of invalid cert to +20 years
	* tests/certs/invalid.crt: Re-generated
	* tests/certs/invalid.key: Re-generated

2017-05-14  Tim Rühsen  <tim.ruehsen@gmx.de>

	* util/createcerts.sh: Fix double equal (syntax-check)

	Fix Test-https-badcerts.px to work with GnuTLS
	* tests/Test-https-badcerts.px: Remove OpenSSL requirement
	* tests/certs/expired.crt: Re-created with valid dates
	* tests/certs/expired.key: Likewise
	* tests/certs/invalid.crt: Likewise
	* tests/certs/invalid.key: Likewise

2017-05-14  Vijo Cherian  <codervijo@gmail.com>

	New shell script to create the certs and keys required for TLS tests
	* util/createcerts.sh: New file

2017-05-11  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix HTTPS testing for stricter OpenSSL
	* testenv/certs/README: Amend cert creation extensions
	* testenv/certs/ca-cert.pem: Created without OCSP signing purpose

	Having the OCSP signing purpose set made newer versions of OpenSSL
	fail due to stricter checking. Test version of OpenSSL was 1.1.0e.

2017-05-11  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/iri.c (idn_encode): Better IDNA 2003 compatibility

2017-05-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	* .gitlab-ci.yml: Also test OpenSSL build

	* .gitlab-ci.yml: Remove installation of texlive

2017-05-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add certs/wotca.pem to avoid temp. file creation
	* tests/certs/wotca.pem: New file
	* tests/Test-https-weboftrust.px: Remove creation of wotca.pem

	This change let Test-https-weboftrust.px survive VPATH builds.

2017-05-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	* cfg.mk: Exclude ^tests/certs/.* from syntax-check

	* po/POTFILES.in: Remove spider.c (syntax-check)

	* tests/Test-https-selfsigned.px: Add newline at EOF (syntax-check)

2017-05-10  Vijo Cherian  <codervijo@gmail.com>

	Removed all uses of temp files. Added needed files to GIT

	Made CRL related files in the repo, instead of trying to generate them

2017-05-09  Tim Rühsen  <tim.ruehsen@gmx.de>

	Cleanup on exit in Test-https-*.px
	* tests/Test-https-*.px: Cleanup on exit

	Auto-generate interca.conf and rootca.conf
	* configure.ac: Add interca.conf.in and rootca.conf.in to AC_CONFIG_FILES
	* tests/certs/interca.conf: Removed
	* tests/certs/rootca.conf: Removed
	* tests/certs/interca.conf.in: New file
	* tests/certs/rootca.conf.in: New file

	Fix path and VPATH issues of new https/TLS tests
	* tests/SSLTest.pm: Use $srcdir in read-only files,
	  (_setup_server): Remove unneeded path fixation code
	* tests/Test-https-*.px: Use $srcdir for read-only files,
	  use $cdir for writable files
	* tests/certs/interca.conf: Adjust paths
	* tests/certs/rootca.conf: Adjust paths

	Check for test server name resolution in tests
	* tests/Test-https-*.px: Skip if test server name resolution fails

	* tests/Makefile.am: Enable Test-https-badcerts again

	Fix WgetFeature.pm to allow multiple required features
	* tests/WgetFeature.cfg: Remove file
	* tests/WgetFeature.pm: Extend to multiple features, cleanup

	* .gitlab-ci.yml: Add wgettestingserver to /etc/hosts

	* tests/SSLServer.pm: Check for IO::Socket::SSL

	* tests/Test-https-*: Change server port to <= 32767

	Move https test server ports from >32767 to <= 32767
	* Test-https-badcerts.px: Change port
	* Test-https-crl.px: Likewise
	* Test-https-weboftrust.px: Likewise

	* tests/Makefile.am: Add SSLTest.pm and SSLServer.pm to EXTRA_DIST

	* tests//Makefile.am: Disable Test-https-badcerts.px

	Add Gitlab CI (Debian)
	* .gitlab-ci.yml: New file

2017-05-06  Tim Rühsen  <tim.ruehsen@gmx.de>

	* .travis.yml: Use trusty for libidn2-dev

2017-05-04  Tim Rühsen  <tim.ruehsen@gmx.de>

	* tests/certs/test-ca-key.pem: Add newline at EOF

	Add static HOSTSALIAS file
	* tests/certs/wgethosts: New file
	* tests/Test-https-*.px: Remove creation of wgethosts file

2017-05-04  Vijo Cherian  <codervijo@gmail.com>

	Added new tests for SSL
	* tests/Test-https-badcerts.px : New file
	* tests/Test-https-clientcert.px : New file
	* tests/Test-https-crl.px : New file
	* tests/Test-https-weboftrust.px : New file
	* tests/certs/interca.conf : New file
	* tests/certs/rootca.conf : New file
	* tests/certs/test-ca-key.pem : New file

	Added all new SSL / HTTPS tests to make check
	Added Test for SSL Web of Trust, accept only if CA chain of trust is intact.
	Added a test script for client certificate
	Added Test for crlfile option of wget
	Added test to make sure that wget doesn't accept expired or invalid certs

	Some clean up : 1, Removed cause of warnings from perl & other cosmetic changes
	                2, Fix  make -j 4 check such that it passes all tests

2017-05-04  Tomas Hozza  <thozza@redhat.com>

	Mention TLSv1_1 and TLSv1_2 as secure-protocol values in help
	* src/main.c: The --secure-protocol option accepts also values TLSv1_1
	and TLSv1_2, as mentioned in the man page. However the help message
	doesn't mention these two values. This patch adds TLSv1_1 and TLSv1_2 as
	possible values to the help message.

2017-05-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http.c (gethttp): Support Wayback Machine's X-Archive-Orig-last-modified

2017-04-28  Vijo Cherian  <codervijo@gmail.com>

	Added new tests for SSL
	* tests/Test-https-badcerts.px : New file
	* tests/Test-https-clientcert.px : New file
	* tests/Test-https-crl.px : New file
	* tests/Test-https-weboftrust.px : New file
	* tests/certs/interca.conf : New file
	* tests/certs/rootca.conf : New file
	* tests/certs/test-ca-key.pem : New file

	Added all new SSL / HTTPS tests to make check
	Added Test for SSL Web of Trust, accept only if CA chain of trust is intact.
	Added a test script for client certificate
	Added Test for crlfile option of wget
	Added test to make sure that wget doesn't accept expired or invalid certs

	Some clean up : Removed cause of warnings from perl & other cosmetic changes

2017-04-19  Vijo Cherian  <codervijo@gmail.com>

	Added new tests for SSL
	* tests/SSLServer.pm: New file
	* tests/SSLTest.pm: New file
	* tests/Test-https-pfs.px: New file
	* tests/Test-https-selfsigned.px: New file
	* tests/Test-https-tlsv1.px: New file
	* tests/Test-https-tlsv1x.px: New file
	* tests/certs/server.crt: New file
	* tests/certs/server.key: New file
	* tests/certs/test-ca-cert.pem: New file

	Added 4 new test scripts all for SSL.
	Added base pm for SSL testing.
	Added SSL tests for TLSv1, TLSv1_1 and PFS.
	Added test for self signed cert : check that it fails without
	--no-check-certificate and passes with that flag.

2017-04-18  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/utils.c: Remove non-portable __builtin_unreachable()

2017-04-18  Tim Rühsen  <tim.ruehsen@gmx.de>

	Skip iconv() usage if HAVE_ICONV is not defined
	This helps on broken iconv implementations, e.g. Solaris.

	Reported-by: Mojca Miklavec

2017-04-18  Tim Rühsen  <tim.ruehsen@gmx.de>

	Mention 'bash' for executing ./bootstrap
	Reported-by: Mojca Miklavec

2017-04-18  Tim Rühsen  <tim.ruehsen@gmx.de>

	* bootstrap.conf: Make 'sed' options more portable
	'sed -i' works differently on FreeBSD.

	Reported-by: Mojca Miklavec

2017-04-16  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix charset transcoding issue for non-reversible codepoints
	* src/url.c: Check iconv() against 0, not -1

	On some libiconv implementations, unknown codepoints become
	encoded as ?, e.g. when converting a non-ascii codepoint to ASCII.
	This results in ambigious file names which also fails our tests.

2017-04-16  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/iri.c: Fix WIN32 idn2_free, forgotten code

2017-04-14  Darshit Shah  <darnir@gnu.org>

	* src/init.c: Set flstats correctly when using WGETRC env var

2017-04-08  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix use of idn2_free()
	* src/connect.c (connect_to_ip): Use xfree() instead of idn2_free()
	* src/host.c (lookup_host): Use xfree() instead of idn2_free()
	* src/iri.h: Do not include idn2.h
	* src/url.c (url_free): Use xfree() instead of idn2_free()
	* src/url.h (struct url): Remove 'idn_allocated' from struct

	Reported-by: Gisle Vanem

2017-04-05  Anton Yuzhaninov  <citrin+github@citrin.ru>

	Fix perl warnings in tests
	* tests/FTPServer.pm: Escape '{' in RE to fix warnings
	* tests/FTPTest.pm: Likewise
	* tests/HTTPServer.pm: Likewise
	* tests/HTTPTest.pm: Likewise
	* tests/Test-proxied-https-auth-keepalive.px: Likewise
	* tests/Test-proxied-https-auth.px: Likewise
	Escape '{' in RE to fix warnings:
	Unescaped left brace in regex is deprecated, passed through in regex;
	marked by <-- HERE in m/{{ <-- HERE port}}/

2017-04-01  klemens  <ka7@github.com>

	Fix typos in comments

2017-03-31  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/metalink.c (retrieve_from_metalink): Fix len in memset()

2017-03-24  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add gnulib module group-member

2017-03-24  Vijo Cherian  <codervijo@gmail.com>

	Safeguards against TOCTTOU
	* src/utils.h: Add struct file_stat_s declaration,
	  change prototypes of file_exists_p(),
	  add prototypes for fopen_stat() and open_stat().
	* src/utils.c: Extend file_exists_p(),
	  new function fopen_stat() and open_stat(),
	  add new param for file_exists_p().
	* src/init.h: Add param file_stats_t to run_wgetrc().
	* src/ftp.c: Amend calls to extended functions.
	* src/hsts.c: Likewise.
	* src/http.c: Likewise.
	* src/init.c: Likewise.
	* src/main.c: Likewise.
	* src/metalink.c: Likewise.
	* src/retr.c: Likewise.
	* src/url.c: Likewise.

	Added fopen_stat() and open_stat() that checks to makes sure the file didn't
	change underneath us.
	Return error from file_exists_p().
	Added a way to return error from this file without major surgery to the
	callers.

	Fixes: #20369

2017-03-24  Tim Rühsen  <tim.ruehsen@gmx.de>

	Update gnulib

2017-03-22  Christof Horschitz  <christof@nimbusec.com>

	* src/warc.c (warc_write_cdx_record): Escape URLs

2017-03-20  Mike Frysinger  <vapier@gentoo.org>

	Include libunistring headers only when used
	* src/iri.c: Check for libidn2 < 0.14 to include libunistring headers

	The unistring functions are used only when an older version of libidn2
	is used, so don't include its headers either w/newer libdin2 versions.

2017-03-18  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix links to www.robotstxt.org
	* NEWS: Fix links
	* doc/wget.texi: Likewise
	* src/res.c: Likewise

	Reported-by: Noël Köthe

2017-03-13  Tim Rühsen  <tim.ruehsen@gmx.de>

	* tests/WgetTests.pm: Add -d to Wget test options

2017-03-08  Tim Rühsen  <tim.ruehsen@gmx.de>

	Include <arpa/inet.h> for Windows
	Reported-by: Gisle Vanem

2017-03-08  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix updating HSTS entries
	* src/hsts.c (hsts_store_entry): Always update 'created' field

	Fixes: #50490
	Reported-by: Deian Stefan, Atyansh Jaiswal, Jonathan Luck

2017-03-06  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix CRLF injection in Wget host part
	* src/url.c (url_parse): Reject control characters in host part of URL

	Reported-by: Orange Tsai

2017-03-04  Benjamin Esham  <benjamin@esham.io>

	* src/warc.c: Use warc_write_header_uri for all WARC-Target-URI fields
	The WARC spec requires that all URIs be enclosed in angle brackets. This
	was being done in most cases, but not for "WARC-Target-URI" fields in
	WARC blocks of type "response", "resource", "revisit", and "metadata".

2017-02-16  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix 504 status handling
	* src/http.c (gethttp): Move 504 handling to correct place.
	  (http_loop): Fix memeory leak.
	* testenv/server/http/http_server.py: Add Content-Length header on non-2xx
	  status codes with a body

	Reported-by: Adam Sampson

2017-02-16  YX Hao  <lifenjoiner@163.com>

	* src/url.c (url_file_name): Do not charset convert local directory
	In a non-ASCII environment, the local path may contain non-ASCII
	characters. The server responded file name must be converted before
	it is concatenated to the local path. Conversion after concatenation
	may result in 'iconv' errors.

2017-02-15  Tim Rühsen  <tim.ruehsen@gmx.de>

	* configure.ac: Remove manually resetting of LIBICONV variable
	Fixes: #48193
	Reported-by: ilovezfs
	Reported-by: Charles

	* bootstrap.conf: Call gperf to create lib/unicase/special-casing-table.h

	* bootstrap.conf: Fix latest gnulib to work with gperf < 3.1

2017-02-14  Darshit Shah  <darnir@gnu.org>

	Pull GNULib to latest.
	* gnulib: Pull to latest commit. This fixes an issue with Gperf 3.1

2017-02-12  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/main.c: Remove double 'verbose' option
	Fixes: #50290

2017-02-11  Tim Rühsen  <tim.ruehsen@gmx.de>

	* NEWS: update

	isrc/http.c (check_retry_on_http_error): Fix gcc warning

2017-02-11  Tom Szilagyi  <tomszilagyi@gmail.com>

	Add support for --retry-on-http-error
	* doc/wget.text: Add documentation
	* src/http.c: Add function check_retry_on_http_error ()
	* src/init.c: Add opt.retry_on_http_error
	* src/main.c: Add struct for retry-on-http-error to option_data[]
	* src/options.h: Add retry_on_http_error to struct options

2017-02-11  Tim Rühsen  <tim.ruehsen@gmx.de>

	Revert "Add support for --retry-on-http-error"
	This reverts commit 977276374d1be7f171f5da8633368025c88b9eee.

2017-02-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	Change libtool library deps to non-libtool deps
	Reported-by: Yousong Zhou
	Fixes: #50260

2017-02-09  Tom Szilagyi  <tomszilagyi@gmail.com>

	Add support for --retry-on-http-error
	* doc/wget.texi: Add description for --retry-on-http-error
	* src/http.c (gethttp):
	Consider given HTTP response codes as non-fatal, transient errors.
	Supply a comma-separated list of 3-digit HTTP response codes as
	argument. Useful to work around special circumstances where retries
	are required, but the server responds with an error code normally not
	retried by Wget. Such errors might be 503 (Service Unavailable) and
	429 (Too Many Requests). Retries enabled by this option are performed
	subject to the normal retry timing and retry count limitations of
	Wget.

	Using this option is intended to support special use cases only and is
	generally not recommended, as it can force retries even in cases where
	the server is actually trying to decrease its load. Please use it
	wisely and only if you know what you are doing.

	Example use and a starting point for manual testing:
	  wget --retry-on-http-error=429,503 http://httpbin.org/status/503

2017-02-09  Tim Rühsen  <tim.ruehsen@gmx.de>

	* tests/WgetTests.pm: Add --no-config to wget invocation
	Without --no-config, wgetrc commands may disturb the tests.

	Reported-by: Dagobert Michelsen

2017-02-06  Tim Rühsen  <tim.ruehsen@gmx.de>

	* tests/WgetTests.pm (_verify_download): Fix failure message
	Reported-by: Zhiming Wang

	* src/http.c (initialize_request): Fix regression in .netrc auth
	Reported-by: Axel Reinhold

	* src/iri.c (idn_encode): Fix memory leak

2017-02-06  Tim Rühsen  <tim.ruehsen@gmx.de>

	Remove skipping libunistring with --disable-iri
	* configure.ac: Remove checking for IRI=no

	On certain systems, gnulib falls back to libunistring
	for mbtowc() and wcwidth() (used in src/progress.c).

	Reported-by: Zhiming Wang

2017-02-04  Tim Rühsen  <tim.ruehsen@gmx.de>

	* bootstrap.conf: Add gnulib module wcwidth

	Fix include/define clash with gnulib's unlink module
	* src/options.h: Rename options.unlink to options.unlink_requested
	* src/init.c: Replace options unlink member by unlink_requested
	* src/http.c: Likewise
	* src/ftp.c: Likewise

	* bootstrap.conf: Specify unicode modules more exact

	* src/xattr.h: Fix #define fsetxattr for MacOS and FreeBSD
	Reported-by: Zhiming Wang

2017-02-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	* contrib/release: New release helper script

	* cfg.mk: Fix syntax-check

	* doc/announcement_1.19.txt: Add new file

	* src/utils.c: Move macro FMT_MAX_LENGTH into scope

	* src/utils.c: Fix -Wformat= warnings

	* src/gnutls.c: Fix -Wformat= warnings

	* src/iri.c: Remove unused macro IDNA_FLAGS

	* src/iri.c: Remove use of __func__ macros

	* src/http.c: Fix -Wformat= warnings

	* src/progress.c: Remove unused macro move_to_end

	* src/html-parse.c: Remove unused macro SKIP_NON_WS

	* src/hsts.c: Remove unused macro CHECK_EXPLICIT_PORT

	* src/hsts.c: Fix -Wformat= warnings

	* src/hash.c: Explicitly convert float to int

	* src/ftp-ls.c: Fix -Wformat= warnings

	* src/ftp.c (ftp_retrieve_list): Add default to switch

	* src/css-url.h: Remove redundant declaration

	* src/ftp.c: Fix -Wformat= warning

	* src/http.c (test_parse_range_header): Fix constants

2017-02-02  Dale R. Worley  <worley@ariadne.com>

	Improve documentation of --trust-server-names.

2017-02-02  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/url.c (mkalldirs): Add newline to log message

	* src/cookies.c (check_domain_match): Add newline to DEBUG lines

2017-01-17  Tim Rühsen  <tim.ruehsen@gmx.de>

	* NEWS: update

	* README.checkout: Link HTTPS where possible, update flex homepage

	* README.checkout: Fix libidn to libidn2

2017-01-13  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/iri.c: Use TR46 non-transitional for toASCII conversion

	* src/main.c: Fix _Noreturn compiler warnings

	* src/utils.c: Fix _Noreturn compiler warning

	* src/init.c (setval_internal): Fix sign compare warning

2017-01-13  Tim Rühsen  <tim.ruehsen@gmx.de>

	Replace home-grown portability code by gnulib modules
	* bootstrap.conf: Add intprops, inttypes, limits-h, signal-h,
	  stat, sys_types
	* src/ftp.c: Replace 'struct_stat' by 'struct stat'
	* src/hsts.c: Likewise
	* src/http.c: Likewise
	* src/main.c: Likewise
	* src/netrc.c: Likewise
	* src/retr.c: Likewise
	* src/url.c: Likewise
	* src/utils.c: Likewise
	* src/sysdep.h: Remove old portability code

	Further portability issues should be addressed by gnulib.

2017-01-13  Tim Rühsen  <tim.ruehsen@gmx.de>

	Replace WGET_* m4 macros by gnulib modules
	* bootstrap.conf: Add hostent, inet_ntop, nanosleep, utimens
	* configure.ac: Remove WGET_STRUCT_UTIMBUF, WGET_FNMATCH,
	  WGET_NANOSLEEP, WGET_POSIX_CLOCK, WGET_NSL_SOCKET
	* m4/wget.m4: Likewise
	* src/Makefile.am: Add $(LIB_NANOSLEEP) $(LIB_POSIX_SPAWN) to LDADD
	* tests/Makefile.am: Likewise
	* src/host.c (print_address): Use inet_ntop also for IPV4

2017-01-13  Tim Rühsen  <tim.ruehsen@gmx.de>

	Remove libidn vulnerability work-around
	* src/iri.c (_utf8_is_valid): Removed

	Since we are using libidn2 for IDNs, we no longer need
	this work-around.

2017-01-13  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/iri.c (idn_encode): Use TR46 transitional if available

	* gnulibx: Update

2017-01-07  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix previous commit 2427ca4ac090dc6cc0c527f4ac4fc5a4bd468eb1

2017-01-06  vijeth-aradhya  <vijthaaa@gmail.com>

	Fix http.c and ftp.c passwd logic error
	* src/ftp.c (getftp): Fix password/user selection
	* src/http.c (initialize_request): Likewise

	Before, netrc password won over interactive
	--ask-password but now --ask-password wins
	after change of program logic

	Fixes Issue #48811

2016-12-31  Giuseppe Scrivano  <gscrivan@redhat.com>

	* src/main.c (main): Add missing \n in error message

2016-12-28  Giuseppe Scrivano  <gscrivan@redhat.com>

	Check that fd_set has not fds bigger than FD_SETSIZE
	* src/connect.c: check that the fd is not bigger than FD_SETSIZE
	  before using FD_SET.  An fd_set cannot hold fds bigger than
	  FD_SETSIZE, causing out-of-bounds write to a buffer on the stack.

	Reported by: Jann Horn <jannh@google.com>

2016-12-20  Nikos Mavrogiannopoulos  <nmav@gnutls.org>

	Avoid calling the gnutls priority functions multiple times
	* src/gnutls.c (ssl_connect_wget): Call gnutls_set_default_priority()
	  for --secure-protocol=auto (default).

	The patch fixes a behavior that may have unintended side-effects in
	certain gnutls versions. Instead use the default priorities when no
	options are given.

2016-12-19  Tim Rühsen  <tim.ruehsen@gmx.de>

	Print debug message when skipping certain recursive downloads
	* src/recur.c (retrieve_tree): Print debug message instead silently
	  skipping recursive downloads.

2016-12-14  Rahul Bedarkar  <rahul.bedarkar@imgtec.com>

	Rename base64_{encode,decode} (trivial patch)
	* src/http-ntlm.c: Rename base64_{encode,decode}
	* src/http.c: Likewise
	* src/utils.c: Likewise
	* src/utils.h: Likewise

	When statically linking with gnutls, we get definition clash error for
	base64_encode which is also defined by gnutls.

	To prevent definition clash, rename base64_{encode,decode}

2016-12-11  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add support for psl_latest()
	* configure.ac: Add check for psl_latest(),
	  remove --with-psl-file
	* src/cookies.c (check_domain_match): Use psl_latest() if available

2016-11-09  Piotr Wajda  <pwajda@gmail.net.pl>

	Respect -o parameter again
	 * log.c: don't choose log output dynamically when opt.lfilename is set

	 Regression introduced by dd5c549f6af8e1143e1a6ef66725eea4bcd9ad50
	 Reported-by: Dale R. Worley

2016-11-07  Tim Rühsen  <tim.ruehsen@gmx.de>

	Move Wget from IDN2003 (libidn) to IDN2008 (libidn2)
	* .travis.yml: Install libidn2-dev instead libidn11-dev.
	* bootstrap.conf: Add modules libunistring-optional, unistr/base,
	  unicase/tolower.
	* configure.ac: Check for libidn2.
	* src/Makefile.am: Add $(LTLIBUNISTRING) to LDADD.
	* tests/Makefile.am: Set LDADD similar to LDADD in src/Makefile.am
	* src/connect.c: Use libidn2 code instead of libidn.
	* src/host.c: Likewise.
	* src/iri.c: Likewise.
	* src/iri.h: Likewise.
	* src/options.h: Likewise.
	* src/url.c: Likewise.
	* src/url.h: Likewise.
	* src/log.c: Fix C99 comment.

	IDN2003 should not be used any more due to security concerns.
	We use libunistring (resp. the unicode code from gnulib) for
	lowercasing UTF-8 before we give data to libidn2.
	TR#46 is missing, no support in libidn2 nor in libunistring.

2016-11-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	Use -O0 in contrib scripts
	* contrib/check-hard: Use -O0 instead of -O2 to speed up script.
	* contrib/travis-ci: Likewise.

	Update gnulib

2016-10-22  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/metalink.c: Fix typo 'suceeded' -> 'succeeded'
	Reported-by: Göran Uddeborg <goeran@uddeborg.se>,
	             Anders Jonsson <anders.jonsson@norsjovallen.se>

2016-10-21  losgrandes  <pwajda@gmail.net.pl>

	Fixes #45790: wget prints it's progress even when background
	* src/log.c: Use tcgetpgrp(STDIN_FILENO) != getpgrp() to determine when to print to STD* or logfile.
	  Deprecate log_request_redirect_output function.
	  Use different file handles for STD* and logfile, to easily switch between them when changing fg/bg.
	* src/log.h: Make redirect_output function externally linked.
	* src/main.c: Don't use deprecated log_request_redirect_output function. Use redirect_output instead.
	* src/mswindows.c: Don't use deprecated log_request_redirect_output function. Use redirect_output instead.

	Fixes #46584: wget --spider always returns zero exit status
	* src/ftp.c: Return error as exit value if even one file doesn't exist

2016-10-12  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http.c (gethttp): Accept 206 for request w/o Range header
	Fixes: #49319

2016-10-07  Tim Rühsen  <tim.ruehsen@gmx.de>

	* tests/Makefile.am: Let WGETRC work on *nix and Windows

	Properly include iconv.h
	* src/iri.c: Check HAVE_ICONV to include iconv.h
	* src/url.c: Same

	* bootstrap.conf: Add pipe-posix for pipe()

2016-10-07  Tim Rühsen  <tim.ruehsen@gmx.de>

	Amend redirection behavior
	* src/recur.c (descend_redirect): Ignore WG_RR_LIST and WG_RR_REGEX
	  for redirections.
	* testenv/Makefile.am: Add Test-recursive-redirect.py
	* testenv/Test-recursive-redirect.py: New test

	Test-recursive-redirect.py written by Dale R. Worley.

	Reported-by: "Dale R. Worley" <worley@ariadne.com>

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	New: Metalink/XML v3 python class, update tests to use this class
	* testenv/misc/metalinkv3_xml.py: New Metalink/XML v3 python class
	* testenv/Test-metalink-xml-abspath-trust.py: Update test to use the
	  new Metalink/XML v3 python class
	* testenv/Test-metalink-xml-abspath.py: Update test to use the new
	  Metalink/XML v3 python class
	* testenv/Test-metalink-xml-absprefix-trust.py: Update test to use the
	  new Metalink/XML v3 python class
	* testenv/Test-metalink-xml-absprefix.py: Update test to use the new
	  Metalink/XML v3 python class
	* testenv/Test-metalink-xml-continue.py: Update test to use the new
	  Metalink/XML v3 python class
	* testenv/Test-metalink-xml-emptyprefix-trust.py: Update test to use
	  the new Metalink/XML v3 python class
	* testenv/Test-metalink-xml-homepath-trust.py: Update test to use the
	  new Metalink/XML v3 python class
	* testenv/Test-metalink-xml-homepath.py: Update test to use the new
	  Metalink/XML v3 python class
	* testenv/Test-metalink-xml-homeprefix-trust.py: Update test to use
	  the new Metalink/XML v3 python class
	* testenv/Test-metalink-xml-homeprefix.py: Update test to use the new
	  Metalink/XML v3 python class
	* testenv/Test-metalink-xml-nohash.py: Update test to use the new
	  Metalink/XML v3 python class
	* testenv/Test-metalink-xml-nourls.py: Update test to use the new
	  Metalink/XML v3 python class
	* testenv/Test-metalink-xml-prefix-trust.py: Update test to use the
	  new Metalink/XML v3 python class
	* testenv/Test-metalink-xml-prefix.py: Update test to use the new
	  Metalink/XML v3 python class
	* testenv/Test-metalink-xml-relpath-trust.py: Update test to use the
	  new Metalink/XML v3 python class
	* testenv/Test-metalink-xml-relpath.py: Update test to use the new
	  Metalink/XML v3 python class
	* testenv/Test-metalink-xml-relprefix-trust.py: Update test to use the
	  new Metalink/XML v3 python class
	* testenv/Test-metalink-xml-relprefix.py: Update test to use the new
	  Metalink/XML v3 python class
	* testenv/Test-metalink-xml-size.py: Update test to use the new
	  Metalink/XML v3 python class
	* testenv/Test-metalink-xml-trust.py: Update test to use the new
	  Metalink/XML v3 python class
	* testenv/Test-metalink-xml.py: Update test to use the new
	  Metalink/XML v3 python class

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	New: --metalink-over-http Content-Type/Disposition Metalink/XML processing
	* src/http.c (metalink_from_http): Process the Content-Type header.
	  Add an application/metalink4+xml URL as metalink metaurl.  If the
	  option opt.content_disposition is true, the Content-Disposition's
	  filename is the metaurl's name
	* doc/wget.texi: Update --content-disposition and --metalink-over-http
	* doc/metalink-standard.txt: Update doc. Content-Type/Disposition
	  processing through --metalink-over-http. Update download naming
	  system about --trust-server-names and --content-disposition
	* testenv/Makefile.am: Add new files
	* testenv/Test-metalink-http-xml-type.py: New file. Metalink/HTTP
	  Content-Type/Disposition header automated Metalink/XML tests
	* testenv/Test-metalink-http-xml-type-trust.py: New file. Metalink/HTTP
	  Content-Type/Disposition header with --trust-server-names automated
	  Metalink/XML tests
	* testenv/Test-metalink-http-xml-type-content.py: New file. Metalink/HTTP
	  Content-Type/Disposition header with --content-disposition automated
	  Metalink/XML tests
	* testenv/Test-metalink-http-xml-type-trust-content.py: New file.
	  Metalink/HTTP Content-Type/Disposition header with --trust-server-names
	  and --content-disposition automated Metalink/XML tests

	Process the Content-Type header, identify an application/metalink4+xml
	file.  The Content-Disposition could provide an alternate name through
	the "filename" field for the metalink xml file.  Respectively, the cli
	options --metalink-over-http and --content-disposition are required.

	When Metalink/XML auto-processing, to use the Content-Disposition's
	filename, the cli option --trust-server-names is also required.

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	Bugfix: Set NULL variable due to --content-disposition to Metalink origin
	* src/http.c (http_loop): Prevent SIGSEGV when hstat.local_file is
	  NULL, opt.content_disposition has a role in leaving the value unset
	* src/http.c (gethttp): If hs->local_file is NULL (aka http_loop()'s
	  hstat.local_file), set it to the value of hs->metalink->origin

	New: --trust-server-names saves Metalink/HTTP xml files using the "name" field
	* src/metalink.c (retrieve_from_metalink): If opt.trustservernames is
	  true, use the basename of the metaurl's name to save the xml file
	* doc/metalink-standard.txt: Update doc. With --trust-server-names any
	  Metalink/HTTP Link application/metalink4+xml file is saved using the
	  basename of the "name" field, if any. Update Metalink/HTTP examples
	* testenv/Makefile.am: Add new file
	* testenv/Test-metalink-http-xml-trust-name.py: New file. Metalink/HTTP
	  automated Metalink/XML, save xml files using the "name" field tests

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	Bugfix: Detect when a metalink:file doesn't have any hash
	* src/metalink.c (retrieve_from_metalink): Reject any metalink:file
	  without hashes. Prompt the error and switch to the next file
	* testenv/Makefile.am: Add new file
	* testenv/Test-metalink-xml-nohash.py: New file. Metalink/XML with no
	  hashes tests

	Prevent SIGSEGV.

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	Bugfix: Detect malformed base64 Metalink/HTTP Digest header
	* src/http.c (metalink_from_http): Fix hash_bin_len type. Use ssize_t
	  instead than size_t. Reject -1 as base64_decode() return value
	* testenv/Makefile.am: Add new file
	* testenv/Test-metalink-http-baddigest.py: New file. Metalink/HTTP
	  malformed base64 Digest header tests

	On malformed base64 input, ssize_t base64_decode() returns -1. Such
	value is too big for a size_t variable, and used as xmalloc() value
	will exaust all the memory.

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	New option --metalink-index to process Metalink application/metalink4+xml
	* NEWS: Mention the effect of --metalink-index over Metalink
	* src/init.c: Add new option metalinkindex (opt.metalink_index),
	  initialize to -1
	* src/main.c: Add new option metalink-index (--metalink-index=NUMBER)
	* src/options.h: Add new option metalink_index (int)
	* src/metalink.h: Add declaration of functions fetch_metalink_file(),
	  replace_metalink_basename()
	* src/metalink.c: Add functions fetch_metalink_file() simple file
	  fetch, replace_metalink_basename() replace file basename
	* src/metalink.c (retrieve_from_metalink): New. Process Metalink
	  application/metalink4+xml of opt.metalink_index ordinal number
	* doc/wget.texi: Add new option metalink-index (--metalink-index)
	  documentation
	* doc/metalink-standard.txt: Updated doc. Add documentation about
	  Metalink application/metalink4+xml metaurls download naming system
	* doc/metalink-standard.txt: Update Metalink/XML and HTTP examples
	* testenv/Makefile.am: Add new files
	* testenv/Test-metalink-http-xml.py: New file. Metalink/HTTP automated
	  Metalink/XML "application/metalink4+xml" --metalink-index tests
	* testenv/Test-metalink-http-xml-trust.py: New file. Metalink/HTTP
	  automated Metalink/XML "application/metalink4+xml" --metalink-index
	  retrieval with --trust-server-names tests

	WARNING: Do not use lib/dirname.c (dir_name) to get the directory
	name, it may append a dot '.' character to the directory name.

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	Bugfix: Prevent sorting when there are less than two elements
	* src/utils.c (stable_sort): Add condition nmemb > 1, sort only when
	  there is more than one element

	Prevent SIGSEGV.

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	New: Parse Metalink/HTTP header for application/metalink4+xml
	* src/http.c (metalink_from_http): Parse Metalink/HTTP header for
	  metaurls application/metalink4+xml media types
	* src/metalink.h: Add function declaration metalink_meta_cmp()
	* src/metalink.c: Add function metalink_meta_cmp() compare metalink
	  metaurls priorities

	Add Metalink/HTTP application/metalink4+xml media types as metaurls to
	the metalink variable that will be used to download the files.

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	New test: Metalink shall not concatenate '/' to an empty directory prefix
	* testenv/Makefile.am: Add new file
	* testenv/Test-metalink-xml-emptyprefix-trust.py: New file.
	  Metalink/XML empty directory prefix (--directory-prefix '') tests

	Detect a '/' character wrongfully concatenated to an empty directory
	prefix '' (not NULL), resulting in an absolute path as '/dir/file',
	instead than 'dir/file'.

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	Bugfix: Remove surrounding quotes from Metalink/HTTP key's value
	* src/metalink.h: Add declaration of function dequote_metalink_string()
	* src/metalink.c: Add function dequote_metalink_string() remove
	  surrounding quotes from string, \' or \"
	* src/metalink.c (find_key_value, find_key_values): Call dequote_metalink_string()
	  to remove the surrounding quotes from the parsed value
	* src/metalink.c (test_find_key_value, test_find_key_values): Add
	  quoted key's values for unit-tests
	* testenv/Makefile.am: Add new file
	* testenv/Test-metalink-http-quoted.py: New file. Metalink/HTTP quoted
	  values tests

	Some Metalink/HTTP keys, like "type" [2], may have a quoted value [1]:
	Link: <http://example.com/example.ext.meta4>; rel=describedby;
	type="application/metalink4+xml"

	Wget was expecting a dequoted value from the Metalink module. This
	patch addresses this problem.

	References:
	 [1] Metalink/HTTP: Mirrors and Hashes
	     1.1. Example Metalink Server Response
	     https://tools.ietf.org/html/rfc6249#section-1.1

	 [2] Additional Link Relations
	     6. "type"
	     https://tools.ietf.org/html/rfc6903#section-6

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	Bugfix: Process Metalink/XML url strings containing white spaces and CRLF
	* src/metalink.h: Add declaration of function clean_metalink_string()
	* src/metalink.c: Add directive #include "xmemdup0.h"
	* src/metalink.c: Add function clean_metalink_string() remove leading
	  and trailing white spaces and CRLF from string
	* src/metalink.c (retrieve_from_metalink): Remove leading and trailing
	  white spaces and CRLF from url resource mres->url
	* testenv/Makefile.am: Add new file
	* testenv/Test-metalink-xml-urlbreak.py: New test. Metalink/XML white
	  spaces and CRLF in url resources tests

	White spaces and CRLF are not automatically removed by libmetalink
	from url strings. The Wget's Metalink module was unable to process
	such url strings. This patch implements the processing of such url
	strings cleaning off leading and trailing white spaces and CRLF.

	If a parsed Metalink/XML url string contains strings separated by
	CRLF, only the first of the series is accepted.

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	New test: Detect when there are no good Metalink url resources
	* testenv/Makefile.am: Add new file
	* testenv/Test-metalink-xml-nourls.py: New file. Metalink/XML unknown
	  urls tests

	Test if when there are no good Metalink url resources there is any
	segmentation fault.

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	New: Metalink file size mismatch returns error code METALINK_SIZE_ERROR
	* src/wget.h (uerr_t): Add error code METALINK_SIZE_ERROR to enum
	* src/metalink.c (retrieve_from_metalink): Use boolean variable
	  size_ok, when false set retr_err to METALINK_SIZE_ERROR
	* testenv/Makefile.am: Add new file
	* testenv/Test-metalink-xml-size.py: New file. Metalink/XML file size
	  tests (<size></size>)

	Before this patch, no appropriate error code was returned to inform a
	file size mismatch.

	This patch introduces the error code METALINK_SIZE_ERROR to inform a
	file size mismatch.

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	New: Metalink/XML and Metalink/HTTP file naming safety rules
	* NEWS: Mention the effect of --trust-server-names over Metalink
	* src/metalink.h: Add declaration of function append_suffix_number()
	* src/metalink.c: Add function append_suffix_number() append number to
	  string
	* src/metalink.c (retrieve_from_metalink): Safer Metalink/XML and
	  Metalink/HTTP download naming system, opt.trustservernames based
	* doc/metalink-standard.txt: Update doc. Explain new Metalink/XML and
	  Metalin/HTTP download naming system and --trust-server-names role
	* testenv/Makefile.am: Add new files
	* testenv/Test-metalink-xml-continue.py: Update test. Metalink/XML
	  continue/keep existing files (HTTP 416) with --continue tests
	* testenv/Test-metalink-xml.py: Update test. Metalink/XML naming tests
	* testenv/Test-metalink-xml-trust.py: New file. Metalink/XML naming
	  tests with --trust-server-names
	* testenv/Test-metalink-xml-abspath.py: Update test. Metalink/XML
	  absolute path tests
	* testenv/Test-metalink-xml-abspath-trust.py: New file. Metalink/XML
	  absolute path tests with --trust-server-names
	* testenv/Test-metalink-xml-relpath.py: Update test. Metalink/XML
	  relative path tests
	* testenv/Test-metalink-xml-relpath-trust.py: New file. Metalink/XML
	  relative path tests with --trust-server-names
	* testenv/Test-metalink-xml-homepath.py: Update test. Metalink/XML
	  home path and ~ (tilde) tests
	* testenv/Test-metalink-xml-homepath-trust.py: New file. Metalink/XML
	  home path and ~ (tilde) tests with --trust-server-names
	* testenv/Test-metalink-xml-prefix.py: New file. Metalink/XML naming
	  tests with --directory-prefix
	* testenv/Test-metalink-xml-prefix-trust.py: New file. Metalink/XML
	  naming tests with --directory-prefix and --trust-server-names
	* testenv/Test-metalink-xml-absprefix.py: New file. Metalink/XML
	  absolute --directory-prefix tests
	* testenv/Test-metalink-xml-absprefix-trust.py: New file. Metalink/XML
	  absolute --directory-prefix tests with --trust-server-names
	* testenv/Test-metalink-xml-relprefix.py: New file. Metalink/XML
	  relative --directory-prefix tests
	* testenv/Test-metalink-xml-relprefix-trust.py: New file. Metalink/XML
	  relative --directory-prefix tests with --trust-server-names
	* testenv/Test-metalink-xml-homeprefix.py: New file. Metalink/XML home
	  --directory-prefix tests
	* testenv/Test-metalink-xml-homeprefix-trust.py: New file. Metalink/XML
	  home --directory-prefix tests with --trust-server-names

	The option --trust-server-names allows to use the file names parsed
	from a Metalink/XML file.  Without --trust-server-names, the safety
	mechanism provides secure and predictable file names.

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	New document: Metalink/XML and Metalink/HTTP standard reference
	* doc/metalink-standard.txt: New doc. Implemented and recommended
	  Metalink/XML and Metalink/HTTP standard features

2016-09-30  Matthew White  <mehw.is.me@inventati.org>

	Enforce Metalink file name verification, strip directory if necessary
	* NEWS: Mention the use of a safe Metalink destination path
	* src/metalink.h: Add declaration of functions get_metalink_basename(),
	  last_component(), metalink_check_safe_path()
	* src/metalink.c: Add directive #include "dosname.h"
	* src/metalink.c: Add function get_metalink_basename() to return the
	  basename of a file name, strip w32's drive letter prefixes
	* src/metalink.c (retrieve_from_metalink): Enforce Metalink file name
	  verification, if the file name is unsafe try its basename
	* doc/metalink.txt: Update document. Explain --directory-prefix

	The function get_metalink_basename() uses FILE_SYSTEM_PREFIX_LEN to
	catch any 'C:D:file' (w32 environment), then it removes each drive
	letter prefix, i.e. 'C:' and 'D:'.

	Unsafe file names contain an absolute, relative, or home path.  Safe
	paths can be verified by libmetalink's metalink_check_safe_path().

2016-09-27  Matthew White  <mehw.is.me@inventati.org>

	Implement Metalink/XML --directory-prefix option in Metalink module
	* NEWS: Mention the effect of --directory-prefix over Metalink
	* src/metalink.c (retrieve_from_metalink): Add opt.dir_prefix as
	  prefix to the metalink:file name mfile->name
	* doc/metalink.txt: Update document. Explain --directory-prefix

	When --directory-prefix=<prefix> is used, set the top of the retrieval
	tree to prefix. The default is . (the current directory). Metalink/XML
	and Metalink/HTTP files will be downloaded under prefix.

2016-09-27  Matthew White  <mehw.is.me@inventati.org>

	Change mfile->name to filename in Metalink module's messages
	* src/metalink.c (retrieve_from_metalink): Change mfile->name to
	  filename when referring to the downloaded file

	The file name could have been changed by unique_create() (or by any
	other mean) before downloading. Use the name of the downloaded file
	(filename) when printing output which refer to it.

2016-09-27  Matthew White  <mehw.is.me@inventati.org>

	Add file size computation in Metalink module
	* NEWS: Mention Metalink's file size verification
	* src/metalink.c (retrieve_from_metalink): Add file size computation
	* doc/metalink.txt: Update document. Remove resolved bugs

	Reject downloaded files when they do not agree with their Metalink/XML
	metalink:size: https://tools.ietf.org/html/rfc5854#section-4.2.14

	At the moment of writing, Metalink/HTTP headers do not provide a file
	size field. This information could be obtained from the Content-Length
	header field: https://tools.ietf.org/html/rfc6249#section-7

2016-09-27  Matthew White  <mehw.is.me@inventati.org>

	Update Metalink/XML tests and add a new test for home paths
	* testenv/Test-metalink-xml-relpath.py: Update test
	* testenv/Test-metalink-xml-homepath.py: New file. Reject home paths
	* testenv/Makefile.am: Add new file

	When --input-metalink=<file> is used, each metalink:file name is
	verified by libmetalink's metalink_check_safe_path(). By design,
	absolute, relative and home paths are rejected.

	At the moment of writing, when --metalink-over-http is used, absolute,
	relative, and home paths aren't a concern. The destination file name
	is a combination of URL's file name and cli's "Directory Options"
	handled by src/url.c (url_file_name).

2016-09-27  Matthew White  <mehw.is.me@inventati.org>

	Bugfix: Keep the download progress when alternating metalink:url
	* NEWS: Mention the effects of --continue over Metalink
	* src/metalink.c (retrieve_from_metalink): On download error, resume
	  output_stream with the next mres->url. Keep fully downloaded files
	  started with --continue, otherwise rename/remove the file
	* testenv/Makefile.am: Add new file
	* testenv/Test-metalink-xml-continue.py: New file. Metalink/XML
	  continue/keep existing files (HTTP 416) with --continue tests

	Before this patch, with --continue, existing and/or fully retrieved
	files which fail the sanity tests were renamed (--keep-badhash), or
	removed.

	This patch ensures that --continue doesn't rename/remove existing
	and/or fully retrieved files (HTTP 416) which fail the sanity tests.

2016-09-27  Matthew White  <mehw.is.me@inventati.org>

	Bugfix: Fix NULL filename and output_stream in Metalink module
	* NEWS: Mention the Metalink "path/file" name format handling
	* src/metalink.c (retrieve_from_metalink): Fix NULL filename, set
	  filename to the right "path/file" value
	* src/metalink.c (retrieve_from_metalink): Fix NULL output_stream, set
	  output_stream to filename when it is created by retrieve_url()
	* src/metalink.c (retrieve_from_metalink): Add RFC5854 comments about
	  proper metalink:file "path/file" name format handling
	* doc/metalink.txt: Update document. Remove resolved bugs

	If unique_create() cannot create/open the destination file, filename
	and output_stream remain NULL. If fopen() is used instead, filename
	always remains NULL. Both functions cannot create "path/file" trees.

	Setting filename to the right value is sufficient to prevent SIGSEGV
	generating from testing a NULL value. This also allows retrieve_url()
	to create a "path/file" tree through opt.output_document.

	Reading NULL as output_stream, when it shall not be, leads to wrong
	results. For instance, a non-NULL output_stream tells when a stream
	was interrupted, reading NULL instead means to assume the contrary.

	This patch conforms to the RFC5854 specification:
	  The Metalink Download Description Format
	  4.1.2.1.  The "name" Attribute
	  https://tools.ietf.org/html/rfc5854#section-4.1.2.1

2016-09-19  Matthew White  <mehw.is.me@inventati.org>

	Add metalink description
	* doc/metalink.txt

	Evaluation of "Directory Options" on the command line interacting with
	the option '--input-metalink=file':

	$ wget --input-metalink=file <directory options>

2016-09-19  Matthew White  <mehw.is.me@inventati.org>

	Use python .replace instead than re.sub in Metalink tests
	* testenv/Test-metalink-http.py: Use python .replace
	* testenv/Test-metalink-xml.py: Use python .replace
	* testenv/Test-metalink-xml-abspath.py: Use python .replace
	* testenv/Test-metalink-xml-relpath.py: Use python .replace

	Use python .replace instead than re.sub, remove 'import re'.

2016-09-19  Matthew White  <mehw.is.me@inventati.org>

	Fix: Change Metalink/XML v3 file name into test.metalink
	* testenv/Test-metalink-xml-abspath.py: Change Metalink/XML v3 file
	  name from test.meta4 into test.metalink
	* testenv/Test-metalink-xml-relpath.py: Change Metalink/XML v3 file
	  name from test.meta4 into test.metalink
	* testenv/Test-metalink-xml.py: Change Metalink/XML v3 file name from
	  test.meta4 into test.metalink

2016-09-13  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add two Metalink/XML tests
	* testenv/Test-metalink-xml-abspath.py: Reject absolute paths
	* testenv/Test-metalink-xml-relpath.py: Reject relative paths
	* testenv/Makefile.am: Add both new files to metalink tests

2016-09-09  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix crash on 'srcset' inline URIs
	* src/html-url.c (tag_handle_img): Check append_url() for NULL
	  return value before dereference.

	Crashed reproducable with parsing srcset="data:..." inline data.
	Reported-by: Coverity

2016-09-09  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/hsts.c (hsts_store_open): NULL check param for fclose().
	Reported-by: Coverity

	* src/ftp-ls.c (ftp_parse_winnt_ls): Fix memset params

	* src/utils.c (stable_sort): Use xmalloc instead of malloc

2016-09-08  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/ftp-ls.c (ftp_parse_winnt_ls): Initialize struct fileinfo cur
	Reported-by: Coverity

	Add const to url param of some functions
	* src/http.c: Add const to first param of initialize_request(),
	  initialize_proxy_configuration(), establish_connection(),
	  check_file_output(), check_auth(), gethttp(), http_loop().
	* src/http.h: Add const to first param of http_loop().

	* Makefile.am: Remove trailing empty line

	* src/recur.c (retrieve_tree): Fix possible NULL dereference
	Reported-by: Coverity

	* src/http.c (initialize_request): Fix check for user
	Reported-by: Coverity

	* src/retr.c (retrieve_url): NULL check mynewloc
	Reported-by: Coverity

	* src/utils.c (stable_sort): Reduce tmp allocation size
	Reported-by: Coverity

	* Makefile.am: Add target 'check-valgrind'

	Fix some issues detected by Coverity
	* src/connect.c (connect_to_ip): Check return value of setsockopt.
	* src/ftp.c (ftp_retrieve_list): Check return value of chmod.
	* src/http.c (digest_authentication_encode): Cleanup code.
	* src/init.c (setval_internal): Explicitely check comind range.
	* src/main.c (main): Explicitely check optarg.
	* src/retr.c (retr_rate): Use snprintf instead sprintf,
	  (retrieve_from_file): More verbose error message,
	  (rotate_backups): Use snprintf instead sprintf, check return
	  value of rename().
	* src/url.c (mkalldirs): Check return value of unlink().
	* src/utils.c (strdupdelim): Explicitely check beg and end for NULL,
	  (merge_vecs): Fix sizeof argument to char *,
	  (stable_sort): Use malloc instead of alloca.

	Code cleanup for --use-askpass
	* bootstrap.conf: Add xmemdup0 and strpbrk.
	* src/init.c (cmd_use_askpass): Add 'const' to char *,
	  remove check for file existence.
	* src/main.c (run_use_askpass): C89 compat init of argv,
	  added \n to error messages,
	  fixed stripping of \n and \r from input,
	  make run_use_askpass and use_askpass static.

2016-09-07  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/http.c (check_file_output): Replace asprintf by aprint

2016-09-04  Tim Rühsen  <tim.ruehsen@gmx.de>

	* testenv/README: Remove obsolete references to TEST_NAME

2016-09-03  Liam R. Howlett  <Liam.Howlett@WindRiver.com>

	Add --use-askpass=COMMAND support
	* doc/wget.texi: Add --use-askpass to documentation.
	* src/init.c: Add cmd_use_askpasss to set opt.use_askpass based on
	argument, WGET_ASKPASS, and SSH_ASKPASS environment variables.
	opt.wget-askpass is freed in cleanup ()
	* src/main.c: Update options & add spawn process of opt.use_askpass
	command.
	* src/options.h: Addition of string use_askpass.
	* src/url.c: Function scheme_leading_string to access the leading
	string of a parsed url.
	* src/url.h: Prototype for scheme_leading_string for returning the
	leading string.
	* bootstrap.conf: Add posix_spawn to gnulib_modules

	This adds the --use-askpass option which is disabled by default.

	--use-askpass=COMMAND will request the username and password for a given
	URL by executing the external program COMMAND.  If COMMAND is left
	blank, then the external program in the environment variable
	WGET_ASKPASS will be used.  If WGET_ASKPASS is not set then the
	environment variable SSH_ASKPASS is used.  If there is no value set, an
	error is returned.  If an error occurs requesting the username or
	password, wget will exit.

2016-09-02  Dale R. Worley  <worley@ariadne.com>

	Add tests for recursion and redirection.
	    * testenv/Test-recursive-basic.py: New file. Test basic recursion
	    * testenv/Test-recursive-include.py: New File. Recursion test with
	    include directories
	    * testenv/Test-redirect.py: New File. Basic redirection tests
	    * testenv/Makefile.am: Add new tests to makefile

	Sort test names into order.
	    * testenv/Makefile.am: Sort all the python tests in alphabetical
	    order

	Corrections and amplifications to test documentation
	    * testenv/README: Update documentation to meet current project
	    status
	    * testenv/Test-Proto.py: Same

2016-08-24  Giuseppe Scrivano  <gscrivan@redhat.com>

	Append .tmp to temporary files
	* src/http.c (struct http_stat): Add `temporary` flag.
	(check_file_output): Append .tmp to temporary files.
	(open_output_stream): Refactor condition to use hs->temporary instead.

	Reported-by: "Misra, Deapesh" <dmisra@verisign.com>
	Discovered by: Dawid Golunski (http://legalhackers.com)

2016-08-24  Tim Rühsen  <tim.ruehsen@gmx.de>

	Limit file mode to u=rw on temp. downloaded files
	* bootstrap.conf: Add gnulib modules fopen, open.
	* src/http.c (open_output_stream): Limit file mode to u=rw
	on temporary downloaded files.

	Reported-by: "Misra, Deapesh" <dmisra@verisign.com>
	Discovered by: Dawid Golunski (http://legalhackers.com)

2016-08-21  Giuseppe Scrivano  <gscrivan@redhat.com>

	Fix some make syntax-check issues
	cfg.mk: Skip .der files.
	testenv/certs/server-template.cfg: Remove empty final line.
	testenv/certs/ca-template.cfg: Likewise.

2016-08-17  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/css-url.c (get_urls_css): Fix memory leak

	* src/html-url.c (get_urls_html): Fix memory leak

2016-08-17  Tim Rühsen  <tim.ruehsen@gmx.de>

	Improve PSL cookie checking
	* configure.ac: Add --with-psl-file to set a PSL file
	* src/cookies.c (check_domain_match): Load PSL_FILE with
	  fallback to built-in data.

	This change allows package maintainers to make Wget use the latest
	PSL (DAFSA or plain text), without updating libpsl itself.

	E.g. Debian now comes with a DAFSA binary within the 'publicsuffix'
	package which allows very fast loading (no parsing or processing needed).

2016-08-10  Tobias Stoeckmann  <tobias@stoeckmann.org>

	Fix stack overflow with way too many cookies
	* src/cookies.c (cookie_header): Use heap instead of stack.
	* src/http.c (request_send): Likewise.

	If wget has to handle an insanely large amount of cookies (~700,000 on
	32 bit systems or ~530,000 on 64 bit systems), the stack is not large
	enough to hold these pointers, leading to undefined behaviour according
	to POSIX; expect a segmentation fault in real life. ;)

2016-08-09  Tobias Stoeckmann  <tobias@stoeckmann.org>

	Fix signal race condition
	The signal handler for SIGALRM calls longjmp, but the handler is
	installed before the jump target has been initialized. If another
	process sends SIGALRM right between handler installation and target
	initialization, the jump leads to undefined behavior.

	This can easily be fixed by moving the signal handler installation
	into the "SETJMP == 0" conditional block, which means that the target
	has just been initialized.

	* src/utils.c: call signal after SETJMP.

2016-08-05  Jeffery To  <jeffery.to@gmail.com>

	Remove hyphens from command names
	* src/init.c: Remove hyphens from command names
	* src/main.c: Likewise

	Options with hyphens (or underscores) in their command name cannot be
	set in a wgetrc file.

2016-08-04  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/metalink.c (badhash_suffix): Fix quoting

2016-08-04  Matthew White  <mehw.is.me@inventati.org>

	Add new option --keep-badhash to keep Metalink's files with a bad hash
	* src/init.c: Add keepbadhash
	* src/main.c: Add keep-badhash
	* src/options.h: Add keep_badhash
	* doc/wget.texi: Add docs for --keep-badhash
	* src/metalink.h: Add prototypes badhash_suffix(), badhash_or_remove()
	* src/metalink.c: New functions badhash_suffix(), badhash_or_remove().
	  (retrieve_from_metalink): Call badhash_or_remove() on download error

	With --keep-badhash, append .badhash to Metalink's files with checksum
	mismatch. (retrieve_from_metalink): unique_create() may append another
	suffix to avoid overwriting existing files.

	Without --keep-badhash, remove downloaded files with checksum mismatch
	(this conforms to the old behaviour).

2016-08-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	* src/metalink.c: Remove C++ style comments

2016-08-03  Matthew White  <mehw.is.me@inventati.org>

	Add gnulib modules 'link', 'unlink' and 'symlink'
	* bootstrap.conf: Add 'link', 'unlink' and 'symlink'

2016-08-03  Matthew White  <mehw.is.me@inventati.org>

	New: --continue continues partially downloaded Metalink's files
	* src/metalink.c (retrieve_from_metalink): Continue file download if
	  opt.always_rest is true

	Without --continue, download as a new file with an unique name (this
	conforms to the old behaviour).

2016-08-03  Matthew White  <mehw.is.me@inventati.org>

	Add support for Metalink's md2, and md4 hashes
	* bootstrap.conf: Add crypto/md2, and crypto/md4
	* src/metalink.c (retrieve_from_metalink): Add md2, and md4 support

	This patch adds support for the deprecated (insecure) md2, and md4
	Message-Digest algorithms to the Metalink module.

2016-08-03  Matthew White  <mehw.is.me@inventati.org>

	Add support for Metalink's md5, sha1, sha224, sha384, and sha512 hashes
	* bootstrap.conf: Add crypto/sha512
	* src/metalink.c (retrieve_from_metalink): Add md5, sha1, sha224,
	  sha384, and sha512 support

	Metalink's checksum verification was limited to sha256. This patch
	adds support for md5, sha1, sha224, sha384, and sha512.

2016-07-27  Sean Burford  <sburford@google.com>

	Style fixes and DEBUG on setxattr failure.
	* src/ftp.c: Fix style.
	* src/http.c: Likewise.
	* src/xattr.h: Likewise.
	* src/xattr.c: Likewise,
	  (write_xattr_metadata): Print debug msg on error.

2016-07-22  Sean Burford  <sburford@google.com>

	Keep fetched URLs in POSIX extended attributes
	* configure.ac: Check for xattr availability
	* src/Makefile.am: Add xattr.c
	* src/ftp.c: Include xattr.h.
	  (getftp): Set attributes if enabled.
	* src/http.c: Include xattr.h.
	  (gethttp): Add parameter 'original_url',
	  set attributes if enabled.
	  (http_loop): Add 'original_url' to call of gethttp().
	* src/init.c: Add new option --xattr.
	* src/main.c: Add new option --xattr, add description to help text.
	* src/options.h: Add new config member 'enable_xattr'.
	* src/xatrr.c: New file.
	* src/xattr.h: New file.

	These attributes provide a lightweight method of later determining
	where a file was downloaded from.

	This patch changes:
	*   autoconf detects whether extended attributes are available and
	    enables the code if they are.
	*   The new flags --xattr and --no-xattr control whether xattr is enabled.
	*   The new command "xattr = (on|off)" can be used in ~/.wgetrc or /etc/wgetrc
	*   The original and redirected URLs are recorded as shown below.
	*   This works for both single fetches and recursive mode.

	The attributes that are set are:
	user.xdg.origin.url: The URL that the content was fetched from.
	user.xdg.referrer.url: The URL that was originally requested.

	Here is an example, where http://archive.org redirects to https://archive.org:
	$ wget --xattr http://archive.org
	...
	$ getfattr -d index.html
	user.xdg.origin.url="https://archive.org/"
	user.xdg.referrer.url="http://archive.org/"

	These attributes were chosen based on those stored by Google Chrome
	https://bugs.chromium.org/p/chromium/issues/detail?id=45903
	and curl https://github.com/curl/curl/blob/master/src/tool_xattr.c

2016-07-02  Noël Köthe  <noel@debian.org>

	Fix typos
	* ChangeLog-2014-12-10: invokation -> invocation
	* doc/wget.texi: invokation -> invocation
	* src/main.c: seperated -> separated
	* src/options.h: seperated -> separated
	* testenv/README: invokation -> invocation
	* testenv/conf/wget_commands.py: invokation -> invocation

2016-06-30  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix creating docs when make uses 'sh -e'
	* doc/Makefile.am: Save fallback for pod2man --utf8

	Reported-by: Jérémie Courrèges-Anglas <jca@wxcvbn.org>

2016-06-30  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix compilation for OpenSSL 1.1.0
	* src/openssl.c (ssl_init): Use SSL_is_init_finished() instead of
	  SSL_state(), conditionally skip SSLeay function calls

	The python test suite makes SSL_peek() hang, consuming 100% CPU time.
	This does not happen on real world TLS connections, though, but needs
	investigations.

2016-06-29  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add script to generate test certs non-interactive
	* Test-pinnedpubkey-hash-https.py: Read hashed pubkey from file
	* Test-pinnedpubkey-hash-no-check-fail-https.py: Use invalid hash
	* certs/make_ca.sh: New script to generate test certs non-interactive
	* certs/ca-template.cfg: New file (template for CA cert)
	* certs/server-template.cfg: New file (template for server cert)
	* certs/server-pubkey-sha256.base64: New file (pubkey sha256 hash)

2016-06-27  Ander Juaristi  <ajuaristi@gmx.es>

	Bypass world-writable checks on Windows
	 * src/hsts.c (hsts_file_access_valid): we should check for "world-writable"
	   files only on Unix-based systems. It's difficult to mimic the same behavior
	   on Windows, so it's better to just not do it.

	Reported-by: Gisle Vanem <gvanem@yahoo.no>
	Reported-by: Eli Zaretskii <eliz@gnu.org>

2016-06-14  Tim Rühsen  <tim.ruehsen@gmx.de>

	Update gnulib and bootstrap
	* gnulib: Sync gnulib submodule with upstream
	* bootstrap: Update to latest version from gnulib/build-aux/

2016-06-12  Tim Rühsen  <tim.ruehsen@gmx.de>

	Use ICONV_CONST to avoid type warning for iconv()
	* src/iri.c (do_conversion): Cast 2. param of iconv() to
	 'ICONV_CONST char **'
	* src/url.c (convert_fname): Likewise

	Remove check for HAVE_ICONV in src/url.c
	* src/url.c: Remove check for HAVE_ICONV

	Add gnulib module 'langinfo'
	* bootstrap.conf: Add 'langinfo'

	Include gnulib fcntl.h instead of sys/fcntl.h
	* src/gnutls.c: Include gnulib fcntl.h

	Add libraries to LDADD for wget
	* src/Makefile.am: Add $(GETADDRINFO_LIB) $(HOSTENT_LIB) $(INET_NTOP_LIB)
	 $(LIBSOCKET) $(LIB_CLOCK_GETTIME) $(LIB_CRYPTO) $(LIB_SELECT)
	 $(LTLIBICONV) $(LTLIBINTL) $(LTLIBTHREAD) $(SERVENT_LIB) to LDADD

2016-06-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	Explicitely mention Python3 in README.checkout
	* README.checkout: Python test suite needs Python3

2016-06-09  Giuseppe Scrivano  <gscrivan@redhat.com>

	NEWS: update

2016-06-09  Giuseppe Scrivano  <gscrivan@redhat.com>

	ftp: understand --trust-server-names on a HTTP->FTP redirect
	If not --trust-server-names is used, FTP will also get the destination
	file name from the original url specified by the user instead of the
	redirected url.  Closes CVE-2016-4971.

	* src/ftp.c (ftp_get_listing): Add argument original_url.
	(getftp): Likewise.
	(ftp_loop_internal): Likewise.  Use original_url to generate the
	file name if --trust-server-names is not provided.
	(ftp_retrieve_glob): Likewise.
	(ftp_loop): Likewise.

2016-06-07  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix warnings for --disable-iri configure flag
	* src/iri.h: Fix #define for parse_charset
	* src/html-url.c: Surround some IRI code parts by #ifdef ENABLE_IRI
	* src/http.c: Likewise
	* src/iri.h: Likewise
	* src/recur.c: Likewise
	* src/retr.c: Likewise

	Fix warning about redefinition of MAP_FAILED
	* src/sysdep.h: Removed definition of MAP_FAILED
	* src/utils.c: Check and define MAP_FAILED after including sys/mmap.h

2016-06-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add new Test for missing scheme behavior
	* testenv/Makefile.am: Add Test-missing-scheme-retval.py
	* testenv: New file Test-missing-scheme-retval.py

	Idea and Perl implementation by Zdenek Dohnal <zdohnal@redhat.com>

2016-05-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fallback to pod2man without utf-8 on error
	* doc/Makefile.am: Fallback to pod2man without utf-8 on error

2016-05-26  Ander Juaristi  <ajuaristi@gmx.es>

	Correct HSTS debug message
	 * src/main.c (save_hsts): save the in-memory HSTS database to a file
	   only if something changed.
	 * src/hsts.c (struct hsts_store): new field 'changed'.
	   (hsts_match): update field 'changed' accordingly.
	   (hsts_store_entry): update field 'changed' accordingly.
	   (hsts_store_has_changed): new function.
	 * src/hsts.h (hsts_store_has_changed): new function.

	Check the HSTS file is not world-writable
	 * hsts.c (hsts_file_access_valid): check that the file is a regular
	   file, and that it's not world-writable.
	   (hsts_store_open): if the HSTS database file does not meet the
	   above requirements, disable HSTS at all.

2016-05-24  Tim Rühsen  <tim.ruehsen@gmx.de>

	Improve description of Perl libraries needed for test suite
	* README.checkout: Improve text about Perl libraries

2016-05-23  Tim Rühsen  <tim.ruehsen@gmx.de>

	Remove special handling for Emacs in progress bar code
	* src/progress.c: Remove special 'emacs' code

	Fixes #47989

2016-04-25  Jernej Simončič  <jernej|s-wget@eternallybored.org>

	Fix xsleep() for Windows (trivial change)
	* src/mswindows.c (xsleep): Fix check for number of seconds

2016-04-17  Sergio Gelato  <sergio.gelato@astro.su.se>

	More accurate log message from do_conversion()
	* src/iri.c (do_conversion): More accurate log message

2016-04-17  Tim Rühsen  <tim.ruehsen@gmx.de>

	Include sys/select.h if HAVE_LIBCARES
	* src/hosts.c: Include sys/select.h if HAVE_LIBCARES

	Reported-by: Gisle Vanem <gvanem@yahoo.no>

2016-04-17  Gisle Vanem  <gvanem@yahoo.no>

	Fix Windows gnulib/c-ares incompatibility of select()
	* src/host.c: Undef 'select' on Windows

2016-04-15  Tim Rühsen  <tim.ruehsen@gmx.de>

	Set X flags for python tests
	* testenv/*.py: Set eXecute flags

	Regression from commit 926e42d4678689195a0bbed210c6d027db7cc390

2016-04-11  Ander Juaristi  <ajuaristi@gmx.es>

	Strictly comply with RFC 6797
	 * src/hsts.c (hsts_store_entry): strictly comply with RFC 6797.

	RFC 6797 states in section 8.1 that the UA's cached information should
	only be updated if:

	    "either or both of the max-age and includeSubDomains header field
	    value tokens are conveying information different than that already
	    maintained by the UA."

2016-04-11  Ander Juaristi  <ajuaristi@gmx.es>

	Correct HSTS database file description
	 * src/hsts.c (hsts_store_dump): s/[:port]/<port>/

2016-04-11  moparisthebest  <admin@moparisthebest.com>

	Implement tests for new pinnedpubkey option
	* testenv/Makefile.am: Add new tests
	* testenv/Test-pinnedpubkey-der-https.py: New test
	* testenv/Test-pinnedpubkey-der-no-check-https.py: New Test
	* testenv/Test-pinnedpubkey-hash-https.py: New test
	* testenv/Test-pinnedpubkey-hash-no-check-fail-https.py: New test
	* testenv/Test-pinnedpubkey-pem-fail-https.py: New test
	* testenv/Test-pinnedpubkey-pem-https.py: New test
	* testenv/certs/README: How to generate public keys with openssl tool
	* testenv/certs/server-pubkey.der: New key file (DER format)
	* testenv/certs/server-pubkey.pem: New key file (PEM format)

	Implement --pinnedpubkey option to pin public keys
	* doc/wget.texi: Add description for --pinnedpubkey
	* src/gnutls.c: New function pkp_pin_peer_pubkey(),
	  (ssl_check_certificate): Check pinned cert via pkp_pin_peer_pubkey()
	* src/init.c: Add option --pinnedpubkey
	* src/main.c: Add option --pinnedpubkey
	* src/openssl.c: New function pkp_pin_peer_pubkey(),
	  (ssl_check_certificate): Check pinned cert via pkp_pin_peer_pubkey()
	* src/options.h: Add new option variable 'pinnedpubkey'
	* src/utils.c: New functions wg_pubkey_pem_to_der(), wg_pin_peer_pubkey()
	* src/utils.h: Add prototype for wg_pin_peer_pubkey()

2016-04-11  Tim Rühsen  <tim.ruehsen@gmx.de>

	Use test file name for temp working directory name
	* testenv/test/base_test.py (__init__): Use test file name for name,
	  remove 'name' parameter
	* testenv/test/http_test.py (__init__): Remove 'name' parameter
	* testenv/*.py: Remove TEST_NAME

	Using a fixed string (TEST_NAME) to build the working directory
	for testing caused random failures (or successes) when tests
	share the same TEST_NAME value. Not easy to find without digging
	into the python test suite code.
	We now use the test file name, which is unique within the test
	environment.

2016-04-11  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix testenv/Test--rejected-log.py
	* testenv/Test--rejected-log.py: Add missing tabs in expected output

	Fail python tests when post_hook errors
	* testenv/test/base_test.py (__exit__): Return self.tests_passed
	  (__test_cleanup): Set self.tests_passed to False on exception

2016-03-29  Darshit Shah  <darnir@gmail.com>

	Print the fingerprint instead of the raw pointer in debugging message
	* src/metalink.c (retrieve_from_metalink): Fix debug message to print the
	fingerprint instead of a pointer.

	* Do not delete the ChangeLog file since it is required by the Makefile
	and breaks compilation

2016-03-29  Darshit Shah  <darnir@gmail.com>

	Revert "Print the fingerprint instead of the raw pointer in debugging message"
	This reverts commit b916595168b6eb0f8868a67a9d214d5e0022871f.

2016-03-28  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fixed URLs and references in wget.texi
	* wget.texi: Replace server.com by example.com,
	  replace ftp://wuarchive.wustl.edu by https://example.com,
	  use HTTPS instead of HTTP where possible,
	  fix list archive reference,
	  remove reference to wget-notify@addictivecode.org,
	  change bugtracker URL to bugtracker on Savannah,
	  replace yoyodyne.com by example.com,
	  fix URL to VMS port

2016-03-25  Giuseppe Scrivano  <gscrivan@redhat.com>

	* metalink.c (retrieve_from_metalink): Fix typo

	Print the fingerprint instead of the raw pointer in debugging message
	* src/metalink.c (retrieve_from_metalink): Fix debug message to print the
	fingerprint instead of a pointer.

2016-03-23  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add options --bind-dns-address and --dns-servers
	* README.checkout: Add description for libares
	* configure.ac: Add check for libares
	* doc/wget.texi: Add docs for the new options
	* src/build_info.c.in: Add +/-cares for --version output
	* src/host.c:
	  (merge_address_lists): New static function
	  (address_list_from_hostent): New static function
	  (wait_ares): New static function
	  (callback): New static function
	  (lookup_host): Add libares resolver code
	* src/init.c: Add new options,
	  (cleanup): Add cleanup code
	* src/main.c: Add global libares channel variable
	  (cmdline_option option_data): Add new options
	  (print_help): Add short descriptions
	  (main): Add libares init code
	* src/options.h (struct options): Add option members

	The new options allow to specify alternative DNS servers and
	an alternate packet route for the resolver packets.
	Wget has to built with libares, enabled at configure time by
	./configure --with-cares.

2016-03-16  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix SNI server names with trailing dot(s)
	* src/gnutls.c (ssl_connect_wget, ssl_check_certificate): Fix SNI server name
	* src/openssl.c (ssl_connect_wget, ssl_check_certificate): Fix SNI server name

	Fixes #47408

2016-03-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix links to original Robots Exclusion Standard
	* doc/wget.texi: Fix links

2016-03-05  Darshit Shah  <darnir@gmail.com>

	Fix assertion in Progress bar
	    * src/progress.c (create_image): Fix off-by-one error in assert()
	    statement for progress bar width.
	    Reported-By: Gisle Vanem <gvanem@yahoo.no>

2016-03-03  Giuseppe Scrivano  <gscrivan@redhat.com>

	src/url.c: fix make syntax-check

2016-03-03  Maks Orlovich  <morlovich@google.com>

	Parse <img srcset> attributes, they have image URLs.
	* src/convert.h: Add link_noquote_html_p to permit rewriting URLs deep
	                 inside attributes without adding extraneous quoting
	* src/convert.c (convert_links): Honor link_noquote_html_p
	* src/html_url.c (tag_handle_img): New function. Add srcset parsing.

2016-03-01  Darshit Shah  <darnir@gmail.com>

	Sanitize value sent to memset to prevent SEGFAULT

2016-03-01  Darshit Shah  <darnir@reniac.com>

	Update documentation about bahviour of -c
	    * docs/wget.texi: -c will restart download from scratch if server
	    does not support RANGE.

	    Reported-By: David Chavez
	    http://stackoverflow.com/questions/30147332/unexpected-behavior-of-wget

2016-02-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix writing WARC-Target-URI value
	src/warc.c: Add function warc_write_header_uri(),
	            Use it for creating WARC-Target-URI

	Fixes #47281

2016-02-13  Darshit Shah  <darnir@gmail.com>

	Remove pointer to unused Mailing List
	    * MAILING-LISTS: Remove pointer to old, unused mailing list for bug
	    reports

2016-02-11  Tim Rühsen  <tim.ruehsen@gmx.de>

	Retain value of errno in logprintf(), logputs() even better
	* src/log.c (logprintf,logputs): Save&Restore value of errno

	Reported-by: Gisle Vanem <gvanem@yahoo.no>

2016-02-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	Retain value of errno in logprintf()
	* src/log.c (logprintf): Save&Restore value of errno

	Reported-by: Gisle Vanem <gvanem@yahoo.no>

2016-02-01  Tim Rühsen  <tim.ruehsen@gmx.de>

	Set AM_SILENT_RULES to yes by default
	* configure.ac: Set AM_SILENT_RULES to yes by default

2016-02-01  Ander Juaristi  <ajuaristi@gmx.es>

	Enforce 'RejectHeader' rule in tests
	 * server/http/http_server.py (_Handler.RejectHeader): enforce
	   'RejectHeader' rule.

2015-12-20  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix Test-iri-forced-remote
	* tests/Test-iri-forced-remote.px: Fix encodings

2015-12-18  Eli Zaretskii  <eliz@gnu.org>

	Support non-ASCII URLs
	* src/url.c [HAVE_ICONV]: Include iconv.h and langinfo.h.
	(convert_fname): New function.
	[HAVE_ICONV]: Convert file name from remote encoding to local
	encoding.
	(url_file_name): Call convert_fname.
	(filechr_table): Don't consider bytes in 128..159 as control
	characters.

	* tests/Test-ftp-iri.px: Fix the expected file name to match the
	new file-name recoding.  State the remote encoding explicitly on
	the Wget command line.

	* NEWS: Mention the URI recoding when built with libiconv.

2015-12-18  Giuseppe Scrivano  <gscrivan@redhat.com>

	* NEWS: Prepare new development cycle

2015-12-17  Tim Rühsen  <tim.ruehsen@gmx.de>

	Cleanup code
	* src/iri.c (do_conversion): Code cleanup

2015-12-17  Eli Zaretskii  <eliz@gnu.org>

	Set URI encoding when redirected
	* src/retr.c (retrieve_url): Set URI on redirection

2015-12-17  Tim Rühsen  <tim.ruehsen@gmx.de>

	Remove requesting X/Open 5, POSIX 1995
	* src/sysdep.h: Remove #define _XOPEN_SOURCE 500

2015-12-16  Eli Zaretskii  <eliz@gnu.org>

	Avoid hanging on MS-Windows when invoked with --connect-timeout
	* src/connect.c (connect_to_ip) [WIN32]: Don't call fd_close if
	the connection timed out, to avoid hanging.

2015-12-15  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix iconv conversion
	* src/iri.c: Kick out the last converted character from iconv()

	Thanks to Eli Zaretskii <eliz@gnu.org> for suggesting the fix.
	Reported-by: "Andries E. Brouwer" <Andries.Brouwer@cwi.nl>

2015-12-14  Tim Rühsen  <tim.ruehsen@gmx.de>

	Let Test-k survive on CygWin and Windows
	* tests/Test-k.px: Use --restrict-file-names for CygWin/Windows
	  filename requirements.

2015-12-13  Ander Juaristi  <ajuaristi@gmx.es>

	Fix leak in HSTS code
	* src/hsts.c (hsts_store_open): close fp if open.

	Remove unused variable in ftp code
	* src/ftp.c (getftp): fix compiler warning for unused variable.

2015-12-11  Giuseppe Scrivano  <gscrivan@redhat.com>

	Tag release 1.17.1
	* NEWS: Update.
	* gnulib: sync from upstream.

2015-12-11  Tim Rühsen  <tim.ruehsen@gmx.de>

	Remove ABOUT-NLS from git
	* ABOUT-NLS: Remove from repository, it will be autogenerated.
	* .gitignore: Add ABOUT-NLS and build-aux/ar-lib

2015-12-11  Jernej Simončič  <jernej|s-wget@eternallybored.org>

	* src/metalink.c: Specify 'rb' as mode to open file

2015-12-10  Ángel González  <keisial@gmail.com>

	* doc/wget.texi: add hint for self-signed certificates

2015-12-10  Ander Juaristi  <ajuaristi@gmx.es>

	Fix Coverity issues
	 * src/ftp.c (getftp): on error, close the file and attempt to remove it
	   before exiting.
	 * src/hsts.c (hsts_store_open): update modification time in the end.

2015-12-10  Darshit Shah  <darnir@gmail.com>

	Faster Travis Builds
	* contrib/travis-ci: Test under different languages only when all the
	features are enabled. This covers the maximum number of strings. For the
	other option permutations, test only in the default C locale

	Fix remaining bugs in progress bar implementation
	* src/progress.c (create_image): Ensure that the entire screen width is
	drawn everytime to prevent any artefacts from leaking through.

2015-12-09  Darshit Shah  <darnir@gmail.com>

	Add bug-wget to list of travis recipients
	* .travis.yml: Add bug-wget to list of Travis Report Recipients

	Eliminate more compiler warnings
	* src/options.h (CHECK_CERT_MODES): Remove C99 style comma after last
	value
	* src/progress.c (create_image): Do not mix statements and declarations
	* src/init.c (cmd_boolean_internal): Mark unused parameters

	Re-enable test on multibyte locale in Travis
	* .travis.yml: Use Russian locale instead of Japanese since it seems to
	be more complete
	* contrib/travis-ci: Re-enable testing on a Russian locale

	Fix progress bar assertion with multibyte locales
	* src/progress.c (bar_create): Define size of progress buffer explicitly
	  (create_image): Clean up progress bar image creation. Use memset
	  instead of for loops to create arrays of the same byte.

2015-12-06  Darshit Shah  <darnir@gmail.com>

	Introduce Travis Integration
	* .travis.yml: Configuration file for Travis-CI
	* contrib/travis-ci: Script to run on travis. Similar to check-hard but modified
	  for travis.
	* tests/valgrind-suppressions{-ssl}: Add extra suppressions to prevent a
	Valgrind False Positive errors in an old version

	Since Travis currently supports only public repositories on GitHub, the support
	for automated testing through Travis will be done using my Clone of Wget on
	GitHub at: https://github.com/darnir/wget.git
	Any commits pushed to this repository will trigger a build on Travis.

2015-12-04  Tim Rühsen  <tim.ruehsen@gmx.de>

	SKIP SSL/TLS tests if configured without it
	* testenv/Makefile.am: Set SSL_TESTS env variable
	* testenv/Test--https-crl.py, testenv/Test--https.py,
	  testenv/Test-hsts.py: Return 77 (SKIP) if SSL/TLS is not configured

2015-12-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add Test-hsts.py to SSL_TESTS
	* testenv/Makefile.am: Add Test-hsts.py to SSL_TESTS

2015-12-03  Ygal Blum  <ygal.blum@technicolor.com>

	Fix compilation when without-ssl is selected

2015-12-03  Darshit Shah  <darnir@gmail.com>

	Include Metalink and GPG information in version
	* src/build_info.c.in: Include the presence of Metalink and GPGME features in
	the output for wget --version

2015-12-03  Giuseppe Scrivano  <gscrivan@redhat.com>

	Add --check-certificate=quiet
	* doc/wget.texi: Add documentation for  --check-certificate=quiet.
	* src/options.h (enum CHECK_CERT_MODES): New enum.
	* src/init.c (cmd_check_cert): New static function.
	(cmd_boolean_internal): Likewise.
	* src/gnutls.c (ssl_check_certificate): Handle CHECK_CERT_QUIET.
	* src/openssl.c (ssl_check_certificate): Handle CHECK_CERT_QUIET.

2015-11-24  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix regression in HTTP authentication
	* src/http.c (initialize_request): Fix wrong params to search_netrc()

	Regression introduced in commit 29850e77
	Reported-by: Axel Reinhold <axel@freakout.de>

2015-11-23  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix SIGSEGV in -N / --content-disposition combination
	* src/http.c (http_loop): Fix SIGSEGV

	Reported-by: "Schleusener, Jens" <Jens.Schleusener@t-online.de>

2015-11-20  Ander Juaristi  <ajuaristi@gmx.es>

	Fix potential NULL pointer dereference
	 * src/gnutls.c (ssl_connect_wget): check for NULL before calls

2015-11-20  Giuseppe Scrivano  <gscrivan@redhat.com>

	* configure.ac: change gettext version to 0.18.1

2015-11-19  Ikey Doherty  <michael.i.doherty@intel.com>

	configure.ac: Use correct gettext version

2015-11-19  Tim Rühsen  <tim.ruehsen@openmediasystem.de>

	Fix HSTS memory issue + test code issue
	* src/hsts.c (hsts_find_entry): Fix freeing memory
	  (hsts_remove_entry): Remove freeing host member
	  (hsts_match): Free host member here
	  (hsts_store_entry): Free host member here
	  (test_url_rewrite): Fix 'created' value
	  (test_hsts_read_database): Fix 'created' value

	Reported-by: Dagobert Michelsen <dam@opencsw.org>

2015-11-17  Tim Rühsen  <tim.ruehsen@gmx.de>

	Include errno.h instead of sys/errno.h (Solaris issue)
	* src/metalink.c: Include errno.h instead of sys/errno.h

	Reported-by: Dagobert Michelsen <dam@opencsw.org>

2015-11-17  Darshit Shah  <darnir@gmail.com>

	Fix compile error when IPv6 is disabled
	* src/ftp-basic.c: The code for the new FTPS functionality was unintentionally
	inside a #ifdef IPV6 block. Move the code around so that it is defined even when
	IPV6 isn't used

	Use gnulib module flock to provide function
	* bootstrap.conf: Use module flock from gnulib to provide it on other platforms
	such as Windows.

2015-11-16  Darshit Shah  <darnir@gmail.com>

	Eliminate NDEBUG redefined warnings
	* src/wget.h: Define NDEBUG only if it hasn't been defined before

2015-11-15  Giuseppe Scrivano  <gscrivan@redhat.com>

	NEWS: prepare new release cycle

	Prepare release 1.17
	* gnulib: sync with upstream.
	* NEWS: Update.
	* src/main.c: Change the copyright year.

2015-11-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	Document combination of -nc and -O
	Fixes #46359

2015-11-03  Tim Rühsen  <tim.ruehsen@gmx.de>

	Do not download/save file on error when --spider enabled
	* src/http.c (gethttp,http_loop):
	  Do not download/save file on error when --spider is enabled and not
	  working recursive.

	Reported-by: Сковорода Никита Андреевич chalkerx@gmail.com
	Fixes #45821

2015-10-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix URL conversion for colons in filenames
	* src/convert.c (construct_relative): Prepend './' to filename
	* tests/Test-k.px: Amend test to succeed

2015-10-15  Tim Rühsen  <tim.ruehsen@gmx.de>

	Adjust indentation of --no-use-server-timestamps in help output
	* src/main.c: Adjust indentation of --no-use-server-timestamps

2015-10-13  Ander Juaristi  <ajuaristi@gmx.es>

	Added --convert-file-only option
	 * src/convert.c (convert_links_in_hashtable, convert_links):
	   test for CO_CONVERT_BASENAME_ONLY.
	   (convert_basename): new function.
	 * src/convert.h: new constant CO_CONVERT_BASENAME_ONLY.
	 * src/init.c, src/main.c, src/options.h: new option "--convert-file-only".
	 * doc/wget.texi: updated documentation.

	 Reviewed-by: Gabriel Somlo <somlo@cmu.edu>

2015-10-12  Darshit Shah  <darnir@gmail.com>

	Fix Test-ftp-pasv-not-supported.px
	    * tests/Test-ftp-pasv-not-supported.px: We do *NOT* expect any
	    downloaded files. Also, do not negate the Test response.

	    The test originally expected a downloaded file, but this is not
	    true. As a result, the test would fail and return exit code 1. This
	    was presumably the reason why the test result was negated before
	    returning to the shell. Fix this issue, so that the test runs
	    correctly without any hacks.

2015-10-12  Darshit Shah  <darnir@gmail.com>

	Fix make distcheck failures in Perl SSL Tests
	    * tests/Makefile.am: Add valgrind-suppressions-ssl to EXTRA_DIST
	    * tests/Test-proxied-https-auth-keepalive.px: Find valgrind in
	    correct path during make distcheck
	    * tests/Test-proxied-https-auth.px: Same

2015-10-12  christian fafard  <cfaf@hotmail.com>

	Skip HTTPS perl tests if IO::Socket::SSL not installed
	* tests/Test-proxied-https-auth-keepalive.px: Skip test if perl module
	  IO::Socket::SSL is not installed (trivial change).
	* tests/Test-proxied-https-auth.px: Skip test if perl module
	  IO::Socket::SSL is not installed (trivial change).

2015-10-09  Ander Juaristi  <ajuaristi@gmx.es>

	Fix potential race condition
	 * src/hsts.c (hsts_read_database): get an open file handle
	   instead of a file name.
	   (hsts_store_dump): get an open file handle
	   instead of a file name.
	   (hsts_store_open): open the file and pass the open file handle.
	   (hsts_store_save): lock the file before the read-merge-dump
	   process.

	 Reported-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

2015-10-09  Ander Juaristi  <ajuaristi@gmx.es>

	Fix HSTS merge bug
	 * src/hsts.c (hsts_store_merge): call hsts_new_entry() if the entry
	   does not exist in the database.

	When merging the existing HSTS database on disk with the one on memory,
	the entries that were on disk but not on memory were ignored. Thus,
	only the existing entries were merged. This behavior was only triggered
	when more than one Wget processes were using the same HSTS database
	simultaneously. This commit fixes the bug by adding the new entries
	to the on-memory database if they were not found there.

2015-09-28  Giuseppe Scrivano  <gscrivan@redhat.com>

	testenv/Test--rejected-log.py: Remove trailing white spaces

2015-09-28  Tim Rühsen  <tim.ruehsen@gmx.de>

	Handle TLS rehandshakes in GnuTLS code
	* src/gnutls.c: New static function _do_handshake()
	* src/gnutls.c (wgnutls_read_timeout): Handle rehandshake
	* src/gnutls.c (wgnutls_write): Handle rehandshake
	* src/gnutls.c (ssl_connect_wget): Move handshake code into _do_handshake()

	Fixes #46061

2015-09-22  Darshit Shah  <darnir@gmail.com>

	Add tests for missing qop in digest auth
	    * testenv/test-auth-both.py: Add qop parameter for digest auth
	    * testenv/test-auth-digest.py: Same
	    * testenv/conf/authentication.py: Support additional parameters for
	    authentication
	    * testenv/servers/http/http_server.py: Same

	Do not test for impossible qop value
	    * http.c (digest_authentication_encode): Wget already errors out if
	    qop != "auth". Then it makes no sense to test for qop == "auth-int"
	    later on. Currently, Wget does not support the "auth-int" qop value
	    and till nobidy requests, it may remain so.

2015-09-22  Darshit Shah  <darnir@gmail.com>

	Fix #46024. Support RFC 2069 Digest Authentication
	    * http.c (digest_authentication_encode): Some servers are still
	    using the obsolete RFC 2069 Digest Authentication. Allow Digest
	    authentication without the qop parameter for this.

	    Reported-by: Andreas Longwitz  <longwitz@incore.de>

2015-09-21  Darshit Shah  <darnir@gmail.com>

	Revert "Disable progress bar when wget is backgrounded (trivial patch)"
	This reverts commit e6247325633d7d0007906f88d573a3bfa37307a7.

2015-09-20  Giuseppe Scrivano  <gscrivan@redhat.com>

	NEWS: cite FTPS support

2015-09-14  Ander Juaristi  <ajuaristi@gmx.es>

	Added support for FTPS
	 * doc/wget.texi: updated documentation to reflect the new FTPS functionality.
	 * src/ftp-basic.c (ftp_greeting): new function to read the server's greeting.
	   (ftp_login): greeting code was previously here. Moved to ftp_greeting to
	   support FTPS implicit mode.
	   (ftp_auth): wrapper around the AUTH TLS command.
	   (ftp_ccc): wrapper around the CCC command.
	   (ftp_pbsz): wrapper around the PBSZ command.
	   (ftp_prot): wraooer around the PROT command.
	 * src/ftp.c (get_ftp_greeting): new static function.
	   (init_control_ssl_connection): new static function to start SSL/TLS on the
	   control channel.
	   (getftp): added hooks to support FTPS commands (RFCs 2228 and 4217).
	   (ftp_loop_internal): test for new FTPS error codes.
	 * src/ftp.h: new enum 'prot_level' with available FTPS protection levels +
	   prototypes of previous functions. New flag for enum 'wget_ftp_fstatus' to track
	   whether the data channel has some security mechanism enabled or not.
	 * src/gnutls.c (struct wgnutls_transport_context): new field 'session_data'.
	   (wgnutls_close): free GnuTLS session data before exiting.
	   (ssl_connect_wget): save/resume SSL/TLS session.
	 * src/http.c (establish_connection): refactor ssl_connect_wget call.
	   (metalink_from_http): take into account SCHEME_FTPS as well.
	 * src/init.c, src/main.c, src/options.h: new command line/wgetrc options.
	   (main): in recursive downloads, check for SCHEME_FTPS as well.
	 * src/openssl.c (struct openssl_transport_context): new field 'sess'.
	   (ssl_connect_wget): save/resume SSL/TLS session.
	 * src/retr.c (retrieve_url): check new scheme SCHEME_FTPS.
	 * src/ssl.h (ssl_connect_wget): refactor. New parameter of type 'int *'.
	 * src/url.c. src/url.h: new scheme SCHEME_FTPS.
	 * src/wget.h: new FTPS error codes.
	 * src/metalink.h: support FTPS scheme.

2015-09-10  Christian Neukirchen  <chneukirchen@gmail.com>

	Disable progress bar when wget is backgrounded (trivial patch)
	* src/progress.c (create_image): progress only when in foreground

	Sometimes I start wget, but the remote site is too slow, so I rather
	want to run it in background, however when I simply use job control
	for that, wget will keep spewing the progress bar all over my
	terminal.  I have found the SIGHUP/SIGUSR1 feature to redirect output
	to a log file, but I think the following small patch is even more
	useful, since the progress bar will simply resume when wget is
	foregrounded again (also, the final message is still printed to the
	terminal in any case):

2015-09-04  Hubert Tarasiuk  <hubert.tarasiuk@gmail.com>

	Add information about libmetalink and GnuPG
	* README.checkout: Optional dependencies and URL references.

2015-09-02  Hubert Tarasiuk  <hubert.tarasiuk@gmail.com>

	Do not free Metalink structure if not initialized
	* src/main.c (main): Move metalink_delete to the conditional block.

2015-09-01  Ander Juaristi  <ajuaristi@gmx.es>

	Updated HSTS documentation
	 * doc/wget.texi: updated HSTS documentation.

	   Reported-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

2015-09-01  Ander Juaristi  <ajuaristi@gmx.es>

	Extra debug traces for HSTS.
	 * src/main.c (load_hsts, save_hsts): added DEBUGP() calls to signal
	   reads and saves of the HSTS database file.

2015-08-31  Darshit Shah  <darnir@gmail.com>

	Fix coding style violation in last commit
	    * http.c (test_parse_range_header): Declare loop variable
	    explicitly. Not in gnu99 standard.

2015-08-30  Darshit Shah  <darnir@gmail.com>

	Add unit test for parse_content_range() method
	    * http.c (test_parse_range_header): New function to test the
	    function for parsing the HTTP/1.1 Content-Range header.
	    * test.[ch]: Same
	    * http.c (parse_content_range): Fix parsing code. Fail on scenarios
	    mentioned in rfc 7233.

2015-08-30  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix null pointer dereference
	* src/metalink.c (gpg_skip_verification):
	  Check output_stream before fclose

	Fix leaks found by Coverity
	* src/http.c (parse_strict_transport_security): Free c_max_age
	             (open_output_stream): Fix indentation
	* src/iri.c (locale_to_utf8): Free new

2015-08-29  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix two leaks foudn by Coverity
	* src/http.c (gethttp): Do not leak 'message'.
	* src/main.c (format_and_print_line): Do not leak 'line_dup'.

	Fix resource leak discovered by Coverity
	* src/retr.c (retrieve_url): Don't leak local_file.

2015-08-29  Darshit Shah  <darnir@gmail.com>

	Fix memory leaks in unit-test
	    * hsts.c (get_hsts_store_filename): Free the homedir value
	    (close_hsts_test_store): Actually free the store struct too
	    (test_hsts_new_entry): Pass store to close_hsts_test_store()
	    (test_hsts_url_rewrite_superdomain): Same
	    (test_hsts_url_rewrite_congruent): Same
	    (test_hsts_read_database): Same and homedir and store filename
	    * http.c (test_parse_content_disposition): Free the returned
	    filename
	    * url.c (test_append_uri_pathel): Free allocated string

	Fix mixed-indentation in http.c
	    * http.c: Fix mix indentation. Visual change only.

2015-08-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	Suppress debug output when strings may contain password
	* iri.c (do_conversion): Do not print out converted strings if they
	  contain an '@'. That could be an URL with embedded password.

	Fixes #45825

2015-08-26  Ander Juaristi  <ajuaristi@gmx.es>

	Fix resource leak.
	 * src/http.c (parse_strict_transport_security): Freed memory to avoid resource leak.
	   Comply with GNU coding style.

2015-08-22  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix typo in NEWS
	* NEWS: Change typo --accept-reject into --accept-regex

	Reported-by: grarpamp <grarpamp@gmail.com>

2015-08-21  Jookia  <166291@gmail.com>

	Clarify that links are being converted.
	* src/convert.c: Add 'links in' after 'Converted %d' and 'Converting %s'.

	Removed useless TODOs.
	 * testenv/Test--reject-log.py: Remove TODOs.

2015-08-15  Miquel Llobet  <mllobet.cm@gmail.com>

	Fixed #44516 -o- not logging to stdout
	src/log.c (log_init): check for hypen on filename, set stdout

2015-08-15  Daniele Calore  <daniele.calore@tin.it>

	Fix #40426: Allow -r -O- only if FILE is regular
	    * main.c: added check of "-r -O FILE" option combination
	    allow only if FILE is a regular file (bug #40426)

2015-08-15  Darshit Shah  <darnir@gmail.com>

	Fix var name conflicts with math.h and wingdi.h
	    * src/recur.c (reject_reason): Rename all enum members to WG_RR_xx.
	    * src/recur.c (retrieve_tree, download_child,
	    write_reject_log_reason): Same

2015-08-14  Tim Rühsen  <tim.ruehsen@gmx.de>

	Let bootstrap/autoreconf work without GPGME installed
	* configure.ac: Check for existance of AM_PATH_GPGME

2015-08-11  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix IP address exposure in FTP code
	* src/ftp.c (getftp): Do not use PORT when PASV fails.
	* tests/FTPServer.px: Add pasv_not_supported server flag.
	* tests/Makefile.am: Add Test-ftp-pasv-not-supported.px
	* tests/Test-ftp-pasv-not-supported.px: New test

	Fix IP address exposure when automatically falling back from
	passive mode to active mode (using the PORT command). A behavior that
	may be used to expose a client's privacy even when using a proxy.

2015-08-07  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix C89 compliancy in HSTS test code
	* src/hsts.c (test_hsts_new_entry):
	  Move variable assignment before code

	Fix C89 compliancy in latest code
	* src/recur.c: Declare variables before code
	  (write_reject_log_url):
	    Use const keyword where appropriate
	    Use the 'default' switch statement
	    Use xfree() instead of free()
	    Renamed variable f -> fp
	  (write_reject_log_reason):
	    Use const keyword where appropriate
	    Use the 'default' switch statement
	    Renamed variable f -> fp
	    Renamed variable r -> reason

2015-08-07  Tim Rühsen  <tim.ruehsen@gmx.de>

	Remove redundant definition of _GNU_SOURCE
	* src/warc.c: Remove definition of _GNU_SOURCE

	_GNU_SOURCE is already defined in config.h

2015-08-07  Giuseppe Scrivano  <gscrivan@redhat.com>

	NEWS: update

2015-08-07  Jookia  <166291@gmail.com>

	Rewrite the --rejected-log test using the new framework.
	 * tests/Test--rejected-log.px: Remove old test.
	 * testenv/Test--rejected-log.py: Create new test.

	Replace variables before comparing expected files.
	* expected_files.py: Use formatted_content instead of file.content.

2015-08-06  Jookia  <166291@gmail.com>

	Add option to write URL rejections to a tab-delimited CSV log.
	 * main.c: Add "--rejected-log" option.
	 * init.c: Add "rejectedlog" command.
	 * options.h: Add "rejected_log" parameter string.
	 * wget.texi: Add brief documentation on new --rejected-log option.
	 * recur.c: Optionally log details of URLs not traversed.
	   Add reject_reason enum.
	   (download_child_p -> download_child): Return a reject_reason.
	   (descend_redirect_p -> descend_redirect): Return a reject_reason.
	   (retrieve_tree): Support logging reasons for rejection.
	   Add write_reject_log_header that writes a CSV format header to a file.
	   Add write_reject_log_url that writes a url struct to a file in CSV format.
	   Add write_reject_log_reason that writes the URL and parent URL as well as the
	   rejection reason to a CSV file.
	 * Test--rejected-log.px: Add a basic test for the --rejected-log command.
	 * tests/Makefile.am: Run Test--rejected-log.px.

	This allows you to figure out why URLs are being rejected and some context
	around it. CSV is used as the output format since it can be used easily parsed,
	it's delimited by tabs instead of commas to allow using all (quoted) URL
	characters and includes column names which may be used for compatibility.

2015-08-04  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix memory leak in HSTS code
	* src/main.c (get_hsts_database): Free 'home' variable

	void uninitialized variable in metalink code
	* src/metalink.c: Init retr_err with METALINK_MISSING_RESOURCE
	* src/wget.h: Add enum METALINK_MISSING_RESOURCE

2015-07-24  Darshit Shah  <darnir@gmail.com>

	Fix function name collision with OpenSSL library
	    * src/utils.[ch], src/http.c, src/metalink.c: Rename function
	    hex_to_string() to wg_hex_to_string sine it collides with a
	    similarly named function in OpenSSL Library.

	Fix configure options for metalink
	    * configure.ac: Ensure metalink support can be properly disabled

2015-07-22  Alex Henrie  <alexhenrie24@gmail.com>

	Make the filename marquee a proper marquee
	* src/progress.c: Start the marquee in the middle of the available space
	  and do not restart it until all of the text has scrolled out of view.

2015-07-20  Giuseppe Scrivano  <gscrivan@redhat.com>

	NEWS: cite HSTS

	Fix metalink tests
	testenv/Test-metalink-http.py: initialize HTTP test server
	testenv/Test-metalink-xml.py: initialize HTTP test server

2015-07-20  Ander Juaristi  <ajuaristi@gmx.es>

	Enhancements in testsuite engine + new HSTS test.
	 * testenv/Makefile.am: added new test 'Test-hsts.py'.
	 * testenv/Test-hsts.py: new test for HSTS.
	 * testenv/conf/domains.py: new hook to override domain list.
	 * testenv/test/base_test.py: (__init__): new optional parameter
	   for tests 'req_protocols'.
	   (get_domain_addr): set the instance variables 'addr' and 'port'.
	   Return address as an array (domain, port) instead of string.
	   (gen_cmd_line): take into account domain and port.
	 * testenv/test/http_test.py (__init__): new optional parameter
	   'req_protocols'.
	   (setup): new function. Call to server_setup() decoupled from
	   begin() and moved here.
	   (begin): call to superclass to maintain backward compatibility.
	   Removed call to server_setup().

	This patch adds a new parameter to the test suite called 'req_protocols',
	and a new function called 'setup'. The ability for tests to be able to set some
	extra parameters such as the actual requested protocols (with 'req_protocols')
	became obvious when support for HSTS was added to Wget, where the requested URI
	and the actual executed URI do not have to be the same. This new parameter is optional
	and if not specified, the test suite behaves as before. Also, the new function 'setup'
	is provided as a means to start the test HTTP server, but not launch the test yet
	(this is done when calling 'begin', as usual), in case we want to query the address
	and port in which the test server listens. If 'setup' is not called, it is automatically
	invoked when calling 'begin'. With these measures, we preserve backward-compatibility with
	existing tests.

2015-07-20  Ander Juaristi  <ajuaristi@gmx.es>

	Added support for HSTS.
	 * Makefile.am: Added new source files hsts.c and hsts.h.
	 * http.c (parse_strict_transport_security): new function for STS header
	   parsing.
	   (gethttp): update the HSTS store.
	 * http.h: new include "hsts.h".
	 * init.c: new options --hsts and --hsts-file.
	 * main.c (get_hsts_database, load_hsts, save_hsts): new functions.
	   New options --no-hsts and --hsts-file added to help.
	   (main): load and save HSTS store.
	 * options.h: new variables for supporting --hsts and --hsts-file.
	 * retr.c (retrieve_url): rewrite the URI according to the HSTS policy before
	   entering http_loop.
	 * test.c, test.h: new unit tests for HSTS.
	 * utils.c, utils.h (countchars): new function.
	 * wget.h: new preprocessor check.
	 * hsts.c, hsts.h: new files with the HSTS engine implementation.

	Added support for HTTP Strict Transport Security (HSTS), as defined by RFC
	6797.

2015-07-20  Giuseppe Scrivano  <gscrivan@redhat.com>

	NEWS: cite metalink support

	fix compiler warnings
	* src/utils.h: Include <stdlib.h>
	* src/recur.c: Include "exits.h"

2015-07-20  Hubert Tarasiuk  <hubert.tarasiuk@gmail.com>

	Test preferred location in Metalink-over-HTTP test case.
	* testenv/Test-metalink-http.py: Ensure preferred location is handled
	properly.

	Geolocation support for Metalink resources.
	* doc/wget.text: Add information about --preferred-location.
	* src/init.c: Add --preferred-location option.
	* src/main.c (option_data): Handle --preferred-location argument.
	(main): Sort resources based on location if requested.
	* src/metalink.c (metalink_res_cmp): Compare based on location if
	priority and preference are equal.
	* src/options.h (options): Add preferred_location option.

	Support at most one file signature. Adapt comments to libmetalink 0.13.
	* src/metalink.c (retrieve_from_metalink): Add comment about new
	libmetalink version. Do not iterate over signatures - support just one.

	Move some Metalink-related code from http.c to metalink.c.
	* src/http.c: Move find_key_value, has_key, find_key_values.
	* src/metalink.c: To here.
	* src/metalink.h: Make them non-static and add prototypes here.

	Unit test for find_key_values.
	* src/http.c: Add test_find_key_values.
	* src/test.c (main): Run new test.
	* src/test.h: Add test_find_key_values.

	Unit test for has_key.
	* src/http.c: Add test_has_key.
	* src/test.c (main): Run new test.
	* src/test.h: Add test_has_key.

	Unit test for find_key_value.
	* src/http.c: Add test_find_key_value.
	* src/test.c (main): Run new test.
	* src/test.h: Add test_find_key_value.

	Test case for Metalink over HTTP.
	* testenv/Test-metalink-http.py: New test.
	* testenv/Makefile.am: Add to test list.

	Support multiple headers with same name in Python test suite.
	* testenv/README: Describe how to use repeated header name.
	* testenv/server/http/http_server.py (finish_headers): Send all
	values from list if the header value is a Python list.

	Test case for Metalink in XML.
	* testenv/Test-metalink-xml.py: New test.
	* testenv/Makefile.am: Add file for automake.

	Start HTTP test only when calling begin().
	* testenv/test/http_test.py: Move self.do_test() from __init__ to
	begin().

	Metalink support.
	* bootstrap.conf: Add crypto/sha256
	* configure.ac: Look for libmetalink and GPGME
	* doc/wget.texi: Add --input-metalink and --metalink-over-http
	options description.
	* po/POTFILES.in: Add metalink.c
	* src/Makefile.am: Add new translation unit (metalink.c)
	* src/http.c (http_stat): Add metalink field.
	(free_stat): Free metalink field.
	(find_key_value): Find value of given key in header string.
	(has_key): Check if token exists in header string.
	(find_key_values): Find all key=value pairs in header string.
	(metalink_from_http): Obtain Metalink metadata from HTTP response.
	(gethttp): Call metalink_from_http if requested.
	(http_loop): Request Metalink metadata from HTTP response if should be.
	Fall back to regular download if no Metalink metadata found.
	* src/init.c: Add --input-metalink and --metalink-over-http options
	* src/main.c (option_data): Handle --input-metalink and
	--metalink-over-http cmd arguments.
	(print_help): Print --input-metalink option description.
	(main): Retrieve files from Metalink file
	* src/metalink.c (retrieve_from_metalink): Download files described by
	metalink.
	(metalink_res_cmp): Comparator for resources priority-sorting.
	* src/metalink.h: Create header for metalink.c
	(RES_TYPE_SUPPORTED): Define supported resources media.
	(DEFAULT_PRI): Default mirror priority for Metalink over HTTP.
	(VALID_PRI_RANGE): Valid priority range.
	* src/options.h (options): Add input_metalink option and metalink_over_http
	options.
	* src/utils.c (hex_to_string): Convert binary data to ASCII-hex.
	* src/utils.h (hex_to_string): Add prototype.
	* src/wget.h: Add metalink-related error enums
	Add METALINK_METADATA flag for document type.

2015-07-15  Romain Bentz  <romain.bentz@dataiku.com>

	Add NULL value check to fix #45289
	* src/recur.c (retrieve_tree): Check return value of url_parse()

2015-07-14  Tim Rühsen  <tim.ruehsen@gmx.de>

	Let HTTPS tests XFAIL when no TLS support configured
	* configure.ac: Export WITH_SSL for use in Makefile.am
	* testenv/Makefile.am: Add HTTPS tests to XFAIL_TESTS when !WITH_SSL

	Reported-by: Ander Juaristi <ajuaristi@gmx.es>

2015-07-01  Tim Rühsen  <tim.ruehsen@gmx.de>

	Change function params to const in src/iri.[ch]
	* iri.h, iri.c: Added const attribute for params of parse_charsset(),
		check_encoding_name(), idn_encode(), idn_decode(),
		remote_to_utf8(), set_uri_encoding(), set_content_encoding().

	Work around a libidn <= 1.30 vulnerability
	* src/iri.c: Add _utf8_is_valid() to check UTF-8 sequences before
	  passing them to idna_to_ascii_8z().

2015-06-27  Ángel González  <keisial@gmail.com>

	Fix wgetrc filename creation for Windows
	* init.c/wgetrc_file_name: Remove obsolete code in WINDOWS code path

	Reported-by: Gisle Vanem <gvanem@yahoo.no>

2015-06-16  Darshit Shah  <darnir@reniac.com>

	Add valgrind suppression files for HTTPS tests
	    * testenv/test/base_test.py: Use Valgrind SSL suppressions file for
	    tests
	    * testenv/valgrind-suppression-ssl, tests/valgrind-suppression-ssl:
	    Add new suppression files to suppress OpenSSL errors in valgrind
	    * tests/test-proxied-https-auth.px: Use the valgrind SSL
	    suppressions file for the test
	    * tests/test-proxied-https-auth-keepalive.px: Same

2015-06-14  Darshit Shah  <darnir@reniac.com>

	contrib/check-hard: Indentation and spacing cleanup
	    * contrib/check-hard: Reduce the amount of text output to the
	    screen. Also implement some indentation and whitespace cleanups.

2015-06-14  Tim Rühsen  <tim.ruehsen@gmx.de>

	Fix usage of CFLAGS in contrib/check-hard
	* contrib/check-hard: Set CFLAGS per command line instead of using export.

	'make distcheck' changes CFLAGS. So using ./configure -C together with
	exported CFLAGS fails. Setting CFLAGS per command line works smoothly.

2015-06-13  Tim Rühsen  <tim.ruehsen@gmx.de>

	Move test_* function protoypes from test.c to test.h
	* src/test.c: Remove test_* function prototypes, make tests_run static
	* src/test.h: Add test_* function protoypes

2015-05-23  Giuseppe Scrivano  <gscrivan@redhat.com>

	NEWS: cite --if-modified-since

	gnulib: update gnulib

2015-05-22  Hubert Tarasiuk  <hubert.tarasiuk@gmail.com>

	Include --if-modified-since option in user manual.
	* doc/wget.texi: Add --if-modified-since section.

	Support If-Modified-Since header in timestamping mode.
	* src/wget.h: Add IF_MODIFIED_SINCE enum for dt. Add TIMECONV_ERR
	enum to uerr_t.
	* src/http.c (time_to_rfc1123): Convert time_t do http time.
	* src/http.c (initialize_request): Include If-Modified-Since header
	if appropriate.
	* src/http.c (set_file_timestamp): Separate this code from check_file_output.
	* src/http.c (check_file_output): Use set_file_timestamp.
	* src/http.c (gethttp): Handle properly 304 return code and 200 if server
	ignores If-Modified-Since headers.
	* src/http.c (http_loop): Load filename to hstat if condget was requested,
	use IF_MODIFIED_SINCE if requested and current timestamp can be obtained.

	Add --if-modified-since option
	* src/init.c: Add to commands array.
	* src/main.c: Add to cmdline_option. Add to help message.
	* src/options.h: Add to options struct.

	Add test for condget requests.
	* testenv/Test-condget.py: the test
	* testenv/Makefile.am: add to tests list

	Support conditional GET in testenv server.
	* src/exc/server_error.py: Add exception for GET to HEAD fallback.
	* src/server/http/http_server.py: Do not send body if 304 return
	code requested for a file.

	Implement timestamp support for local files in testenv
	* testenv/README: Change timestamp format definition
	* testenv/conf/local_files.py: Set proper timestamps

2015-05-20  Pär Karlsson  <feinorgh@gmail.com>

	Fix undeclared loop variable in Perl test suite
	Reported-by: Hubert Tarasiuk <hubert.tarasiuk@gmail.com>

2015-05-12  Ander Juaristi  <ajuaristi@gmx.es>

	Make sure Wget does not unescape reserved chars.
	* testenv/Test-reserved-chars.py: New file.

	* testenv/Makefile.am: Added new test Test-reserved-chars.py.

	When following redirections, Wget should not unescape the reserved
	characters that might appear in target URLs.

2015-05-12  Ander Juaristi  <ajuaristi@gmx.es>

	Fixed incorrect handling of reserved chars.
	* src/iri.c (do_conversion): Call url_unescape_except_reserved,
	instead of url_unescape.

	* src/url.c (url_unescape_1): New static function.
	(url_unescape): Calls url_unescape_1 with mask zero. Preserves
	same behavior as before. Only code changes.
	(url_unescape_except_reserved): New function.

	* src/url.h: Added prototype for url_unescape_except_reserved().

	When the locale is US-ASCII, URIs that contain special characters
	in them are converted to IRIs according to RFC 3987, section 3.2
	"Converting URIs to IRIs".

2015-05-07  Darshit Shah  <darnir@reniac.com>

	Fix documentation for update_speed_ring()
	    * progress.c (update_speed_ring): The comment for the function
	    incorrectly stated that the function uses thirty samples from the
	    past instead of twenty.

	    Reported-By: Yi Li <lovelylich@gmail.com>

2015-05-04  Darshit Shah  <darnir@reniac.com>

	Remove shadowed variable in http.c
	    * http.c (gethttp): Rename err to conn_err to prevent shadowed
	    variable

2015-05-04  Steven Schubiger  <stsc@member.fsf.org>

	paramcheck: use explicit quoting for here-docs
	* util/paramcheck.pl: Adjust here-docs

2015-05-03  Tim Ruehsen  <tim.ruehsen@gmx.de>

	Fix format specifier warning
	* src/utils.c (aprintf): Use %d for int argument

2015-05-01  Nikolay Merinov  <kim.roader@gmail.com>

	Fix timestamping and continue behaviour with ftp protocol.
	* src/ftp.c (ftp_loop_internal): Add option `force_full_retrieve' that force to
	retrieve full file.
	(ftp_retrieve_list): Pass `true' as `force_full_retrieve' option to
	`ftp_loop_internal' if we want to download file with newer timestamp than local
	copy.

2015-04-27  Rohit Mathulla  <rohit_mathulla@yahoo.com>

	openssl: Read cert from private key file when needed
	* src/openssl.c (ssl_init): Assign opt.cert_{file, type}
	  from opt.private_key(_type)

	Fix double free bug in SSL code
	* src/openssl.c, src/gnutls.c (ssl_init): Copy options using xstrdup

2015-04-20  Hubert Tarasiuk  <hubert.tarasiuk@gmail.com>

	Single exit point and common cleanup code in gethttp
	* src/http.c (gethttp): Common cleanup for type, message,
	  req, resp, head.  Single exit point.

2015-04-17  Tim Rühsen  <tim.ruehsen@gmx.de>

	Silence warning in perl test suite
	* tests/WgetTests.pm: Use string comparisons for $valgrind variable

2015-04-17  Tim Rühsen  <tim.ruehsen@gmx.de>

	Check memory allocations in WARC code
	* src/warc.c: Remove some memory allocations,
	              use xmalloc instead of malloc

	Reported-by: Bill Parker <wp02855@gmail.com>

2015-04-17  Tim Rühsen  <tim.ruehsen@gmx.de>

	Add more const usage to function params
	* warc.c, warc.h: Add const specifier to several function args

2015-04-14  Darshit Shah  <darnir@reniac.com>

	PEP8'ify the Python Test Suite
	    * testenv/conf/{__init__,authentication,files_crawled,
	      hook_sample,reject_header,server_files}.py: Aesthetic changes to
	      meet Python PEP8 guidelines
	    * testenv/exc/{server_error,test_failed}.py: Same
	    * testenv/misc/{colour_terminal,wget_file}.py: Same
	    * testenv/server/http/http_server.py: Same
	    * testenv/test/base_test.py: Same

2015-04-13  Ander Juaristi  <ajuaristi@gmx.es>

	Improved test suite documentation
	* README.checkout: Added reference to Python. New section
	  "Testing and development". Updated information about test suites.

	Added support for GDB in Python tests
	* base_test.py (gen_cmd_line): Check GDB_TESTS environment variable.

2015-04-13  Tim Ruehsen  <tim.ruehsen@gmx.de>

	Added GDB support to Perl tests
	* WgetTests.pm (run): Check GDB_TESTS environment variable.

2015-04-11  Hubert Tarasiuk  <hubert.tarasiuk@gmail.com>

	Add Valgrind suppression for libidn.so at idna_to_ascii_4z
	* tests/WgetTests.pm (run): Include suppression file when running Valgrind.
	* tests/valgrind-suppressions: Add suppression for idn_to_ascii_4z.
	* tests/Makefile.am: Add valgrind-suppressions to EXTRA_DIST.

2015-04-11  Ángel González  <keisial@gmail.com>

	Remove memory leak in idn_encode.
	* src/iri.c (idn_encode): Free buffer from remote_to_utf8
	when needed; give meaningful names to variables;
	remove excessive comment.

2015-04-10  Hubert Tarasiuk  <hubert.tarasiuk@gmail.com>

	Fix error in free_vec.
	* src/utils.c (free_vec): Increment pointer instead of its value.

	Reported-by: Gisle Vanem <gvanem@yahoo.no>

2015-04-10  Ángel González  <keisial@gmail.com>

	Fix const usage in iri.c
	* src/iri.c (remote_to_utf8): Do not qualify with const the output pointer.
	(do_conversion): Use the provided input parameter as const.
	(idn_encode): casts to remote_to_utf8 parameters are no longer needed.
	* src/iri.h: Adjusted remote_to_utf8 prototype.
	* src/url.c: It is no longer necessary to cast new_url to const char.

2015-04-06  Miquel Llobet  <mllobet.cm@gmail.com>

	Fixed #44628 honoring RFC 6266 content-disposition
	src/http.c (parse_content_disposition): stores filename* and filename
	separately and choses filename* if available.
	(test_parse_content_disposition): added new tests.

2015-04-02  Giuseppe Scrivano  <gscrivan@redhat.com>

	NEWS: cite last change

2015-04-02  Steven M. Schweda  <sms@antinode.info>

	Add option to restrict filenames used VMS.
	* src/options.h (enum restrict_files_os): Define "restrict_vms".
	* src/init.c (defaults) [__VMS]: Set "opt.restrict_files_os" to
	"restrict_vms".
	(cmd_spec_restrict_file_names): honor "vms".
	* src/url.c (filechr_not_unix): Define "filechr_not_vms".
	(filechr_table): Update for VMS.
	(append_uri_pathel): Honor opt.restrict_files_os.
	(FN_QUERY_SEP): Update for VMS.
	(FN_QUERY_SEP_STR): Update for VMS.

2015-04-01  Hubert Tarasiuk  <hubert.tarasiuk@gmail.com>

	Change semantics of resp_free and request_free in http.c
	* src/http.c (resp_free): Change the semantics of this function.
	(request_free): Change the semantics of this function.
	(initialize_request): Adjust request_free call.
	(establish_connection): Adjust request_free, resp_free calls.
	(gethttp): Adjust request_free, resp_free calls.

	Do not free request in establish_connection; do it in gethttp
	* src/http.c (establish_connection): Do not free request here (it is
	* never allocated here).
	* src/http.c (gethttp): Free request before returning if error in
	* establish_connection encountered.

	Transform read_header label and goto into a loop
	* src/http.c (gethttp): Replace label and goto statement with a do
	loop.

2015-03-31  Hubert Tarasiuk  <hubert.tarasiuk@gmail.com>

	Factor out set_content_type function from gethttp
	* src/http.c (gethttp): Move some code in...
	(set_content_type): ... a new function.

2015-03-18  Giuseppe Scrivano  <gscrivan@redhat.com>

	Factor out some gethttp code
	* src/http.c (gethttp): Move some code in...
	(open_output_stream): ... a new function.

	Factor out some auth gethttp code
	* src/http.c (gethttp): Move some code in...
	(check_auth): ... a new function.

	Factor out some gethttp code
	* src/http.c (gethttp): Move some code in...
	(check_file_output): ... a new function.

	Factor out some connection initialization code for gethttp
	* src/http.c (gethttp): Move some initialization code in...
	(establish_connection): ... a new function.

	Factor out some proxy initialization code for gethttp
	* src/http.c (gethttp): Move some initialization code in...
	(initialize_proxy_configuration): ... a new function.

	Factor out some initialization code for gethttp
	* src/http.c (gethttp): Move some initialization code in...
	(initialize_request): ... a new function.

2015-03-18  Tim Ruehsen  <tim.ruehsen@gmx.de>

	src/ftp.c: make sure warc_tmp becomes closed before return
	Reported-by: Coverity bug #1188044

	src/http.c: fix error return of digest_authentication_encode()
	Reported-by: Coverity bug #1188036

2015-03-17  Rohan Prinja  <rohan.prinja@gmail.com>

	Convert wget.texi to UTF-8
	* doc/wget.texi: convert to UTF-8 by adding @documentencoding
	* doc/Makefile.am: Pass argument --utf8 to pod2man.

2015-03-16  Ander Juaristi Alamos  <ajuaristi@gmx.es>

	* doc/wget.texi: The default is GnuTLS, not OpenSSL.

2015-03-16  Darshit Shah  <darnir@gmail.com>

	testenv/http_server: Allow overriding Headers
	We would like to override existing headers in the response from the
	server to allow the test cases to define their own headers. This patch
	allows this behaviour through the use of the add_header() method while
	also allowing sending multiple headers of the same name.

2015-03-14  Darshit Shah  <darnir@gmail.com>

	retr.c: Fix memory leak in retrieve_from_file()
	Reported by: Coverity Bug 1188045

	html-url.c: Fix potential memory leaks
	Reported by: Coverity Bug 1188050

	main.c: Fix two potential memory leaks
	Reported by: Coverity bug 1188048

	retr.c: Fix two memory leaks when proxy URL is bad
	Reported by: Coverity bug 1188047

2015-03-13  Darshit Shah  <darnir@reniac.com>

	Docs: --post-file is binary data
	Wget considers the file mentioned in the --post-file argument as a
	binary file and does not strip any control characters. The lack of this
	information in the documentation can cause a lot of headaches debugging
	for a simple issue

2015-03-09  Giuseppe Scrivano  <gscrivan@redhat.com>

	maint: update copyright year ranges to include 2015

	NEWS: Prepare new development cycle

2015-03-09  Yousong Zhou  <yszhou4tech@gmail.com>

	Fix --content-on-error option handling.
	* src/http.c: Log --content-on-error downloads.
	* src/retr.c (retrieve_url): Register the download of an error page
	when --content-on-error is specified.

	testenv: add test case Test--convert-links--content-on-error.py.
	* testenv/Makefile.am: Register the new test.
	* testenv/Test--convert-links--content-on-error.py: Add test case for
	the combination of --convert-links and --content-on-error.py.

	testenv: fix http_server.py with Response and Authentication.
	* testenv/exc/server_error.py: Try writing file content for GET
	request even if there is a Response rule present.
	* testenv/server/http/http_server.py: Likewise.

	testenv: improve color output a bit.
	* testenv/misc/colour_terminal.py: Only print color codes when stdout
	isatty().

	testenv: typo and style fix.
	* testenv/server/http/http_server.py(BaseTest): Add docstring; use raw
	string for regex.
	* testenv/server/http/http_server.py(_Handler): Typo fix.
	* testenv/conf/server_files.py(ServerFiles): Code style change for
	readability plus another typo fix.

2015-03-09  Giuseppe Scrivano  <gscrivan@redhat.com>

	NEWS: tag 1.16.3

2015-03-08  Anderson Goulart  <global@kokre.com>

	src/main.c (--no-verbose): don't show progress bar
	Fixes #44431

2015-03-06  Darshit Shah  <darnir@reniac.com>

	main.c: Use assertion to test buffer size

2015-03-02  Darshit Shah  <darnir@gmail.com>

	main.c: Need to explicitly disallow show_progress in -q

2015-02-28  Giuseppe Scrivano  <gscrivan@redhat.com>

	NEWS: add other items and tag 1.16.2

	gnulib: sync gnulib

2015-02-27  Giuseppe Scrivano  <gscrivan@redhat.com>

	NEWS: Update file

2015-02-23  Eli Zaretskii  <eliz@gnu.org>

	warc.c: native uuid generation on Windows
	* warc.c (windows_uuid_str) [WINDOWS]: New function specific to
	MS-Windows.
	(warc_uuid_str) [WINDOWS]: If windows_uuid_str succeeds, use its
	result; otherwise use the fallback method.

2015-02-18  Gisle Vanem  <gvanem@yahoo.no>

	idn: use idn_free() to free allocated libidn memory
	xfree() might crash on libidn memory on Windows.

	From 'man idn_free':
	"Under Windows, different parts of the same application may use different
	 heap memory, and then it is important to deallocate memory allocated within
	 the same  module  that  allocated it. This function makes that possible."

2015-02-10  Tim Rühsen  <tim.ruehsen@gmx.de>

	gettext: Use gnulib's gettext.h for compatibility
	Fixes issues with gettext on Solaris
	Reported-by: Kiyoshi KANAZAWA <yoi_no_myoujou@yahoo.co.jp>

	src/openssl.c: Use SSL_state() instead of ssl_st.state
	Changes in OpenSSL 1.0.2 API hides ssl_st structure members.
	Reported-by: Gisle Vanem <gvanem@yahoo.no>

2015-01-31  Giuseppe Scrivano  <gscrivan@redhat.com>

	* README.checkout: Remove duplicated word

	* cfg.mk (VC_LIST_ALWAYS_EXCLUDE_REGEX): Add ChangeLog-2014-12-10.

2015-01-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	README.checkout: Mention libio-socket-ssl-perl to be installed

2015-01-22  Dagobert Michelsen  <dam@opencsw.org>

	tests/Makefile.am: Solaris needs libintl and libiconv for testsuite

2015-01-20  Darshit Shah  <darnir@gmail.com>

	progress bar: Allow display on stderr alongwith -o
	This commit causes the --show-progress option to print the progress bar
	to stderr even when a logfile was explicitly provided on the command
	line. Such a combination allows a user to log the output of Wget while
	simultaneously keeping track of the download status.

2015-01-18  Darshit Shah  <darnir@gmail.com>

	gnulib: Pull submodule forward

2015-01-16  Mathieu Parent  <math.parent@gmail.com>

	src/connect.c: More verbose error message (tiny change)
	This fixes Debian bug #144076.

2015-01-04  Tim Ruehsen  <tim.ruehsen@gmx.de>

	src/ftp-basic.c: Accept 5-digit port numbers in EPSV responses
	Reported-by: Adam Sampson <ats@offog.org>

2015-01-02  Tim Rühsen  <tim.ruehsen@gmx.de>

	README.checkout: Add libpcre, pkg-config, libgnutls
	Add description for libpcre
	Add description for pkg-config
	Add description of GnuTLS
	Add 2014,2015 copyright year
	Use ASCII copyright characters

2014-12-27  Tim Ruehsen  <tim.ruehsen@gmx.de>

	src/http.c: Revert commit d81a8d5f56fca2746c4ad83d764bd24adcfbe927
	The removal of the 'redundant' condition was a failure.
	Fixes: #43876
	Reported-by: Sean Jensen-Grey <seanj@xyke.com>

2014-12-25  Tim Ruehsen  <tim.ruehsen@gmx.de>

	configure.ac: Skip pkg-config for opensl and gnutls when prefix is given
	Make --with-libssl-prefix and --with-libgnutls-prefix do the right thing,
	no matter if pkg-config is installed or not.

	Reported-by: Charles Diza <chdiza@gmail.com>

2014-12-25  Tim Ruehsen  <tim.ruehsen@gmx.de>

	src/main.c, src/warc.c: Use gnulib's base_name() instead of basename()
	Reported-by: Eli Zaretskii <eliz@gnu.org>

2014-12-24  Giuseppe Scrivano  <gscrivan@redhat.com>

	Generate distributed ChangeLog from git log
	* bootstrap.conf (gnulib_modules): Add "gitlog-to-changelog".
	* Makefile.am: Generate the ChangeLog file from the git log and
	the old ChangeLog data.

	merge ChangeLog files in ChangeLog-2014-12-10.
	* ChangeLog: truncate file.
	* ChangeLog.README: Likewise.
	* doc/ChangeLog: Likewise.
	* msdos/ChangeLog: Likewise.
	* src/ChangeLog: Likewise.
	* testenv/ChangeLog: Likewise.
	* tests/ChangeLog: Likewise.
	* ChangeLog-2014-12-10: New file.
	* Makefile.am: Distribute ChangeLog-2014-12-10.

2014-12-21  Eli Zaretskii  <eliz@gnu.org>

	src/utils.c: Don't include termios.h on Windows

2014-12-21  Tim Ruehsen  <tim.ruehsen@gmx.de>

	tests/FTPServer.pm: Fix ftp tests for Windows
	The Single Unix strftime format specifier %e is not supported by
	MS Windows. Instead we now use %d.

	Reported-By: Eli Zaretskii <eliz@gnu.org>

2014-12-21  Tim Rühsen  <tim.ruehsen@gmx.de>

	gnulib: Use basename() from gnulib module 'dirname'
	Avoid basename incompatibilities between POSIX and GNU implementations.
	Also, libgen.h isn't needed any more which increases compatibility.

2014-12-21  Giuseppe Scrivano  <gscrivan@redhat.com>

	contrib/check-hard: delete trailing whitespaces and repeated word

2014-12-21  Benno Schulenberg  <bensberg@justemail.net>

	* src/main.c (print_help): Indent description continuation lines by two spaces.

	* src/main.c (print_help): Don't use a possessive instead of a plural.

	* src/main.c (print_help): Don't use the backtick as a left quote mark in the help text.

	* src/main.c (print_help): Remove the full stops from option descriptions.
	And use semicolons to separate multiple phrases in a description.

	* src/main.c (print_help): Make all option descriptions start with a lowercase letter.
	Also spell URL consistently in all uppercase, and fix the grammar.

2014-12-20  Tim Ruehsen  <tim.ruehsen@gmx.de>

	doc/wget.texi: Add 'https_only' in 'wgetrc commands' section
	Reported-By: Eli Zaretskii <eliz@gnu.org>

2014-12-20  Eli Zaretskii  <eliz@gnu.org>

	tests/WgetTests.pm: Print timestamps when tests fail due to wrong timestamps

2014-12-19  Tim Rühsen  <tim.ruehsen@gmx.de>

	sample.wgetrc: Fix wrong command 'locale' into 'localencoding'
	Reported-by: Eli Zaretskii <eliz@gnu.org>

	wget.texi: Clarify wgetrc command syntax
	Reported-by: Eli Zaretskii <eliz@gnu.org>

2014-12-18  Tim Rühsen  <tim.ruehsen@gmx.de>

	configure.ac: Fix libuuid and uuid_create detection
	--with-libuuid now explictly asks for libuuid.
	--without-libuuid ignores libuuid and tries to use libc builtin functions.
	Else try builtin functions first, libuuid second and fallback to Wget's own
	function.

2014-12-17  Yuriy M. Kaminskiy  <yumkam@gmail.com>

	src/log.c: Fix unexpected termination in logprintf (tiny change)
	When errno was set to EPIPE before call to logprintf (e.g. during close of
	SSL connection that was reset by peer), it will unexpectedly terminate wget.
	It should exit only when EPIPE was triggered by logging code.

	Regression by 0b5b100fc9aaa54257ffa16a083a862c031c335b

2014-12-17  Tim Rühsen  <tim.ruehsen@gmx.de>

	configure.ac: Check for RAND_egd() in pkg-config success code

	src/main.c: Conditionally print help for --random-file and --egd-file
	--random-file is only relevant when compiled with either OpenSSL or LibreSSL.
	--egd-file is only relevant when compiled with OpenSSL

	src/init.c: Fix indentation for crlfile option

	wget.texi: Document --random-file and --egd-file as OpenSSL only

2014-12-17  Jérémie Courrèges-Anglas  <jca@wxcvbn.org>

	openssl: Detect the availability of RAND_egd (tiny change)
	Alternatives like LibreSSL don't provide RAND_egd() anymore.
	Fixes compilation on OpenBSD.

	Fix use of uuid libc functions (tiny change)
	* Always attempt to detect uuid.h and uuid_create().
	* Split libuuid and uuid.h implementations of warc_uuid_str(), since
	  those APIs vary significantly.
	* Correctly use the uuid.h functions

2014-12-16  Darshit Shah  <darnir@gmail.com>

	Revert "ChangeLog: Move all ChangeLog files to .pre-gitlog"
	This reverts commit fcd3b3c473be25c4967fd8139d976e76faaef1b6.

	Turns out that removing the ChangeLog files causes the Wget build to
	fail. While this issue is investigated and sorted out, the commit is
	reversed to allow people to be able to build Wget from master

2014-12-16  Tim Rühsen  <tim.ruehsen@gmx.de>

	contrib: Added script contrib/check-hard to check Wget status
	This script automates some tests, e.g. testing with and without valgrind,
	using different configure options. It is aimed at developers to execute
	before pushing commits.

2014-12-16  Cong Ma  <cma@pmo.ac.cn>

	ftp: fix invalid pointer dereference in getftp() (tiny change)
	The pointer respline in use after being passed to ftp_response() may be
	uninitialized if ftp_response() fails.  Ensure that respline be used
	after checking the return value of ftp_response().

2014-12-15  Darshit Shah  <darnir@gmail.com>

	ChangeLog: Move all ChangeLog files to .pre-gitlog
	From v1.16.1 onwards, Wget no longer maintains an active ChangeLog file.
	Instead the ChangeLog will be automatically generated on each release
	through gnulib's gitlog-to-changelog script. However, the old versions
	of the ChangeLog files are retained for reference. These files are
	renamed with a .pre-gitlog appended to their filenames.
	Also removed ChangeLog.README file which is not required anymore

2014-12-12  Tim Rühsen  <tim.ruehsen@gmx.de>

	src/iri.c: Call xstrndup instead of strndup
	strndup() does not exist in some older C libraries, also xstrndup()
	exits on memory allocation failures.

	bootstrap.conf: Add module 'getline'
	This function does not exist in some older C libraries.

2014-12-12  Tim Rühsen  <tim.ruehsen@gmx.de>

	src/iri.c: Use c_strcasestr instead of strcasestr
	This also fixes a problem with strcasestr not being in the
	boostrap.conf module list.

	Reported-by: Kiyoshi KANAZAWA <yoi_no_myoujou@yahoo.co.jp>

2014-12-11  Friedrich Haubensak  <hsk@fli-leibniz.de>

	Add support for older versions of flex (tiny change)
	E.g. flex 2.5.4 (Solaris 10) does not like a space after -o.

2014-12-11  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/Makefile.am: Support older versions of flex

2014-12-10  Tim Ruehsen <tim.ruehsen@gmx.de>

	* configure.ac: Check for pcre.h

2014-12-08  Giuseppe Scrivano  <gscrivan@redhat.com>

	* cfg.mk (local-checks-to-skip): Add sc_cast_of_argument_to_free.

2014-12-05  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/Makefile.am: Removed reference to cmpt.c

2014-12-05  Tim Ruehsen <tim.ruehsen@gmx.de>

	* configure.ac: Fix message for when GnuTLS has not been found.

2014-12-05  Tim Ruehsen <tim.ruehsen@gmx.de>

	* bootstrap.conf: Add modules fnmatch, memrchr, strcase, strptime,
	strtoll, timegm
	Remove module strcasecmp
	Use module spawn-pipe instead of deprecated module pipe

2014-12-04  Darshit Shah  <darnir@gmail.com>

	* src/wget.h: Define MIX and MAX macros globally for all files
	* src/gnutls.c, retr.c: Delete declaration of MIN macro
	* src/http.c, progress.c: Delete declaration of MIN and MAX macros

2014-12-04  Darshit Shah  <darnir@gmail.com>

	* src/ftp.c (getftp): Remove a call to assert(1) and replace with error message.
	Also fix indentation

2014-12-03  Jérémie Courrèges-Anglas  <jca@wxcvbn.org> (tiny change)

	* src/openssl.c (ssl_init): Allow pfs to be used with protocols other than
	TLSv1.

2014-12-03  Gisle Vanem  <gvanem@yahoo.no>

	* src/openssl.c (ssl_init): Fix C89 warning

2014-12-03  Gisle Vanem  <gvanem@yahoo.no>

	* src/mswindows.c (ws_cleanup): Fix compiler error

2014-12-01  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/connect.c, iri.c, url.c, warc.c: Fix issues reported
	by static code analysis tool 'parfait'.

	Closes: #41235
	Reported-by: Jiri Kukacka

2014-11-29  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/utils.h: xfree() sets argument to NULL after freeing,
	removed xfree_null()
	* src/connect.c, cookies.c, ftp-basic.c, ftp-ls.c, ftp.c hash.c,
	host.c, html-url.c, http.c, init.c, iri.c, log.c, main.c,
	mswindows.c, netrc.c, openssl.c, recur.c, res.c, retr.c,
	url.c, warc.c: Replaced xfree_null() by xfree()

2014-11-28  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/main.c: Fix length of program_argstring,
	fix regression introduced with commit
	9217b864d865cf1766e1589d138c8fc17d3d3d5c.

2014-11-28  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/gettext.h: Removed this file
	* src/wget.h: Do not include gettext.h, include libintl.h directly,
	define _() as gettext() shortcut.

	The header file gettext.h is simply not needed.

2014-11-28  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/Makefile.am: Removed gettext.h

2014-11-27  Darshit Shah  <darnir@gmail.com>

	* src/cookies.c, gettext.h, init.c, retr.c, url.c, warc.c: Replace usage of
	free() with xfree() macro.

2014-11-26  Tim Ruehsen <tim.ruehsen@gmx.de>

	* tests/HTTPServer.pm: Substitue server port in HTTP headers

	This allows us to use references like
	  "Location" => "http://localhost:{{port}}/whatever
	in test cases.

2014-11-26  Tim Ruehsen <tim.ruehsen@gmx.de>

	* testenv/Makefile.am: Removed Test-auth-both.py from XFAIL_TESTS

2014-11-26  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/recur.c: Fix blacklisting of URLs to download

	Fixes a reported crash and prevents multiple downloads of the
	same file in case the URL is escaped in different ways.

	The crash has been
	Reported-by: Frédéric <vfrederix@gmail.com>

2014-11-26  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/recur.c: Add space after function names

2014-11-26  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/http.c: Select strongest challenge from WWW-Authenticate,
	support multiple challenges per header line.

2014-11-26  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/gnutls.c (ssl_connect_wget): Implement missing code for
	--secure-protocol=TLSv1_1|TLSv1_2, print message before abort()
	for missing protocol implementations.
	* src/openssl.c (ssl_init): Print message before abort() for
	missing protocol implementations.

2014-11-26  Giuseppe Scrivano  <gscrivan@redhat.com>

	* testenv/Makefile.am (TESTS): Add Test-redirect-crash.py.
	* testenv/Test-redirect-crash.py: New File.

2014-11-25  Pär Karlsson <feinorgh@gmail.com>

	* src/Makefile.am: Added missing version.h to wget_SOURCES

2014-11-25  Darshit Shah  <darnir@gmail.com>

	* bootstrap.conf: Add flex as a prerequisite to building Wget from the
	repository sources

2014-11-24  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/wget.h, test.c, main.c: Make program_name and program_argstring const

2014-11-24  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/warc.c: Fix C89 compile errors using ./configure --without-libuuid

2014-11-24  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/warc.c, warc.h, http.c: Add size of buffer to warc_timestamp()

2014-11-24  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/retrc.c: Fix possibly uninitialized variable

2014-11-22  Darshit Shah  <darnir@gmail.com>

	* src/wget.h: Make extern declaration for program_name

2014-11-22  Darshit Shah  <darnir@gmail.com>

	* src/wget.h: Make extern declaration for program_argstring.
	* src/warc.c: Remove extern declaration
	* src/test.c: Make program_argstring a char *, instead of const char *.

2014-11-22  Darshit Shah  <darnir@gmail.com>

	* src/version.h: New file. Add extern declarations for globally shared strings
	* src/Makefile.am: Have version.c import version.h
	* src/main.c: Import version.h and remove old extern declarations
	* src/http.c: Same
	* src/warc.c: Same

2014-11-22  Darshit Shah  <darnir@gmail.com>

	* src/version.h: Add extern for compilation_string
	* src/main: Remove declaration for compilation_String

2014-11-22  Darshit Shah  <darnir@gmail.com>

	* src/utils.c (abort_run_with_timeout): The sig parameter is not used. Mark it
	as such.
	(abort_run_with_timeout): One implementation of this function did not
	specify _Noreturn. Add it.

2014-11-22  Darshit Shah  <darnir@gmail.com>

	* src/retr.h: Declare extern variable numurls
	* src/http.c: Remove extern declaration for numurls
	* src/ftp.c: Same

2014-11-22  Darshit Shah  <darnir@gmail.com>

	* src/hosts.c (address_list_set_faulty): Add a helpful error message for when a
	logical assumption fails

2014-11-22  Darshit Shah  <darnir@gmail.com>

	* src/cookies.c (discard_matching_cookie): Replace defensive assert with a
	logical check and error message

2014-11-22  Darshit Shah  <darnir@gmail.com>

	* build-aux/build_info.pl: Include version.h in the final C file generated
	by the script.

2014-11-21  Tim Ruehsen <tim.ruehsen@gmx.de>

	* testenv/server/http/http_server.py: Fixed typo Blackisted to Blacklisted

2014-11-21  Daniel Stenberg  <daniel@haxx.se>

	* src/iri.c (remote_to_utf8): Fix compiler warning

2014-11-20  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/progress.c: Fix code for undefined USE_NLS_PROGRESS_BAR

	Reported-by: Gisle Vanem

2014-11-20  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/cookies.c, ftp-basic.c, ftp-ls.c, ftp.c, html-url.c,
	http.c, init.c, iri.c, main.c, progress.c, res.c, url.c,
	utils.c, wget.h: Replaced strcasecmp and strncasecmp by
	c_strcasecmp and c_strncasecmp where only ASCII string
	comparison is wanted (instead of locale dependent).

	Fixes possible issues with Wget running in a turkish locale.

2014-11-20  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/Removed form feeds (\014) from *.c and *.h

2014-11-20  Tim Ruehsen <tim.ruehsen@gmx.de>

	* configure.ac: Fix libpsl<0.6.0 detection

2014-11-20  Tim Ruehsen <tim.ruehsen@gmx.de>

	* NEWS: remove form feeds

2014-11-20  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/cookies.c, ftp-basic.c, ftp.c, gnutls.c, host.c,
	html-url.c, http.c, main.c, progress.c, retr.c, warc.c:
	Trivial fixes for C89 compliancy.

2014-11-20  Gisle Vanem  <gvanem@yahoo.no>

	* src/http.c (parse_content_disposition): Fix C89 issue found by MSVC 16

2014-11-20  Gisle Vanem  <gvanem@yahoo.no>

	* src/build_info.c.in: Assume large file for WINDOWS

2014-11-20  Darshit Shah  <darnir@gmail.com>

	* configure.ac: Use pkg-config for libpsl detection
	config status for libpsl is reflected by $with_libpsl

2014-11-20  Darshit Shah  <darnir@gmail.com>

	* configure.ac: Use autoconf macros where available

2014-11-20  Darshit Shah  <darnir@gmail.com>

	* configure.ac: Change option to --enable-assert. Assertions are disabled by
	default.
	* NEWS: Edit to reflect default option.
	* README.checkout: Document --enable-assert for developers

2014-11-20  Darshit Shah  <darnir@gmail.com>

	* configure.ac: Add the -Wextra flag when no CFLAGS are set

2014-11-20  Darshit Shah  <darnir@gmail.com>

	* .gitignore: po/stamp-po should be ignored

2014-11-19  Tim Ruehsen <tim.ruehsen@gmx.de>

	* configure.ac: Check for random()

2014-11-19  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/utils.c (random_float, random_number): Use random() and
	srandom() if available.

	Reported-by: Coverity scanner

2014-11-19  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/openssl.c (ssl_check_certificate): Fix memory leak

2014-11-19  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/gnutls.c (ssl_init): Report load failure of cert files from
	cert directory only with --debug. Fixes #41331.

2014-11-19  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/ftp-basic.c (ftp_epsv): Fix loop check

	Reported-by: Coverity scanner

2014-11-19  Darshit Shah  <darnir@gmail.com>

	* testenv/Test-504.py: Add new test case to show how Wget handles 504 Gateway
	Timeouts
	* testenv/Makefile.am: Add Test-504.py to TESTS

2014-11-19  Darshit Shah  <darnir@gmail.com>

	* src/utils.c (compile_posix_regex): Fix memory leak due to unfreed regex
	pointer

2014-11-19  Darshit Shah  <darnir@gmail.com>

	* src/progress.c (create_image): Do not scroll filename if amount of scrolling
	is less than MIN_SCROLL_TEXT
	* src/retr.c (fd_read_body): Do not print the directory prefix in the progress
	bar

2014-11-19  Darshit Shah  <darnir@gmail.com>

	* src/main.c (format_and_print_line): Fix potential memory leak

2014-11-19  Darshit Shah  <darnir@gmail.com>

	* src/exits.c (get_status_for_err): GATEWAYTIMEOUT is a Server Error and Wget's
	exit code should reflect that
	* src/wget.h: Add GATEWAYTIMEOUT as an error
	* src/http.c (http_loop): Gateway timeout errors should be non-fatal

2014-11-18  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/Fix warnings from clang-analyzer 3.6

	gnutls.c:457:3: warning: Value stored to 'err' is never read
	  err = 0;
	http-ntlm.c:477:5: warning: Value stored to 'size' is never read
	  size = (size_t) snprintf (ntlmbuf, sizeof(ntlmbuf),
	http.c:1479:3: warning: Attempt to free released memory
	  xfree_null (hs->error);

2014-11-17  Tim Ruehsen <tim.ruehsen@gmx.de>

	* testenv/server/http/http_server.py: allow case-insensitive auth-type,
	send BasIc and DIgest to provoke Wget failures with turkish locales

2014-11-17  Tim Ruehsen <tim.ruehsen@gmx.de>

	* bootstrap.conf (gnulib_modules): Add module c-strcase

2014-11-17  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/main.c: code cleanup for redirect_output_signal()

2014-11-17  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/http.c: use c_strncasecmp() in BEGINS_WITH macro
	and in STARTS macro

2014-11-17  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/ftp.h: removed unused variable ftp_last_respline
	* src/init.c, test.c, warc.c: removed 'make check'compiler warnings

2014-11-16  Tom Li  <biergaizi2009@gmail.com>

	* src/progress.c (create_image): Ensure that the last character of the filename
	is scrolled to

2014-11-16  Darshit Shah  <darnir@gmail.com>

	* po/stamp-po: Remove autogenerated file from checked  out sources

2014-11-16  Darshit Shah  <darnir@gmail.com>

	* gnulib: Update submodule
	* bootstrap: Update script from latest gnulib

2014-11-16  Darshit Shah  <darnir@gmail.com>

	* .gitignore: Sort gitignore file based on directories

2014-11-15  Darshit Shah  <darnir@gmail.com>

	* testenv/certs/README: Remove trailing whitespaces

2014-11-15  Darshit Shah  <darnir@gmail.com>

	* src/progress.c (create_image): Fix assertion that checks progress bar length
	Should fix bug #43593

2014-11-15  Darshit Shah  <darnir@gmail.com>
	* configure.ac: Add AC_HEADER_ASSERT. Enables --disable-assert option

2014-11-12  Witchakorn Kamolpornwijit <witchakk@mit.edu> (tiny change)

	* src/html-parse.c (map_html_tags): Fix range check

2014-11-12  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/openssl.c (ssl_init): Fix error handling for CRL loading

2014-11-11  Tim Ruehsen <tim.ruehsen@gmx.de>

	* testenv/recreated the certs and the CRL file, also amended certs/README

2014-11-11  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/openssl.c (ssl_init): Load CRL file given by --crl-file

2014-11-11  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/main.c: Fix missing _Noreturn declaration specifiers

	Reported-by: Gisle Vanem <gvanem@yahoo.no>

2014-11-11  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/http.c (gethttp): Always add Accept-Encoding: identity

	Fixes bug #40819
	Reported-by: Noël Köthe <noel@debian.org>

2014-11-10  Tim Ruehsen <tim.ruehsen@gmx.de>

	* testenv/removed certs/wget-cert.pem
	* testenv/added certs/ca-cert.pem, certs/ca-key.pem, certs/server-cert.pem,
	certs/server-key.pem and certs/server-crl.pem
	* testenv/added certs/README for description how to generate the certs and keys
	* testenv/server/http/http_server.py: amended to work with new certs/ files
	* testenv/added Test--https-crl.py to test --crl-file
	* testenv/Makefile.am: added Test--https-crl.py
	* testenv/Test--https.py: use --ca-certificate of --no-check-certificates

2014-11-10  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/openssl.c: Fix compile-time check for TLSv1.1 and TLSv1.2

	Reported-by: Velemas Vosak <velemas@gmail.com>

2014-11-09  Darshit Shah  <darnir@gmail.com>

	* src/http.c (gethttps): Honour keep-alive when server responds with a 416 Range
	not Satisfiable

2014-11-09  Darshit Shah  <darnir@gmail.com>

	* src/http.c (gethttp): Remove redundant condition evaluation

2014-11-06  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/init.c, main.c, options.h: added new option --crl-file
	 for specifying a CRL (Certificate Revocation List) file.
	* src/gnutls.c: load CRL file given by --crl-file

	Reported-by: Noël Köthe <noel@debian.org>

2014-11-06  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* doc/wget.texi: added description for --crl-file

2014-11-05  Tim Ruehsen <tim.ruehsen@gmx.de>

	* tests/Test-stdouterr.px: fix skip exit code to 77

2014-11-05  Tim Ruehsen <tim.ruehsen@gmx.de>

	* tests/Makefile.am: added $(LIB_CLOCK_GETTIME) to unit test linkage

	Reported-by: kdevel@vogtner.de

2014-11-05  Tim Ruehsen <tim.ruehsen@gmx.de>

	* configure.ac: check for python3
	* Makefile.am: only use python test suite if python3 found

2014-11-05  Giuseppe Scrivano  <gscrivan@redhat.com>

	* contrib/tsocked-wget (TSOCKS_CONF_FILE): Remove empty new-line.

2014-11-04  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/iri.c (do_conversion): fix quote() misuse
	* src/iri.c (remote_to_utf8): fix segfault on do_conversion() error

	Reported-by: Mikael Magnusson <mikachu@gmail.com>

2014-11-04  Darshit Shah  <darnir@gmail.com>

	* README.checkout: Bootstrap script is ./bootstrap not ./bootstrap.sh

2014-11-03  Tim Ruehsen <tim.ruehsen@gmx.de>

	* tests/added new test Test-proxied-https-auth-keepalive.px

2014-11-03  Tim Ruehsen <tim.ruehsen@gmx.de>

	* tests/Test-proxied-https-auth.px: add valgrind support,
	sync parent / child (client / server)

2014-11-03  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/log.c: turn on automatic format check for log_vprintf_internal()

2014-11-03  Pär Karlsson <feinorgh@gmail.com>
	* tests/WgetFeature.pm: Fixed finding of WgetFeature.cfg when using separate
	build dirs.
	* tests/WgetFeature.pm: Fixed warning from BLOCK eval, made it indo EXPR eval

2014-11-03  Jakub Čajka  <jcajka@redhat.com>

	* src/iri.c (remote_to_utf8): Fixed assumption that char is signed. Fixes
	fellowing test case failures idn-cmd-utf8, idn-robots-utf8, if char is
	unsigned.

2014-11-01  Mike Frysinger <vapier@gentoo.org>

	* configure.ac: Use pkg-config to check for zlib presence and
	fallback to the previous code if that doesn't work.

	* configure.ac: Use pkg-config to check for libuuid presence and
	fallback to the previous code if that doesn't work.

	* configure.ac: Use pkg-config to check for pcre presence and
	fallback to the previous code if that doesn't work.

	* configure.ac: Use pkg-config to check for openssl presence and
	fallback to the previous code if that doesn't work.

	* configure.ac: Use pkg-config to check for gnutls presence and
	fallback to the previous code if that doesn't work.

2014-11-01  Giuseppe Scrivano  <gscrivan@redhat.com>

	* src/http.c (gethttp): Do not check for "Connection: close" header
	only when the Content-Length is specified.

2014-11-01  Darshit Shah  <darnir@gmail.com>

	* src/progress.c (create_image): Extra padding for size_grouped_diff has already
	been added. Do not add that again.
	(create_image): Assert that the progress bar being drawn is lesser than the
	size of the screen.

2014-11-01  Darshit Shah  <darnir@gmail.com>

	* configure.ac: Fix check for libpsl

2014-10-31  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/openssl.c: make _get_rfc2253_formatted() static

2014-10-31  Pär Karlsson <feinorgh@gmail.com>
	* tests/WgetTests.pm: Proper conditional operators, tidied up code, idiomatic
	improvements as per modern Perl best practices.
	* tests/WgetFeature.pm: Tidied up code, idiomatic improvements for readability
	* tests/FTPServer.pm: Tidied up code (perltidy -gnu)
	* tests/FTPTest.pm: Likewise
	* tests/HTTPServer.pm: Likewise
	* tests/HTTPTest.pm: Likewise

2014-10-30  Mike Frysinger <vapier@gentoo.org>

	* tests/WgetFeature.pm: fix skip exit code to 77

2014-10-30  Mike Frysinger <vapier@gentoo.org>

	* src/openssl.c: fix implicit decl warning

2014-10-29  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/openssl.c: print cert subject and issuer RFC2253 compliant
	* src/openssl.c (ssl_check_certificate): removed memory leak

2014-10-29  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/http.c (gethttp): use CLOSE_INVALIDATE instead of fd_close

2014-10-29  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/http.c (gethttp): fix memory leak

2014-10-29  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/http.c (CLOSE_FINISH): always set fd invalid after close

2014-10-29  Peter Meiser <meiser@gmx-topmail.de> (tiny change)

	* src/openssl.c (ssl_init) [! OPENSSL_NO_SSL3]: Add guard for OpenSSL
	without SSLv3.

2014-10-28  Tim Ruehsen <tim.ruehsen@gmx.de>

	* tests/Test-proxied-https-auth.px: synchronize client and server

2014-10-28  Tim Ruehsen <tim.ruehsen@gmx.de>

	* configure.ac: check for strlcpy()

2014-10-28  Tim Ruehsen <tim.ruehsen@gmx.de>

	* configure.ac: add --enable-valgrind-tests

2014-10-28  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/utils.c: added strlcpy(), concat_strings() rewritten
	* src/utils.h: added strlcpy()

2014-10-28  Tim Ruehsen  <tim.ruehsen@gmx.de>

	* src/ftp.c (ftp_loop_internal): Fix memory leak
	* src/http.c (gethttp): Fix two memory leaks
	* src/init.c (cleanup): Fix compile errors and warnings
	* src/init.c (cleanup): Free more opt variables
	* src/main.c (main): Fix two memory leaks
	* src/retr.c (retrieve_url): Fix two memory leaks
	* src/retr.c (retrieve_url): Add iri to call to url_parse()
	* src/url.c (url_parse): Fix memory leak

2014-10-28  Giuseppe Scrivano  <gscrivan@redhat.com>

	* tests/Makefile.am: Replace $FOO with @VAR@.

2014-10-28  Giuseppe Scrivano  <gscrivan@redhat.com>

	* src/Makefile.am: Replace $FOO with @VAR@.

2014-10-28  Giuseppe Scrivano  <gscrivan@redhat.com>

	* doc/Makefile.am: Replace $FOO with @VAR@.

2014-10-28  Giuseppe Scrivano  <gscrivan@redhat.com>

	* cfg.mk (local-checks-to-skip): Add sc_makefile_at_at_check.

	* Makefile.am: Replace $FOO with @VAR@.

2014-10-25  Tim Ruehsen <tim.ruehsen@gmx.de>

	* tests/WgetTests.pm (run): generate valgrind command line if requested
	* tests/Makefile.am: set/export VALGRIND_TESTS

2014-10-25  Tim Ruehsen <tim.ruehsen@gmx.de>

	* testenv/test/base_test.py (gen_cmd_line): generate valgrind command line if requested
	* testenv/README: amend description of VALGRIND_TESTS
	* testenv/Makefile.am: set/export VALGRIND_TESTS

2014-10-22  Ángel González <keisial@gmail.com>

